from base import *
class Search(object):

    def __init__(self, searchMode=STRING_SEARCH_MODE, searchCommand="", earliestTime=None, latestTime=None, id=None, base=None, app=None):
        self.searchMode = searchMode
        self.searchCommand = searchCommand
        self.earliestTime = earliestTime
        self.latestTime = latestTime
        self.id = id
        self.baseSearchId = base
        self.app = app
        self.statusBuckets = 0
        if self.searchMode == POST_SEARCH_MODE and self.baseSearchId == None:
            self.baseSearchId = DEFAULT_SEARCH_ID

    def normalizedSearchCommand(self):
        return self.searchCommand.strip()


def createSearchFromSearchXml(searchNode):
    """
    Parses a search from search, dashboard, panel element xml nodes
    @param searchNode: Lxml representing a form or dashboard element
    @param id: and optional id to force id to
    @return:
    """

    opt = dict()
    base = searchNode.attrib.get('base')
    if searchNode.find('query') is not None:
        opt['searchMode'] = TEMPLATE_SEARCH_MODE
        opt['searchCommand'] = (
            searchNode.findtext('query')).replace("\n", " ")
    elif searchNode.get('ref') is not None:
        opt['searchMode'] = SAVED_SEARCH_MODE
        opt['searchCommand'] = (
            searchNode.get('ref')).replace("\n", " ")
        if searchNode.get('app') is not None:
            opt['app'] = searchNode.get('app')
    elif not base:
        return False
    for nodePair in [('earliest', 'earliestTime'), ('latest', 'latestTime')]:
        nodeVal = searchNode.findtext(nodePair[0])
        if nodeVal:
            opt[nodePair[1]] = nodeVal
    id = searchNode.attrib.get('id')
    if id:
        opt['id'] = id
    if base:
        opt['base'] = base
        opt['searchMode'] = POST_SEARCH_MODE
    return Search(**opt)

