var jsdom = require('jsdom'),
    __script_basepath = "file:///" + __dirname + "/httpdocs/static/js/",
    __font_basepath = "file:///" + __dirname + "/";

PDFDocument = require('pdfkit');
fs = require('fs');

function createChartingWindow(scriptBasepath, callback) {
    jsdom.env({
        html: "<html><head></head><body><div id='container'></div></body></html>",
        src: [
            fs.readFileSync(scriptBasepath + "contrib/jquery-2.1.0.min.js").toString(),

            // Give '_' variable back to i18n.
            // This block must be placed after backbone, but before any i18n dependencies.
            'window.underscore = _.noConflict();',

            fs.readFileSync(scriptBasepath + "contrib/json2.js").toString(),
            fs.readFileSync(scriptBasepath + "i18n.js").toString(),

            // Prepare i18n since we didn't load it from splunk web: hard-code locale data for en_US
            'window._i18n_locale={"date_formats": {"medium": {"pattern": "MMM d, yyyy", "format": "%(MMM)s %(d)s, %(yyyy)s"}, "full": {"pattern": "EEEE, MMMM d, yyyy", "format": "%(EEEE)s, %(MMMM)s %(d)s, %(yyyy)s"}, "long": {"pattern": "MMMM d, yyyy", "format": "%(MMMM)s %(d)s, %(yyyy)s"}, "short": {"pattern": "M/d/yy", "format": "%(M)s/%(d)s/%(yy)s"}}, "scientific_format": "#E0", "exp_symbol": "E", "eras": {"wide": {"0": "Before Christ", "1": "Anno Domini"}, "abbreviated": {"0": "BC", "1": "AD"}, "narrow": {"0": "B", "1": "A"}}, "decimal_symbol": ".", "months": {"stand-alone": {"wide": {"1": "January", "2": "February", "3": "March", "4": "April", "5": "May", "6": "June", "7": "July", "8": "August", "9": "September", "10": "October", "11": "November", "12": "December"}, "abbreviated": {"1": "January", "2": "February", "3": "March", "4": "April", "5": "May", "6": "June", "7": "July", "8": "August", "9": "September", "10": "October", "11": "November", "12": "December"}, "narrow": {"1": "J", "2": "F", "3": "M", "4": "A", "5": "M", "6": "J", "7": "J", "8": "A", "9": "S", "10": "O", "11": "N", "12": "D"}}, "format": {"wide": {"1": "January", "2": "February", "3": "March", "4": "April", "5": "May", "6": "June", "7": "July", "8": "August", "9": "September", "10": "October", "11": "November", "12": "December"}, "abbreviated": {"1": "Jan", "2": "Feb", "3": "Mar", "4": "Apr", "5": "May", "6": "Jun", "7": "Jul", "8": "Aug", "9": "Sep", "10": "Oct", "11": "Nov", "12": "Dec"}, "narrow": {"1": "J", "2": "F", "3": "M", "4": "A", "5": "M", "6": "J", "7": "J", "8": "A", "9": "S", "10": "O", "11": "N", "12": "D"}}}, "group_symbol": ",", "days": {"stand-alone": {"wide": {"0": "Monday", "1": "Tuesday", "2": "Wednesday", "3": "Thursday", "4": "Friday", "5": "Saturday", "6": "Sunday"}, "abbreviated": {"0": "Monday", "1": "Tuesday", "2": "Wednesday", "3": "Thursday", "4": "Friday", "5": "Saturday", "6": "Sunday"}, "narrow": {"0": "M", "1": "T", "2": "W", "3": "T", "4": "F", "5": "S", "6": "S"}}, "format": {"wide": {"0": "Monday", "1": "Tuesday", "2": "Wednesday", "3": "Thursday", "4": "Friday", "5": "Saturday", "6": "Sunday"}, "abbreviated": {"0": "Mon", "1": "Tue", "2": "Wed", "3": "Thu", "4": "Fri", "5": "Sat", "6": "Sun"}, "narrow": {"0": "M", "1": "T", "2": "W", "3": "T", "4": "F", "5": "S", "6": "S"}}}, "datetime_formats": {"null": "{1} {0}"}, "percent_format": "#,##0%", "min_week_days": 1, "first_week_day": 6, "periods": {"am": "AM", "pm": "PM"}, "minus_sign": "-", "time_formats": {"medium": {"pattern": "h:mm:ss a", "format": "%(h)s:%(mm)s:%(ss)s %(a)s"}, "full": {"pattern": "h:mm:ss a v", "format": "%(h)s:%(mm)s:%(ss)s %(a)s %(v)s"}, "long": {"pattern": "h:mm:ss a z", "format": "%(h)s:%(mm)s:%(ss)s %(a)s %(z)s"}, "short": {"pattern": "h:mm a", "format": "%(h)s:%(mm)s %(a)s"}}, "quarters": {"stand-alone": {"wide": {"1": "1st quarter", "2": "2nd quarter", "3": "3rd quarter", "4": "4th quarter"}, "abbreviated": {"1": "1st quarter", "2": "2nd quarter", "3": "3rd quarter", "4": "4th quarter"}, "narrow": {"1": "1", "2": "2", "3": "3", "4": "4"}}, "format": {"wide": {"1": "1st quarter", "2": "2nd quarter", "3": "3rd quarter", "4": "4th quarter"}, "abbreviated": {"1": "Q1", "2": "Q2", "3": "Q3", "4": "Q4"}, "narrow": {"1": "1", "2": "2", "3": "3", "4": "4"}}}, "plus_sign": "+", "number_format": "#,##0.###", "locale_name": "en_US"};',
            'window.locale_name = function() { return "en_US"; };',
            'window.locale_uses_day_before_month = function() { return false; };',

            fs.readFileSync(scriptBasepath + "splunk.js").toString(),
            fs.readFileSync(scriptBasepath + "util.js").toString(),
            fs.readFileSync(scriptBasepath + "logger.js").toString(),

            // Do the bare minimum to convince HighCharts that the 'DOM window' supports SVG,
            // we will add more sophisticated handling later in the 'done' callback
            'window.document.createElementNS = function() { return { createSVGRect: true }; };',

            fs.readFileSync(scriptBasepath + "build/jscharting.js").toString()
        ],
        done: function(err, window) {
            if(err) {
                callback(err, null);
                return;
            }

            // Set up a good mock implementation for creating elements and later getting their bounding box
            window.document.createElementNS = function(ns, tagName) {
                var elem = window.document.createElement(tagName);
                elem.getBBox = function() {
                    if (this.textContent) {
                        var doc = new PDFDocument(),
                            fontSize = parseInt(window.getComputedStyle(elem, null).getPropertyValue("font-size"), 10),
                            font = doc.font('Helvetica', fontSize);

                        if(!fontSize) {
                            window.console.log('ERROR: In getBBox, element has no font size');
                            // To track down the log statement above, un-comment this throw and comment out the try-catch around getBBox in Highcarts
                            // throw new Error('In getBBox, element has no font size');
                        }

                        return ({
                            x: elem.offsetLeft,
                            y: elem.offsetTop,
                            // need to compute max width per line
                            width: font.widthOfString(this.textContent),
                            // need to compute currentLineHeight()+(numLines-1)*currentLineHeight(true)
                            height: font.currentLineHeight()
                        });
                    }
                    return ({
                        x: elem.offsetLeft || 0,
                        y: elem.offsetTop || 0,
                        width: elem.offsetWidth || 0,
                        height: elem.offsetHeight || 0
                    });

                };
                // the element has to know its namespace or HighCharts will choke calculating its bounding box
                elem.namespaceURI = ns;
                elem.createSVGRect = function() {};
                return elem;
            };

            // Set up mock console logging
            var mockConsole = {
                log: function() {
                    mockConsole.addMessage.apply(mockConsole, arguments);
                },
                warn: function() {
                    mockConsole.addMessage.apply(mockConsole, arguments);
                },
                debug: function() {
                    mockConsole.addMessage.apply(mockConsole, arguments);
                },
                error: function() {
                    mockConsole.addMessage.apply(mockConsole, arguments);
                },

                messages: [],
                addMessage: function(args) {
                    var i, strSegments = [];
                    for(i = 0; i < arguments.length; i++) {
                        strSegments.push(arguments[i]);
                    }
                    mockConsole.messages.push('JSDOM CONSOLE: ' + strSegments.join(' '));
                }
            };
            window.console = mockConsole;

            callback(null, window);
        }
    });
}

function getSVG(data, scriptBasepath, callback) {
    if(scriptBasepath === null || scriptBasepath === undefined) {
        scriptBasepath = __script_basepath;
    }

    createChartingWindow(scriptBasepath, function(err, window) {
        if(err) {
            callback(err, null);
        }
        else {
            var $ = window.$;
            var Splunk = window.Splunk;
            var $container = $('#container');

            var getConsoleMessages = function() {
                if(window.console.messages && window.console.messages.length > 0) {
                    return window.console.messages;
                }
                return null;
            };

            var chartData = Splunk.JSCharting.extractChartReadyData(data.series);
            // Unfortunately, a little bit of duplication of what happens in util/jscharting_utils.
            // If the data contains '_tc' - and indication of the 'top' or 'rare' commands - suppress the 'percent' field
            // (SPL-79265)
            if(chartData.hasField('_tc')) {
                data.props.fieldHideList = ['percent'];
            }
            $container.width(parseInt(data.width, 10)).height(parseInt(data.height, 10));
            try {
                var chart = Splunk.JSCharting.createChart($container[0], data.props);

                chart.prepareAndDraw(chartData, data.props, function() {
                    var svg = chart.getSVG();
//					var $svg = $('.highcharts-container').find('svg');
//                    $svg.siblings().remove();
//                    $svg.find('.highcharts-tracker').remove();
//                    var svg = $svg.parent().html();
                    // un-comment this next line to pretty-print the SVG to python.log
                    //throw new Error(svg.replace(/>/g, ">\n"));

                    callback({ consoleMessages: getConsoleMessages() }, svg);
                });
            }
            catch(err) {
                console.log('exception in js_charting::getSVG' + JSON.stringify(err));
                var fullError = {
                    consoleMessages: getConsoleMessages(),
                    message: err
                };
                callback(fullError, null);
            }
        }
    });
}

exports.getSVG = getSVG;
