define(
    [
        'underscore',   
        'models/services/configs/EventRenderer',
        'collections/SplunkDsBase'
    ],
    function(_, EventRendererModel, SplunkDsBaseCollection) {
        return SplunkDsBaseCollection.extend({
            url: "configs/conf-event_renderers",
            model: EventRendererModel,
            initialize: function() {
                SplunkDsBaseCollection.prototype.initialize.apply(this, arguments);
            },
            getRenderer: function(eventtypes) {
                var renderer;
                if (eventtypes) {
                    for(var i=0; i<eventtypes.length; i++) {
                        for(var j=0; j<this.models.length; j++) {
                            var model = this.models[j];
                            
                            if(model.getEventtype() === eventtypes[i]) {
                                if(!renderer || model.getPriority() > renderer.getPriority()) {
                                    renderer = model;
                                }
                                break; //we request with sorting by priority, so can bail if we find a match
                            }
                        }                    
                    }
                }
                return renderer;
            }
        });
    }
);
