define(
    [
        'models/search/Job'
    ],
    function(SearchJob) {
        return SearchJob.extend({
            initialize: function() {
                SearchJob.prototype.initialize.apply(this, arguments);
            },
            
            startJob: function(parentJob, application, sensitivity) {
                if (!parentJob.isPatternable()) {
                    throw new Error("You should never try this at home.");
                }
                
                this.entry.content.custom.set({
                    parentEventCount: parentJob.entry.content.get('eventCount')
                });
                
                return this.save({},{
                    data: {
                        search: '| loadjob ' + parentJob.id + ' events=true require_finished=false | cluster t=' + sensitivity + ' labelonly=true labelfield=_patterns match=termset | findkeywords labelfield=_patterns dedup=true',
                        earliest_time: parentJob.getDispatchEarliestTimeOrAllTime(),
                        latest_time: parentJob.getDispatchLatestTimeOrAllTime(),
                        preview: false,
                        app: application.get('app'),
                        owner: application.get('owner'),
                        ui_dispatch_app: application.get('app')
                    }
                });
            },
            
            getParentEventCount: function() {
                return parseInt(this.entry.content.custom.get('parentEventCount'), 10);
            }
        });
    }
);