define(
    [
        'jquery',
        'underscore',
        'models/Base',
        'backbone',
        'splunk.util'
    ],
    function($, _, BaseModel, Backbone, splunkUtil) {
        var SHelper = BaseModel.extend({
            initialize: function() {
                BaseModel.prototype.initialize.apply(this, arguments);
            },
            url: splunkUtil.make_url('api/shelper'),
            sync: function(method, model, options) {
                if (method!=='read') {
                    throw new Error('invalid method: ' + method);
                }
                options = options || {};
                var defaults = {
                        data: {},
                        dataType: 'text'
                    },
                    url = _.isFunction(model.url) ? model.url() : model.url || model.id;
                defaults.url = url;
                $.extend(true, defaults, options);
                return Backbone.sync.call(this, method, model, defaults);
            },
            parse: function(response) {
                return {raw: response};
            }
        });
        return SHelper;
    }
);