define(
    [
        'jquery',
        'underscore',
        'models/StaticIdSplunkDBase'
    ],
    function($, _, BaseModel){
        return BaseModel.extend({
            url: 'cluster/config',
            initialize: function() {
                BaseModel.prototype.initialize.apply(this, arguments);
            },
            defaults: function() {
               var baseDefaults = BaseModel.prototype.defaults.apply(this, arguments);
                
               return _.extend(
                   {},
                   baseDefaults,
                   {
                       'ui.host': '',
                       'ui.port': '',
                       'ui.secret': ''
                   }
               );             
            },
            transposeToRest: function() {
                this.entry.content.set('master_uri', this.get('ui.host') +':'+ this.get('ui.port'));
                this.entry.content.set('secret', this.get('ui.secret'));
                this.entry.content.set('replication_factor', this.get('ui.replication_factor'));
                this.entry.content.set('search_factor', this.get('ui.search_factor'));
                this.entry.content.set('replication_port', this.get('ui.replication_port'));
                this.entry.content.set('mode', this.get('ui.mode'));
            },
            transposeFromRest: function() {
                var indexOfPort,port,host;

                var masteruri = this.entry.content.get('master_uri');
                if (typeof masteruri === 'string' && masteruri.lastIndexOf(':') > 0){
                    indexOfPort = masteruri.lastIndexOf(':');
                    port = masteruri.substring(indexOfPort+1) || '';
                    host = masteruri.substring(0, indexOfPort);
                } else {
                    host = masteruri;
                }
                host = (host == 'master' ? '': host);

                var attr = {
                    'ui.host': host,
                    'ui.port': port,
                    'ui.secret': this.entry.content.get('secret'),
                    'ui.replication_factor': this.entry.content.get('replication_factor'),
                    'ui.search_factor': this.entry.content.get('search_factor'),
                    'ui.replication_port': this.entry.content.get('replication_port')
                };

                this.set(attr);
            }
        },
        {
            id: 'cluster/config/config'
        });
    }
);
