define(
    [
        'underscore',
        'models/services/data/inputs/BaseInputModel'
    ],
    function (
        _,
        BaseInputModel
        ) {
        return BaseInputModel.extend({
            url: "data/inputs/script",
            validation: {
                'ui.name': [
                    {
                        required: true,
                        msg: _("Command field is required.").t()
                    },
                    {
                        fn: 'checkInputExists'
                    }
                ],
                'ui.sourcetype': [
                    {
                        required: function() {
                            return (this.wizard.get('currentStep') === 'inputsettings') && (!this.get('ui.sourcetype'));
                        },
                        msg: _("Sourcetype value is required.").t()
                    }
                ],
                'ui.interval': [
                    {
                        pattern: 'number',
                        msg: _('Enter a number for the Interval field.').t(),
                        required: true
                    }
                ],
                'ui.host': [
                    {
                        required: function() {
                            return this.wizard.get('currentStep') === 'inputsettings';
                        },
                        msg: _("Host value is required.").t()
                    }
                ]
            }
        });
    }
);