define([
            'underscore',
            'models/SplunkDRaw',
            'models/shared/fetchdata/ResultsFetchData',
            'util/splunkd_utils'
        ],
        function(
            _,
            SplunkDRaw,
            ResultsFetchData,
            splunkdUtils
        ) {

    var DATA_FIELD_REGEX = /^[^_]|^_time$|^_raw$/;

    return SplunkDRaw.extend({

        initialize: function(attributes, options) {
            options = options || {};
            if (_(options.fetchData).isUndefined())
                options.fetchData = new ResultsFetchData({ output_mode: 'json_rows' });
            SplunkDRaw.prototype.initialize.call(this, attributes, options);
        },

        parse: function(response) {
            return _(response).pick('fields', 'rows', 'post_process_count');
        },

        getDataFields: function() {
            var fields = this.get('fields') || [];
            return _.filter(fields, function(field) {
                return this.isDataField(field);
            }.bind(this));

        },

        isDataField: function(fieldName) {
            return DATA_FIELD_REGEX.test(fieldName);
        }

    });

});