//splunk cmd node $SPLUNK_HOME/lib/node_modules/requirejs/bin/r.js -o jscharting.js
({
    baseUrl: '../',
    preserveLicenseComments: false,
    name: 'contrib/almond',
    stubModules: [],
    optimize: 'uglify2',
    uglify2: {
        mangle: {
            except: ['_']
        }
    },
    include: ['js_charting/js_charting', 'underscore-prepare'],
    wrap: {
        start: ' ',
        end: 'require("underscore-prepare"); require("splunk").JSCharting = require("js_charting/js_charting");'
    },
    out: '../build/jscharting.js',
    paths: {

        // jQuery and contrib plugins
        'jquery': 'stubs/jquery',

        // other contrib libraries
        'underscore': 'contrib/underscore',
        'highcharts': 'contrib/highcharts-3.0.10/highcharts',
        'highcharts.runtime_patches': 'contrib/highcharts-3.0.10/runtime_patches',
        'moment': 'contrib/moment',

        // Splunk legacy
        'splunk': 'stubs/splunk',
        'splunk.util': 'stubs/splunk.util',
        'splunk.i18n': 'stubs/i18n',
        'splunk.config': 'stubs/splunk.config',
        'splunk.logger': 'stubs/splunk.logger',
        'strftime': 'stubs/strftime'

    },
    // Because underscore `define`s itself as a named module, there is no good way to add an on-load handler for it.
    // Instead define a preparation module which will be included in this bundle and executed before bootstrapping the
    // charting library code.
    // TODO [sff]: this is duplication of what's in require/backbone.js
    rawText: {
        'underscore-prepare': '\
            define(["underscore", "splunk.i18n"], function(_, i18n) {\
                _.mixin({\
                    t: function(string) {\
                        return i18n._(string);\
                    }\
                });\
                _.noConflict();\
            });\
        '
    },
    shim: {
        highcharts: {
            deps: ['jquery', 'highcharts.runtime_patches'],
            exports: 'Highcharts',
            init: function($, runtimePatches) {
                runtimePatches.applyPatches(this.Highcharts);
                return this.Highcharts;
            }
        }
    }
})
