({
    preserveLicenseComments: false,
    optimize: 'uglify2',
    uglify2: {
        mangle: {
            except: ['_']
        }
    },
    mainConfigFile: './shared.js',
    appDir: '../',
    baseUrl: '.',
    stubModules: ['contrib/text'],
    skipDirOptimize: true,
    optimizeCss: 'none',
    wrapShim: true,

    modules: [

        {
            name: 'build/bundles/require',
            create: true,
            include: [
                'contrib/require',
                'profiles/shared'
            ],
            override: {
                wrap: {
                    startFile: [],
                    endFile: ['shared.js', 'bundles.js']
                }
            }
        },
        // WARNING: the contents of these bundles are duplicated in the bundles config in profiles/bundles.js.
        // Any changes made here should also be made there.
        {
            name: 'build/bundles/common',
            create: true,
            include: [
                'routers/Base',
                'backbone',
                'collections/services/AppLocals',
                'collections/services/UITours',
                'models/config',
                'models/services/AppLocal',
                'models/services/UITour',
                'models/services/authentication/User',
                'models/services/data/UserPref',
                'models/services/data/ui/Nav',
                'models/services/server/ServerInfo',
                'models/shared/Application',
                'splunk',
                'splunk.error',
                'splunk.util',
                'underscore',
                'uri/route',
                'util/ajax_logging',
                'util/ajax_no_cache',
                'util/console',
                'util/csrf_protection',
                'util/splunkd_utils',
                'views/shared/Page',
                'collections/SplunkDsBase',
                'jquery',
                'util/general_utils',
                'models/Base',
                'splunk.config',
                'models/SplunkDBase',
                'models/StaticIdSplunkDBase',
                'splunk.logger',
                'util/console_dev',
                'views/Base',
                'views/shared/appbar/Master',
                'views/shared/footer/Master',
                'views/shared/litebar/Master',
                'views/shared/splunkbar/Master',
                'views/shared/tourbar/TourBar',
                'collections/Base',
                'models/shared/fetchdata/EAIFetchData',
                'util/math_utils',
                'mixins/modelcollection',
                'validation/ValidationMixin',
                'models/ACLReadOnly',
                'models/SplunkDWhiteList',
                'models/services/ACL',
                'mixins/viewlogging',
                'collections/services/saved/Searches',
                'collections/services/data/ui/Views',
                'helpers/AppNav',
                'util/color_utils',
                'views/shared/appbar/AppLabel',
                'views/shared/appbar/AppNav',
                'views/shared/AboutDialog',
                'collections/services/Messages',
                'collections/services/authentication/CurrentContexts',
                'helpers/Session',
                'views/shared/litebar/HelpMenu',
                'views/shared/litebar/SideNav',
                'views/shared/splunkbar/messages/LiteMessages',
                'views/shared/splunkbar/messages/NoConnectionOverlay',
                'collections/services/data/ui/Managers',
                'collections/shared/splunkbar/SystemMenuSections',
                'models/services/configs/Web',
                'views/shared/delegates/Popdown',
                'views/shared/splunkbar/ActivityMenu',
                'views/shared/splunkbar/AppMenu',
                'views/shared/splunkbar/HelpMenu',
                'views/shared/splunkbar/SystemMenu',
                'views/shared/splunkbar/UserMenu',
                'views/shared/splunkbar/find/Master',
                'views/shared/splunkbar/messages/Master',
                'util/Ticker',
                'backbone_validation',
                'models/services/saved/Search',
                'models/services/data/ui/View',
                'views/shared/appbar/NavItem',
                'views/shared/Modal',
                'models/services/Message',
                'models/services/authentication/CurrentContext',
                'lowpro',
                'splunk.session',
                'views/shared/delegates/Accordion',
                'views/shared/litebar/Activity',
                'views/shared/litebar/SystemSection',
                'views/shared/WaitSpinner',
                'models/services/data/ui/Manager',
                'models/shared/splunkbar/SystemMenuSection',
                'views/shared/delegates/Base',
                'views/shared/delegates/PopdownDialog',
                'views/shared/controls/TextControl',
                'views/shared/whatsnewdialog/Master',
                'views/shared/splunkbar/SystemMenuSection',
                'collections/search/Reports',
                'collections/services/datamodel/DataModels',
                'collections/shared/Dashboards',
                'views/shared/splunkbar/find/FindProgress',
                'views/shared/splunkbar/find/results/Master',
                'views/shared/tablecaption/Input',
                'views/shared/delegates/StopScrollPropagation',
                'views/shared/splunkbar/messages/LegacyMessage',
                'views/shared/splunkbar/messages/Message',
                'splunk.widget.slidenav',
                'bootstrap.modal',
                'bootstrap.transition',
                'util/keyboard',
                'util/string_utils',
                'views/shared/controls/Control',
                'models/search/Report',
                'models/services/datamodel/DataModel',
                'models/search/Dashboard',
                'views/shared/PopTart',
                'views/shared/splunkbar/find/ProgressSpinner',
                'views/shared/splunkbar/find/results/AlertResults',
                'views/shared/splunkbar/find/results/DashboardResults',
                'views/shared/splunkbar/find/results/DataModelResults',
                'views/shared/splunkbar/find/results/ReportResults',
                'util/time',
                'jquery.ui.core',
                'jquery.ui.position',
                'jquery.ui.widget',
                'collections/search/Jobs',
                'models/services/data/ui/Viewstate',
                'splunk.i18n',
                'collections/services/datamodel/private/ObjectHierarchy',
                'models/services/datamodel/private/Acceleration',
                'models/services/datamodel/private/DataModelWhiteList',
                'util/xml',
                'util/moment',
                'collections/services/search/Jobs',
                'models/search/Job',
                'models/services/datamodel/private/Object',
                'moment',
                'models/services/search/Job',
                'collections/services/datamodel/private/Calculations',
                'collections/services/datamodel/private/FieldSampleValues',
                'collections/services/datamodel/private/Fields',
                'models/services/datamodel/private/Field',
                'util/pivot/config_form_utils',
                'models/services/search/jobs/Control',
                'models/services/datamodel/private/Calculation',
                'models/services/datamodel/private/EvalCalculation',
                'models/services/datamodel/private/GeoIPCalculation',
                'models/services/datamodel/private/LookupCalculation',
                'models/services/datamodel/private/RexCalculation',
                'util/model_utils',
                'collections/services/datamodel/private/LookupOutputFields',
                'collections/services/datamodel/private/LookupInputs',
                'models/services/datamodel/private/RexOutputFields',
                'models/services/datamodel/private/LookupOutputField',
                'models/services/datamodel/private/LookupInput',
                'models/services/datamodel/private/RexOutputField'
            ]
        },
        {
            name: 'build/bundles/js_charting',
            create: true,
            include: ['js_charting/js_charting'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/bundles/jg_common',
            create: true,
            include: ['jg_global', 'jgatt'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/bundles/mapping',
            create: true,
            include: ['views/shared/Map'],
            exclude: ['build/bundles/common', 'build/bundles/jg_common']
        },
        {
            name: 'build/bundles/canvas_timeline',
            create: true,
            include: ['views/shared/CanvasTimeline'],
            exclude: ['build/bundles/common', 'build/bundles/jg_common']
        },
        {
            name: 'build/bundles/events_viewer',
            create: true,
            include: ['views/shared/eventsviewer/Master', 'views/shared/eventsviewerdrilldown/Master'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/bundles/results_table',
            create: true,
            include: ['views/shared/results_table/ResultsTableMaster', 'views/shared/ResultsTableDrilldown'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/bundles/datapreview_source_selector_dialog',
            create: true,
            include: ['views/datapreview/SourceSelectorDialog'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/adddatapage',
            create: true,
            include: ['pages/adddata'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/alertpage',
            create: true,
            include: ['pages/alert'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/alertspage',
            create: true,
            include: ['pages/alerts'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/authentication_userspage',
            create: true,
            include: ['pages/authentication_users'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/clusteringpage',
            create: true,
            include: ['pages/clustering'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/clustering_bucket_detailspage',
            create: true,
            include: ['pages/clustering_bucket_details'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/clustering_pushpage',
            create: true,
            include: ['pages/clustering_push'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/dashboardspage',
            create: true,
            include: ['pages/dashboards'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/data_model_editorpage',
            create: true,
            include: ['pages/data_model_editor'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/data_model_managerpage',
            create: true,
            include: ['pages/data_model_manager'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/datapreviewpage',
            create: true,
            include: ['pages/datapreview'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/deploymentserverpage',
            create: true,
            include: ['pages/deploymentserver'
            ],
            exclude: ['build/bundles/common'
            ]
        },
        {
            name: 'build/deploymentserver_add_appspage',
            create: true,
            include: ['pages/deploymentserver_add_apps'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/deploymentserver_add_clientspage',
            create: true,
            include: ['pages/deploymentserver_add_clients'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/deploymentserver_apps_detailpage',
            create: true,
            include: ['pages/deploymentserver_apps_detail'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/deploymentserver_edit_apppage',
            create: true,
            include: ['pages/deploymentserver_edit_app'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/deploymentservereditpage',
            create: true,
            include: ['pages/deploymentserveredit'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/embedpage',
            create: true,
            include: ['pages/embed'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/field_extractorpage',
            create: true,
            include: ['pages/field_extractor'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/homepage',
            create: true,
            include: ['pages/home'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/homeclassicpage',
            create: true,
            include: ['pages/homeclassic'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/managementconsole_configurepage',
            create: true,
            include: ['pages/managementconsole_configure'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/managementconsole_instancespage',
            create: true,
            include: ['pages/managementconsole_instances'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/pivotpage',
            create: true,
            include: ['pages/pivot'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/reportpage',
            create: true,
            include: ['pages/report'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/reportspage',
            create: true,
            include: ['pages/reports'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/searchpage',
            create: true,
            include: ['pages/search'],
            exclude: ['build/bundles/common']
        },
        {
            name: 'build/showhtmlpage',
            create: true,
            include: ['pages/showhtml'],
            exclude: ['build/bundles/common']
        }
    ]
})
