define(
    [
        'jquery',
        'underscore',
        'routers/Base',
        'backbone',
        'views/deploymentserver/editServerclass/addClients/AddClients',
        'models/services/deploymentserver/DeploymentServerClass',
        'collections/services/deploymentserver/ClientMachineTypes',
        'models/classicurl',
        'collections/services/deploymentserver/ClientsPreview',
        'collections/services/deploymentserver/DeploymentServerClients',
        'bootstrap.tab'
    ],
    function(
        $,
        _,
        BaseRouter,
        Backbone, 
        AddClientsView,
        DeploymentServerClassModel,
        MachineTypesCollection, 
        classicurlModel,
        DeploymentServerClientsCollection,
        AllClientsCollection,
        undefined
    ){
        return BaseRouter.extend({
            initialize: function() {
                BaseRouter.prototype.initialize.apply(this, arguments);
                this.setPageTitle(_('Edit Clients').t());
                this.enableAppBar = false;
           },
            page: function(locale, app, page) {
                BaseRouter.prototype.page.apply(this, arguments);

                //collections
                //var clientsCollection = new DeploymentServerClientsCollection();
                var selectedClientsCollection = new DeploymentServerClientsCollection();
                
                var unselectedClientsCollection = new DeploymentServerClientsCollection();
                var allClientsCollection = new DeploymentServerClientsCollection();
                var machineTypes = new MachineTypesCollection(); 
                var selectedMachineTypes = new Backbone.Collection(); 
                machineTypes.fetch(); 
                //allClientsCollection.fetch({data:{count: 10, offset: 0}}); 


                var that = this; 
                classicurlModel.fetch({
                    success: function() {
                        var serverClassModel = new DeploymentServerClassModel(); 
                        serverClassModel.set("id", classicurlModel.get('id')); 
                        var return_to = classicurlModel.get('return_to'); 

                        that.addClientsView = new AddClientsView({
                            collection: {
                                //allClients: clientsCollection, 
                                selectedClients: selectedClientsCollection, 
                                unselectedClients: unselectedClientsCollection, 
                                allClients: allClientsCollection, 
                                selectedMachineTypes: selectedMachineTypes, 
                                machineTypes: machineTypes 
                            },
                            model: { 
                                serverClass: serverClassModel 
                            }, 
                            application: that.model.application,  
                            return_to: return_to
                        });  
                    }
                });

                $.when(                    
                    this.deferreds.pageViewRendered
                ).then(function(){
                    $('.preload').replaceWith(this.pageView.el);
                    this.pageView.$('.main-section-body').append(this.addClientsView.render().el);
                }.bind(this)); 
 
            }
        });
    });
