define(function (require, exports, module) {
    var $ = require('jquery');
    var _ = require('underscore');
    var mvc = require('./mvc');
    var BaseSplunkView = require("./basesplunkview");
    var Footer = require('views/shared/footer/Master');
    var sharedModels = require('./sharedmodels');

    var FooterView = BaseSplunkView.extend({
        moduleId: module.id,
        
        className: 'splunk-footer',
        initialize: function() {
            var appModel = sharedModels.get("app");
            var appLocalModel = sharedModels.get("appLocal");
            var serverInfoModel = sharedModels.get("serverInfo");
            var appLocals = sharedModels.get("appLocals");

            this.dfd = $.when.apply($, [
                appModel.dfd,
                appLocalModel.dfd,
                serverInfoModel.dfd,
                appLocals.dfd
            ]);
            this.dfd.done(_.bind(function(){
                this.footer = Footer.create({
                    model: {
                        application: appModel,
                        appLocal: appLocalModel,
                        serverInfo: serverInfoModel
                    },
                    collection: {
                        apps: appLocals
                    }
                });
            }, this));
        },
        render: function() {
            this.dfd.done(_.bind(function(){
                this.$el.append(this.footer.render().el);
            }, this));
            return this;
        }
    });

    return FooterView;
});