define(function(require, exports, module) {
    var _ = require('underscore');
    var BaseMultiChoiceView = require("./basemultichoiceview");
    var BaseDropdownViewMixin = require("./basedropdownviewmixin");

    // See http://ricostacruz.com/backbone-patterns/#mixins for
    // this mixin pattern.
    var MultiDropdownView = BaseMultiChoiceView.extend(
        _.extend({}, BaseDropdownViewMixin, {
            moduleId: module.id,
            
            className: "splunk-multidropdown splunk-choice-input",
            selectRoot: '<input type="hidden" />',
            valueIsList: true,
            
            initialize: function() {
                this.options = _.extend({}, BaseMultiChoiceView.prototype.options, this.options);
                BaseMultiChoiceView.prototype.initialize.apply(this, arguments);
                this.settings.on("change:width", _.debounce(this.render, 0), this);
            },
            remove: function() {
                BaseDropdownViewMixin.remove.apply(this, arguments);
                BaseMultiChoiceView.prototype.remove.apply(this, arguments);
            }
        })
    );

    return MultiDropdownView;
});
