define(['jquery', 'util/console'], function($, console) {

    var load = function(deps) {
        var cancelled = false;
        var dfd = $.Deferred();
        require(deps,
            // success callback, resolve the promise unless the loading was cancelled
            function() {
                if(!cancelled) {
                    dfd.resolve.apply(dfd, arguments);
                }
            },
            // error callback, log the error and reject the promise
            function(err) {
                console.error('Error dynamically loading module: ', err);
                dfd.reject(err);
            }
        );

        dfd.cancel = function() {
            cancelled = true;
            dfd.reject();
        };

        return dfd;
    };

    return ({ load: load });

});