define([
            'underscore'
        ],
        function(
            _
        ) {

    // normalize data for drilldown event to handle a map click
    var convertMapClickToIntentions = function(e) {
        var eventData = _(e.data).pick('_geo_lat_field', '_geo_long_field', '_geo_bounds_north', '_geo_bounds_east',
            '_geo_bounds_south', '_geo_bounds_west');
        // If we were able to discover geo_bounds data in the click, use the 'geoviz' action with the intentions parser.
        if(!_(eventData).isEmpty()) {
            eventData.action = 'geoviz';
            // Normalize a naming inconsistency.
            eventData._geo_lon_field = eventData._geo_long_field;
            delete eventData._geo_long_field;
            return eventData;
        }
        // If not, fall back to a 'fieldvalue' action with the latitude and longitude.
        return ({
            action: 'fieldvalue',
            field: ['latitude', 'longitude'],
            value: [e.data.latitude, e.data.longitude]
        });
    };

    return ({
        convertMapClickToIntentions: convertMapClickToIntentions
    });

});