define(['underscore', 'backbone'], function(_) {

    var vizToAttrs = {
        line: {
            'display.visualizations.charting.chart': 'line',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        area: {
            'display.visualizations.charting.chart': 'area',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        column: {
            'display.visualizations.charting.chart': 'column',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        bar: {
            'display.visualizations.charting.chart': 'bar',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        pie: {
            'display.visualizations.charting.chart': 'pie',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        scatter: {
            'display.visualizations.charting.chart': 'scatter',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        bubble: {
            'display.visualizations.charting.chart': 'bubble',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        radialGauge: {
            'display.visualizations.charting.chart': 'radialGauge',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        fillerGauge: {
            'display.visualizations.charting.chart': 'fillerGauge',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        markerGauge: {
            'display.visualizations.charting.chart': 'markerGauge',
            'display.visualizations.type': 'charting',
            'display.general.type': 'visualizations'
        },
        single: {
            'display.visualizations.type': 'singlevalue',
            'display.general.type': 'visualizations'
        },
        events: {
            'display.general.type': 'events'
        },
        statistics: {
            'display.general.type': 'statistics'
        },
        mapping: {
            'display.visualizations.type': 'mapping',
            'display.general.type': 'visualizations'
        }
    };

    var visualizationGroupings = {
        "events": [
            { value: 'events', label: _("Events").t(), icon: 'list' }
        ],
         "statistics": [
            {value: 'statistics', label: _("Statistics Table").t(), icon: 'table' }
        ],
        "visualizations": [
            { value: 'line', label: _("Line").t(), icon: 'chart-line' },
            { value: 'area', label: _("Area").t(), icon: 'chart-area' },
            { value: 'column', label: _("Column").t(), icon: 'chart-column' },
            { value: 'bar', label: _("Bar").t(), icon: 'chart-bar' },
            { value: 'pie', label: _("Pie").t(), icon: 'chart-pie' },
            { value: 'scatter', label: _("Scatter").t(), icon: 'chart-scatter' },
            { value: 'bubble', label: _("Bubble").t(), icon: 'chart-bubble' },
            { value: 'single', label: _("Single Value").t(), icon: 'single-value' },
            { value: 'radialGauge', label: _("Radial Gauge").t(), icon: 'gauge-radial' },
            { value: 'fillerGauge', label: _("Filler Gauge").t(), icon: 'gauge-filler' },
            { value: 'markerGauge', label: _("Marker Gauge").t(), icon: 'gauge-marker' },
            { value: 'mapping', label: _("Map").t(), icon: 'location' }
        ]
    };

    var getVisualizationGroupings = function() {
        return visualizationGroupings;
    };

    var getReportSettingsForType = function(type) {
        return vizToAttrs[type];

    };

    return {
        getVisualizationGroupings: getVisualizationGroupings,
        getReportSettingsForType: getReportSettingsForType,
        vizToAttrs: vizToAttrs
    };
});
