define(
    [
        'module',
        'underscore',
        'views/Base'
    ],
    function(
        module,
        _,
        BaseView
    ) {
        return BaseView.extend({
            moduleId: module.id,
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
            },
            events: {
                'click a.skip': function(e) {
                    this.model.login.saveAsFree(this.model.session.entry.content.get('cval'), this.model.application.get('return_to'));
                    e.preventDefault();
                }
            },
            render: function() {
                this.$el.html(this.compiledTemplate({
                    _: _
                }));
                return this;
            },
            template: '\
                <a href="http://www.splunk.com/r/download" class="btn"><%= _("Download").t() %></a>\
                <a href="#" class="skip"><%= _("Skip update").t() %></a>\
            '
        });
    }
);
