define(
    [
        'module',
        'views/Base'
    ],
    function(module, BaseView) {
        return BaseView.extend({
            moduleId: module.id,
            tagName: 'iframe',
            attributes: {
                scrolling: 'no',
                allowtransparency: 'true',
                marginheight: '0',
                marginwidth: '0',
                frameborder: '0',
                src: 'about:blank'
            },
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
                this.listenTo(this.model.updateChecker, 'change:url', this.render);
            },
            render: function() {
                var url = this.model.updateChecker.get('url'),
                    isLite = this.model.serverInfo.isLite();
                if (url) {
                    this.el.src = url;
                } else if (isLite) {
                    this.el.height = "0";
                }
                return this;
            }
        });
    }
);