define(
    [
        'module',
        'underscore',
        'views/Base',
        'views/shared/WaitSpinner'
    ],
    function(
        module,
        _,
        BaseView,
        WaitSpinnerView
    ) {
        return BaseView.extend({
            moduleId: module.id,
            tagName: 'p',
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
                this.children.waitSpinner = new WaitSpinnerView({});
                this.children.waitSpinner.start();
            },
            render: function() {
                this.$el.html(this.template);
                this.children.waitSpinner.prependTo(this.el);
                return this;
            },
            template: _('Checking for updates...').t()
        });
    }
);


