define(
    [
        'module',
        'underscore',
        'views/Base',
        'uri/route'
    ],
    function(
        module,
        _,
        BaseView,
        route
    ) {
        return BaseView.extend({
            moduleId: module.id,
            tagName: 'p',
            className: 'spl-change-password-skip',
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
            },
            render: function() {
                var html = this.compiledTemplate({
                    _: _,
                    route: route,
                    model: this.model
                });
                this.$el.html(html);
                return this;
            },
            template: '\
                <a href="<%- route.returnTo(model.get("root"), model.get("locale"), model.get("return_to") || "") %>"><%- _("Skip").t() %></a>\
            '
        });
    }
);
