define(
[
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/add_data/Initial.html',
    'splunk.util',
    'uri/route'
],
function(
    $,
    _,
    module,
    BaseView,
    template,
    splunkUtil,
    route
){
    /**
     */
    return BaseView.extend({
        template: template,
        moduleId: module.id,

        initialize: function () {
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.wizard.set('currentStep', 'initial');
        },

        events: {
            'click .link-wrap': function(e) {
                var targetId = e.currentTarget.id;
                this.model.wizard.set('upload', false);
                if (targetId == 'btn-upload') {
                    this.model.wizard.setInputMode(0);
                    this.model.wizard.set({
                        inputType: 'file_upload',
                        currentStep: 'selectsource',
                        upload: true
                    });
                } else if (targetId == 'btn-monitor') {
                    this.model.wizard.unset('inputType');
                    this.model.wizard.setInputMode(1);
                    this.model.wizard.set({currentStep: 'selectsource'});
                } else if (targetId == 'btn-forward') {
                    this.model.wizard.setInputMode(2);
                    this.model.wizard.set({currentStep: 'selectforwarders'});
                }

                $(".adddata-header").css("display", "block"); //TODO get working in CSS
                $(".layoutRow").css("position", "absolute"); //TODO get working in CSS
            }
        },

        render: function () {
            var addDataTutorialLink = route.docHelp(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                'learnmore.adddata.datatutorial'
            );
            var setupForwarderLink = route.docHelp(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                'learnmore.adddata.setupforwarder'
            );
            var monitorLink = route.docHelp(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                'manager.adddata'
            );
            var troubleshootLink = route.docHelp(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                'learnmore.adddata.troubleshooting'
            );

            var stewieAppsLink = route.manager(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                'search',
                ['apps', 'local']
            );

            var isLite = this.model.serverInfo.isLite();

            var template = this.compiledTemplate({
                isLite: isLite,
                stewieAppsLink: stewieAppsLink,
            	imgBaseUrl: splunkUtil.make_url('/static/img/skins/default'),
                addDataTutorialLink: addDataTutorialLink,
                setupForwarderLink: setupForwarderLink,
                monitorLink: monitorLink,
                troubleshootLink: troubleshootLink
            });
            this.$el.html(template);
            $(".adddata-header").css("display", "none"); //TODO get working in CSS
            $(".layoutRow").css("position", "static"); //TODO get working in CSS
            return this;
        }
    });
});