define(function(require, exports, module) {

    var $ = require("jquery");
    var _ = require("underscore");
    var i18n = require("splunk.i18n");
    var SplunkUtil = require("splunk.util");
    var BaseView = require("views/Base");

    var template = require("contrib/text!views/authentication_users/Title.html");

    return BaseView.extend({

        moduleId: module.id,
        template: template,
        className: 'section-header',

        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },

        render: function() {
            if (!this.el.innerHTML) {
                this.$el.html(this.compiledTemplate({
                    _: _,
                    sprintf: SplunkUtil.sprintf,
                    ungettext: i18n.ungettext,
                    isAdmin: this.model.user.hasRole("admin"),
                    maxUsers: this.model.serverInfo.entry.content.get("max_users")
                }));
            }
            return this;
        }

    });

});
