define([
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'views/shared/Modal',
    'uri/route',
    'contrib/text!views/clustering/config/Restart.html'
],
    function(
        $,
        _,
        module,
        BaseView,
        Modal,
        route,
        RestartTemplate
        ) {
        return BaseView.extend({
            moduleId: module.id,
            template: RestartTemplate,
            /**
             * @param {Object} options {
        *       model: <models.>,
        *       collection: <collections.services.>
        * }
             */
            initialize: function(options) {
                BaseView.prototype.initialize.call(this, options);
                this.model.wizard.on('change', this.render);
            },
            events: {
                'click .btn-primary.restart': function(e) {
                    this.model.wizard.trigger('restart');
                    e.preventDefault();
                }
            },
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html(_("Restart Splunk").t());

                var root = this.model.application.get('root'),
                    locale = this.model.application.get('locale'),
                    learnmoreIndexesLink = route.docHelp(root, locale, 'learnmore.peers.index'),
                    learnmoreForwardersLink = route.docHelp(root, locale, 'learnmore.peers.forwarders');
                var html = this.compiledTemplate({
                    mode: this.model.wizard.get('mode') || '',
                    learnmoreIndexesLink: learnmoreIndexesLink,
                    learnmoreForwardersLink: learnmoreForwardersLink
                });
                this.$(Modal.BODY_SELECTOR).append(html);
                this.$(Modal.BODY_SELECTOR).show();
                this.$(Modal.FOOTER_SELECTOR).append(Modal.BUTTON_CANCEL);
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn restart next btn-primary modal-btn-primary">'+ _('Go to Server Controls').t()+ '</a>');
                return this;
            }
        });
    });
