define([
    'underscore',
    'module',
    'views/Base',
    'views/shared/Modal'
],
    function(
        _,
        module,
        BaseView,
        Modal
        ) {
        return BaseView.extend({
            moduleId: module.id,
            /**
             * @param {Object} options {
        *       model: <models.>,
        *       collection: <collections.services.>
        * }
             */
            initialize: function(options) {
                BaseView.prototype.initialize.call(this, options);
            },
            events: $.extend({}, Modal.prototype.events, {
                'click .btn-primary': function(e) {
                    this.model.wizardModel.trigger('disable');
                    e.preventDefault();
                }
            }),
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html(_('Disable Clustering').t());
                var html = this.compiledTemplate({
                    mode: this.model.clusterConfig.entry.content.get('mode')
                });
                this.$(Modal.BODY_SELECTOR).append(html);
                this.$(Modal.FOOTER_SELECTOR).append(Modal.BUTTON_CANCEL);
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn btn-primary modal-btn-primary">'+_('Disable clustering').t()+'</a>');
                return this;
            },
            template: "<% if (mode=='master') { %>\
                <%= _('Before disabling clustering, make sure all the peers are disabled from the master. Are you sure you want to continue?').t() %>\
            <% } else { %>\
                <%= _('This will disable clustering on this node. Are you sure you want to continue?').t() %>\
            <% } %>"
        });
    });
