define([
    'underscore',
    'module',
    'views/Base',
    'views/shared/Modal'
],
    function(
        _,
        module,
        BaseView,
        Modal
        ) {
        return BaseView.extend({
            moduleId: module.id,
            /**
             * @param {Object} options {
        *       model: <models.>,
        *       collection: <collections.services.>
        * }
             */
            initialize: function(options) {
                BaseView.prototype.initialize.call(this, options);
            },
            events: {
                'click .btn-primary.restart': function(e) {
                    this.model.wizardModel.trigger('restart');
                    e.preventDefault();
                }
            },
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html(_('Restart Splunk').t());

                var html = this.compiledTemplate();
                this.$(Modal.BODY_SELECTOR).append(html);
                this.$(Modal.FOOTER_SELECTOR).append(Modal.BUTTON_CANCEL);
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn restart next btn-primary modal-btn-primary">'+_('Go to Server Controls').t()+'</a>');
                return this;
            },
            template: _('You must restart Splunk for clustering to be completely disabled. You can restart Splunk from Server Controls.').t()
        });
    });
