/**
 * Created by ykou on 5/15/14.
 */
define(
    [
        'jquery',
        'underscore',
        'backbone',
        'views/Base',
        'module'
    ],
    function(
        $,
        _,
        Backbone,
        BaseView,
        module
    )
    {
        /**
         * this.options.rowData: an array of data, which would be columns in that row
         */
        return BaseView.extend({
            moduleId: module.id,
            tagName: 'tr',
            className: 'table-row',
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
                this.$el = $('<tr>');
            },
            render: function() {
                _.each(this.options.rowData, function(element, index, array) {
                    var cell = null;
                    if (this.options.rowType == 'head') {
                        cell = $('<th>').append(element);
                    }
                    else {
                        cell = $('<td>').append(element);
                    }
                    this.$el.append(cell);
                }.bind(this));
                return this;
            }
        });
    }
);