define([
    'jquery',
    'underscore',
    'module',
    'uri/route',
    'util/splunkd_utils',
    'models/search/Dashboard',
    'views/Base',
    'views/home/Apps',
    'views/home/dashboard/Master',
    'views/home/gettingstarted/Master'
],
function(
    $,
    _,
    module,
    route,
    splunkDUtils,
    DashboardModel,
    BaseView,
    AppsView,
    DashboardView,
    GettingStartedView
) {
    return BaseView.extend({
        moduleId: module.id,
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);

            this.children.apps = new AppsView({
                collection: {
                    apps: this.collection.apps,
                    appNavs: this.collection.appNavs
                },
                model: {
                    application: this.model.application,
                    userPref: this.model.userPref
                },
                canManageRemoteAppsDfd: this.options.canManageRemoteAppsDfd
            });
            this.children.dashboard = new DashboardView({
                model: {
                    userPref: this.model.userPref, 
                    application: this.model.application, 
                    user: this.model.user,
                    dashboard: this.model.dashboard
                }
            });
            this.children.gettingStarted = new GettingStartedView({
                model: {
                    uiPref: this.model.uiPref,
                    application: this.model.application,
                    user: this.model.user
                },
                collection: this.collection.managers
            });
        },
        render: function () {
            this.$el.html(this.template);
            this.children.apps.appendTo(this.$('.apps')).render();
            this.children.gettingStarted.appendTo(this.$('.dashboard')).render();
            this.children.dashboard.appendTo(this.$('.dashboard')).render();
        },
        template: '\
            <div class="section-home section-content">\
                <div class="apps"></div>\
                <div class="dashboard scrolling-bar-dashboard"></div>\
            </div>\
        '
    });
});
