define([
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/homeclassic/FindAndManageApps.html',
    'splunk.util',
    'uri/route'
],
function(
    $,
    _,
    module,
    BaseView,
    findAndManageAppsTemplate,
    splunk_util,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        initialize: function(){
            BaseView.prototype.initialize.apply(this, arguments);
            this.viewTemplate = _.template(findAndManageAppsTemplate);
            this.canManageRemoteApps = false;
            $.when(this.options.canManageRemoteAppsDfd)
                .done(function(){
                    this.canManageRemoteApps = true;
                    this.render();
                }.bind(this))
                .fail(function(){
                    this.canManageRemoteApps = false;
                    this.render();
                }.bind(this));
        },
        render: function(){
            this.$el.html(this.viewTemplate({
                makeManagerLink: this.makeManagerLink.bind(this),
                canManageRemoteApps: this.canManageRemoteApps
            }));
            return this;
        },
        makeManagerLink: function(managerPage){
            return route.manager(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                this.model.application.get('app'),
                managerPage
            );
        }
    });
});
