/**
 * Created by ykou on 8/5/14.
 */
define([
    'jquery',
    'module',
    'views/Base',
    'views/managementconsole/instances/components/ViewMenu',
    'contrib/text!views/managementconsole/instances/components/Action.html'
], function(
    $,
    module,
    BaseView,
    ViewMenu,
    Template
) {
    return BaseView.extend({
        moduleId: module.id,
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.children.viewMenu = new ViewMenu({
                instance: this.options.instance,
                earliest: this.options.earliest,
                latest: this.options.latest
            });
        },
        events: {
            'mousedown .dmc-view-menu': 'toggleViewMenu',
            'mouseup .dmc-view-menu': function(e) {
                e.preventDefault();
            }
        },
        toggleViewMenu: function(e) {
            e.preventDefault();
            this.children.viewMenu.show($(e.target));
        },
        render: function() {
            this.$el.html(this.compiledTemplate());
            this.children.viewMenu.render().$el.appendTo(this.$el);
        },
        template: Template
    });
});