define(
	[
		'jquery',
		'underscore',
		'module',
		'views/shared/controls/MultiInputControl',
		'splunk.util'
	],
	function(
		$,
		_,
		module,
		MultiInputControl,
		splunkUtils
	) {
		var DELIMITER = "::::";

		return MultiInputControl.extend({
			moduleId: module.id,
			events: {
				'change input': function(e) {
					var values = e.val || [];
					this.setValue(splunkUtils.fieldListToString(values), false);
				}
			},
			initialize: function() {
				MultiInputControl.prototype.initialize.apply(this, arguments);
				this.collection.on('change:tags', this.debouncedRender, this);
			},
			getTags: function() {
				return this.options.autoCompleteFields || this.collection.getAllTags();
			},
			render: function() {
				this.$el.html(this.compiledTemplate({ options: this.options }));
                var $input = this.$('input');
                $input.select2({
                	placeholder: this.options.placeholder || _("Choose groups").t(),
                	tags: this.getTags(),
                	formatNoMatches: function() { return '&nbsp;'; },
                	dropdownCssClass: 'empty-results-allowed',
                	separator: DELIMITER,
                	openOnEnter: false
                }).select2('val', splunkUtils.stringToFieldList(this._value || ''));
                return this;

			},
            template: '\
            	<input class="<%= options.inputClassName %>" />\
        	'

		});

	}
);