define(
    [
        'jquery',
        'underscore',
        'module',
        'backbone',
        'collections/shared/FlashMessages',
        'views/shared/Modal',
        'views/shared/FlashMessagesLegacy'
    ],
    function(
        $,
        _,
        module,
        Backbone,
        FlashMessagesCollection,
        ModalView,
        FlashMessagesView
    ) {
        var TEMPLATE_WITHOUT_CLOSE = '\
                <div class="' + ModalView.HEADER_CLASS + '">\
                    <h3 class="modal-title">&nbsp;</h3>\
                </div>\
                <div class="' +  ModalView.BODY_CLASS + '">\
                </div>\
                <div class="' + ModalView.FOOTER_CLASS + '">\
                </div>\
                ';
        return ModalView.extend({
            moduleId: module.id,
            initialize: function() {
                // options disable exiting upon clicking outside modal
                var defaults = {
                    onHiddenRemove: true,
                    keyboard: false,
                    backdrop: 'static'
                };
                this.options = _.extend({}, defaults, this.options);
                ModalView.prototype.initialize.apply(this, arguments);

                this.title = this.options.errorMessage ? _("Error").t() : this.options.title;
                this.message = this.options.message;
                this.errorMessage = this.options.errorMessage;

                this.collection = this.collection || {};
                this.collection.flashMessages = new FlashMessagesCollection();

                this.children.flashMessage = new FlashMessagesView({
                    collection: this.collection.flashMessages,
                    escape: false
                });

                this.$el.html(TEMPLATE_WITHOUT_CLOSE);
                this.$(ModalView.HEADER_TITLE_SELECTOR).html(this.title);
                this.$(ModalView.BODY_SELECTOR).prepend(this.children.flashMessage.render().el);
                this.$(ModalView.BODY_SELECTOR).append(this.message);

                if (this.errorMessage) {
                    this.collection.flashMessages.reset([{
                        type: 'error',
                        html: this.errorMessage
                    }]);
                }

              
            },
            render: function() {
               
                return this;
            },
            TEMPLATE_WITHOUT_CLOSE: TEMPLATE_WITHOUT_CLOSE
        });
    }
);

