/**
 * @author sfishel
 *
 * The view for editing an object count cell pivot config form.
 */

define([
            'module',
            '../ConfigFormBase',
            '../../custom_controls/LabelControlGroup',
            '../../custom_controls/CellDisplayControlGroup'
        ],
        function(
            module,
            ConfigFormBase,
            LabelControlGroup,
            CellDisplayControlGroup
        ) {

    return ConfigFormBase.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
         *     model <models/pivot/elements/cells/ObjectCountCell> the model to edit
         * }
         *
         * CellDisplayControlGroup is currently commented out because sparklines are not supported by the back end
         */

        initialize: function(options) {
            ConfigFormBase.prototype.initialize.call(this, options);
            this.children.labelControlGroup = new LabelControlGroup({ model: this.model });
//            this.children.displayControlGroup = new CellDisplayControlGroup({ model: this.model });
        },

        render: function() {
            // have to detach the control groups so their event listeners aren't destroyed
            this.children.labelControlGroup.$el.detach();
//            this.children.displayControlGroup.$el.detach();

            this.$el.append(this.children.labelControlGroup.render().el);
//            this.$el.append(this.children.displayControlGroup.render().el);
            return this;
        }

    });

});