/**
 * @author sfishel
 *
 * The view for editing a timestamp cell pivot config form.
 */

define([
            'module',
            '../ConfigFormBase',
            '../../custom_controls/LabelControlGroup',
            '../../custom_controls/CellValueControlGroup'
        ],
        function(
            module,
            ConfigFormBase,
            LabelControlGroup,
            CellValueControlGroup
        ) {

    return ConfigFormBase.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
         *     model <models/pivot/elements/cells/TimestampCell> the model to edit
         * }
         */

        initialize: function(options) {
            ConfigFormBase.prototype.initialize.call(this, options);
            this.children.valueControlGroup = new CellValueControlGroup({ model: this.model });
        },

        render: function() {
            // have to detach the control groups so their event listeners aren't destroyed
            this.children.valueControlGroup.$el.detach();

            this.$el.append(this.children.valueControlGroup.render().el);
            return this;
        }

    });

});