/**
 * @author sfishel
 *
 * The view for a boolean column-split pivot config form.
 */

define([
            'module',
            '../ConfigFormBase',
            '../../custom_controls/TrueLabelControlGroup',
            '../../custom_controls/FalseLabelControlGroup'
        ],
        function(
            module,
            ConfigFormBase,
            TrueLabelControlGroup,
            FalseLabelControlGroup
        ) {

    return ConfigFormBase.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
         *     model <models/pivot/elements/columns/BooleanColumn> the model to edit
         * }
         */

        initialize: function(options) {
            ConfigFormBase.prototype.initialize.call(this, options);
            this.isFirst = options.elementIndex === 0;
            this.children.trueLabelControlGroup = new TrueLabelControlGroup({
                model: this.model
            });
            this.children.falseLabelControlGroup = new FalseLabelControlGroup({
                model: this.model
            });
        },

        render: function() {
            // have to detach the control groups so their event listeners aren't destroyed
            this.children.trueLabelControlGroup.$el.detach();
            this.children.falseLabelControlGroup.$el.detach();
            this.$el.append(this.children.trueLabelControlGroup.render().el);
            this.$el.append(this.children.falseLabelControlGroup.render().el);
            return this;
        }

    });

});