/**
 * @author sfishel
 *
 * A view for a timestamp column pivot config form.
 */

define([
            'module',
            '../ConfigFormBase',
            '../../custom_controls/TimePeriodControlGroup'
        ],
        function(
            module,
            ConfigFormBase,
            TimePeriodControlGroup
        ) {

    return ConfigFormBase.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
         *     model <models/pivot/elements/columns/TimestampColumn> the model to edit
         * }
         */

        initialize: function(options) {
            ConfigFormBase.prototype.initialize.call(this, options);
            this.isFirst = options.elementIndex === 0;
            this.children.periodControlGroup = new TimePeriodControlGroup({
                model: this.model,
                showSamples: true
            });
        },

        render: function() {
            // have to detach the control groups so their event listeners aren't destroyed
            this.children.periodControlGroup.$el.detach();
            this.$el.append(this.children.periodControlGroup.render().el);
            return this;
        }

    });

});

