/**
 * @author sfishel
 *
 * The view for editing a boolean filter pivot config form.
 */

define([
           'module',
           '../ConfigFormBase',
            '../../custom_controls/FilterMatchControlGroup',
           'util/pivot/config_form_utils'
       ],
       function(
           module,
           ConfigFormBase,
           FilterMatchControlGroup,
           configFormUtils
       ) {

   return ConfigFormBase.extend({

       moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
             *     model <models/pivot/elements/filters/BooleanFilter> the model to edit
             * }
         */

       initialize: function(options) {
           ConfigFormBase.prototype.initialize.call(this, options);
           this.children.matchControlGroup = new FilterMatchControlGroup({ model: this.model });
       },

       render: function() {
           // have to detach the control group so its event listeners aren't destroyed
           this.children.matchControlGroup.$el.detach();
           this.$el.append(this.children.matchControlGroup.render().el);
           return this;
       }

   });

});