/**
 * @author sfishel
 *
 * The view for a number row-split pivot config form.
 */

define([
            'module',
            '../columns/NumberColumnForm',
            'views/shared/controls/ControlGroup',
            '../../custom_controls/LabelControlGroup'
        ],
        function(
            module,
            NumberColumnForm,
            ControlGroup,
            LabelControlGroup,
            SplitSortControlGroup
        ) {

    return NumberColumnForm.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
         *     model <models/pivot/elements/rows/NumberRow> the model to edit
         * }
         */

        initialize: function(options) {
            NumberColumnForm.prototype.initialize.call(this, options);
            this.children.labelControlGroup = new LabelControlGroup({ model: this.model });
        },

        render: function() {
            // have to detach the control group so its event listeners aren't destroyed
            this.children.labelControlGroup.$el.detach();
            NumberColumnForm.prototype.render.call(this);
            this.$el.prepend(this.children.labelControlGroup.render().el);
            return this;
        }

    });

});