define([
            'jquery',
            'module',
            'views/pivot/content/ContentBase',
            'views/shared/SingleValue'
        ],
        function(
            $,
            module,
            ContentBase,
            SingleValue
        ) {

    return ContentBase.extend({

        moduleId: module.id,

        initialize: function() {
            ContentBase.prototype.initialize.apply(this, arguments);
            this.children.singleValue = new SingleValue({
                model: {
                    searchResultsColumn: this.model.results,
                    state: this.model.report.entry.content
                }
            });
        },

        renderData: function() {
            this.children.singleValue.render().appendTo(this.$el);
        },

        clearData: function() {
            this.children.singleValue.remove();
        },

        showDataDisplay: function() {
            this.children.singleValue.wake().$el.show();
        },

        hideDataDisplay: function() {
            this.children.singleValue.sleep().$el.hide();
        }

    });

});
