define([
            'module',
            'views/shared/reportcontrols/dialogs/dashboardpanel/Master',
            './components/CreateDashboardPanelAndDataModel',
            './components/DashboardPanelAndDataModelSuccess'
        ],
        function(
            module,
            DashboardpanelMaster,
            CreateDashboardPanelAndDataModel,
            DashboardPanelAndDataModelSuccess
        ) {

    return DashboardpanelMaster.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param {Object} options {
         *     model:{
         *         report: <models.services.SavedSearch>,
         *         application: <models.Application>,
         *         user: <models.service.admin.user>,
         *         dataModel: <models.services.datamodel.DataModel>,
         *         searchJob: <models.search.Job>
         *     }
         * }
         */

        initialize: function() {
            this.options.chooseVisualizationType = false;
            DashboardpanelMaster.prototype.initialize.apply(this, arguments);
            if(this.model.dataModel.isTemporary()) {
                this.children.create = new CreateDashboardPanelAndDataModel({
                    model: {
                        report: this.model.report,
                        application: this.model.application,
                        searchJob: this.model.searchJob,
                        dashboardToSave: this.model.dashboardToSave,
                        inmem: this.model.inmem,
                        user: this.model.user,
                        dataModel: this.model.dataModel
                    },
                    chooseVisualizationType: false
                });
                this.children.success = new DashboardPanelAndDataModelSuccess({
                    model: {
                        dashboardToSave: this.model.dashboardToSave,
                        inmem: this.model.inmem,
                        application: this.model.application,
                        dataModel: this.model.dataModel
                    }
                });

                this.on('hidden', function() {
                    this.trigger(
                        'action:flowExited',
                        !this.model.dataModel.isTemporary(),
                        this.model.report.entry.content.get('search')
                    );
                }, this);
            }
        }

    });

});