define([
            'module',
            'views/shared/reportcontrols/dialogs/createreport/Master',
            './components/CreateReportAndDataModel',
            './components/ReportAndDataModelSuccess'
        ],
        function(
            module,
            CreatereportMaster,
            CreateReportAndDataModel,
            ReportAndDataModelSuccess
        ) {

    return CreatereportMaster.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param {Object} options {
         *     model:{
         *         report: <models.services.SavedSearch>,
         *         application: <models.Application>,
         *         user: <models.service.admin.user>,
         *         dataModel: <models.services.datamodel.DataModel>,
         *         searchJob: <models.search.Job>
         *     }
         * }
         */

        initialize: function() {
            this.options.chooseVisualizationType = false;
            CreatereportMaster.prototype.initialize.apply(this, arguments);
            // If the data model is temporary, replace the step views with different views that
            // will incorporate saving the data model into the flow.
            if(this.model.dataModel.isTemporary()) {
                this.children.create = new CreateReportAndDataModel({
                    model: {
                        searchJob: this.model.searchJob,
                        application: this.model.application,
                        inmem: this.model.inmem,
                        dataModel: this.model.dataModel
                    },
                    chooseVisualizationType: false
                });
                // TODO [sff] the inheritance got a little ugly with the event bindings,
                //            should clean this up in the superclass.
                this.children.success.off();
                this.children.success = new ReportAndDataModelSuccess({
                    model: {
                        application: this.model.application,
                        inmem: this.model.inmem,
                        searchJob: this.model.searchJob,
                        user: this.model.user,
                        dataModel: this.model.dataModel
                    }
                });
                this.children.success.on('addToDashboardPanel', function(){
                    this.stepViewStack.setSelectedView(this.children.createDashboardPanel);
                }, this);

                this.on('hidden', function() {
                    this.trigger(
                        'action:flowExited',
                        !this.model.dataModel.isTemporary() && this.model.inmem.isNew(),
                        this.model.inmem.entry.content.get('search')
                    );
                }, this);
            }
        }

    });

});
