define([
            'module',
            'views/shared/MultiStepModal',
            './components/SaveDataModel',
            './components/DataModelSuccess'
        ],
        function(
            module,
            MultiStepModal,
            SaveDataModel,
            DataModelSuccess
        ) {
    
    return MultiStepModal.extend({
    
        moduleId: module.id,
    
        initialize: function() {
            MultiStepModal.prototype.initialize.apply(this, arguments);
            this.children.save = new SaveDataModel({
                model: {
                    dataModel: this.model.dataModel,
                    report: this.model.report,
                    application: this.model.application
                }
            });
            this.children.success = new DataModelSuccess({
                model: {
                    dataModel: this.model.dataModel,
                    user: this.model.user,
                    application: this.model.application
                }
            });
            this.listenTo(this.children.save, 'saveSuccess', function() {
                this.stepViewStack.setSelectedView(this.children.success);
            });
            this.on('hidden', function() {
                this.trigger(
                    'action:flowExited',
                    !this.model.dataModel.isTemporary(),
                    this.model.report.entry.content.get('search')
                );
            }, this);
        },

        getStepViews: function() {
            return [this.children.save, this.children.success];
        }
        
    });
    
});