define(
    [
        'underscore',
        'module',
        'views/Base',
        'views/search/actions/eventtype/Master'
    ],
    function(_, module, Base, EventTypeDialog) {
        return Base.extend({
            moduleId: module.id,
            tagName: 'li',
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);
            },
            events: {
                'click a:not(.disabled)': function(e) {
                    this.children.eventTypeDialog = new EventTypeDialog({
                        model: {
                            application: this.model.application,
                            user: this.model.user
                        },
                        collection: {
                            eventRenderers: this.collection.eventRenderers
                        },
                        searchString: this.model.report.entry.content.get('search'),
                        onHiddenRemove: true
                    });

                    this.children.eventTypeDialog.render().appendTo($('body')).show();
                    this.children.eventTypeDialog.show();
                    
                    e.preventDefault();
                },
                'click a.disabled': function(e) {
                    e.preventDefault();
                }
            },
             render: function() {
                this.$el.html(this.compiledTemplate({
                    _: _,
                    searchJob: this.model.searchJob
                }));
                return this;
            },
            template: '\
                <% if (searchJob.searchCanBeEventType()) { %>\
                    <a href="#"><%- _("Event Type").t() %></a>\
                <% } else {%>\
                    <a href="#" class="disabled"><%- _("Event Type").t() %></a>\
                <% } %>\
            '
        });
    }
);
