define(
    [
        'jquery',
        'underscore',
        'backbone',
        'module',
        'views/shared/Modal',
        'uri/route'
    ],
    function(
        $, 
        _, 
        backbone, 
        module, 
        Modal,
        route
    ){
        return Modal.extend({
            moduleId: module.id,
            initialize: function() {
                Modal.prototype.initialize.apply(this, arguments);
            },
            events: {
                'click .modal-btn-continue': function(e) {
                    this.setFirstTimePref();
                    var root = this.model.application.get('root'),
                        locale = this.model.application.get('locale'),
                        app = this.model.application.get('app'),
                        tourLink = route.page(root, locale, app, 'onboarding');
                    window.location = tourLink;
                },
                'click .modal-btn-skip': function(e) {
                    this.setFirstTimePref();
                }
            },
            setFirstTimePref: function() {
                if (this.model.userPrefs) {
                    this.model.userPrefs.entry.content.set('first.time.light', 1);
                    this.model.userPrefs.save();
                }
            },
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html(_("Welcome to Splunk").t());
                this.$(Modal.BODY_SELECTOR).append(Modal.FORM_HORIZONTAL);
                this.$(Modal.BODY_SELECTOR).append(_("Seems to be your first time, kiddo. Confused? Yeah, we are too. <br /><br /> Wanna take a quick walkthrough?").t());
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn modal-btn-skip pull-left" data-dismiss="modal">' + _('Skip').t() + '</a>');
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn modal-btn-continue pull-right">' + _('Continue to tour').t() + '</a>');
            }
        });
    }
);
