define([
            'underscore',
            'module',
            'views/shared/LazyView'
        ],
        function(
            _,
            module,
            LazyView
        ) {

    return LazyView.extend({

        moduleId: module.id,
        className: (LazyView.prototype.className || '') + ' lazy-timeline',
        wrappedModuleName: 'views/shared/CanvasTimeline',
        deps: ['jg_global', 'jgatt'],
        loadingMessage: _('Loading Timeline...').t(),
        _shown: false,

        show: function() {
            this._shown = true;
            return this;
        },

        hide: function() {
            this._shown = false;
            return this;
        },

        _onWrappedViewLoaded: function() {
            LazyView.prototype._onWrappedViewLoaded.apply(this, arguments);
            if(this._shown) {
                this.children.wrappedView.show();
            }
            this.$el.height('');
        }

    });

});