define([
            'underscore',
            'module',
            'views/shared/LazyView'
        ],
        function(
            _,
            module,
            LazyView
        ) {

    return LazyView.extend({

        moduleId: module.id,
        className: (LazyView.prototype.className || '') + ' lazy-map',
        wrappedModuleName: 'views/shared/Map',
        deps: ['jg_global', 'jgatt'],
        loadingMessage: _('Loading Map...').t(),

        initialize: function() {
            LazyView.prototype.initialize.apply(this, arguments);
            this.$el.height(this.options.height || 400);
        },

        _getWrappedViewOptions: function() {
            return _.extend(
                {},
                LazyView.prototype._getWrappedViewOptions.apply(this, arguments),
                { height: '100%' }
            );
        }

    });

});