// Control wrapper around a native input of type range
//
// NOTES:
// this has not been well tested


define([
        'underscore',
        'module',
        'views/shared/controls/TextControl'
    ],
    function(
        _,
        module,
        TextControl
    ){
        return TextControl.extend({

            /**
            * @constructor
            * @param {Object} options {
            *     {String, required} modelAttribute The attribute on the model to observe and update on selection
            *     {Model, required} model The model to operate on
            *     {Number, optional} min The minimum allowed value. Default 0.
            *     {Number, optional} max The maximum allowed value. Default 100.
            *     {Number, optional} step The step to apply when buttons/arrow keys are used. Default 1.
            *     {String, optional} inputClassName A class name to apply to the input element
            * }
            */

            moduleId: module.id,
            initialize: function() {
                var defaults = {
                        min: '0',
                        max: '100',
                        step: '1',
                        inputClassName: '',
                        enabled: true
                };
                _.defaults(this.options, defaults);
                
                TextControl.prototype.initialize.apply(this, arguments);
            },
            events: _.extend({}, TextControl.prototype.events, {
                'change input[type=range]': function(e) {
                    this.setValue($(e.target).val(), false);
                }
            }),
            disable: function() {
                this.$('input').prop('disabled', true);
                TextControl.prototype.disable.call(this);
            },
            enable: function() {
                this.$('input').prop('disabled', false);
                TextControl.prototype.enable.call(this);
            },
            render: function() {
                if (!this.el.innerHTML) {
                    TextControl.prototype.render.call(this);
                    this.$el.prepend(_.template(this.sliderTemplate, {
                      options: this.options,
                      value: this._value
                    }));
                } else {
                    this.$('input').val(this._value);
                }
            },
            sliderTemplate: '\
                <input  class="slider <%= options.inputClassName %>" type="range" \
                min="<%- options.min %>" max="<%- options.max %>" \
                step="<%- options.step %>" value="<%- value %>" />\
            '
        });
    }
);