// Control wrapper around a jquery UI spinner
//
// NOTES:
// this has not been well tested
// you need to import components/spinner-control.less when using it

define([
            'module',
            'views/shared/controls/Control',
            'jquery.ui.spinner'
        ],
        function(
            module,
            Control
            /* jquery ui spinner */
        ) {

    return Control.extend({

         /**
          * @constructor
          * @param {Object} options {
          *     {String, required} modelAttribute The attribute on the model to observe and update on selection
          *     {Model, required} model The model to operate on
          *     {Number, optional} min The minimum allowed value
          *     {Number, optional} max The maximum allowed value
          *     {Number, optional} step The step to apply when buttons/arrow keys are used
          *     {String, optional} inputClassName A class name to apply to the input element
          * }
         */

        moduleId: module.id,

        events: {

            'change input': function(e) {
                this.setValue($(e.target).val(), false);
            }

        },

        render: function() {
            this.$el.html(this.compiledTemplate({ options: this.options }));
            this.$('input').spinner({
                min: this.options.hasOwnProperty('min') ? this.options.min : null,
                max: this.options.hasOwnProperty('max') ? this.options.max : null,
                step: this.options.step || 1
            })
            .spinner('value', this.model.get(this.options.modelAttribute));
        },

        enable: function() {
            this.$('input').spinner('option', 'disabled', false);
            return Control.prototype.enable.apply(this, arguments);
        },

        disable: function() {
            this.$('input').spinner('option', 'disabled', true);
            return Control.prototype.disable.apply(this, arguments);
        },

        remove: function() {
            this.$('input').spinner('destroy');
            return Control.prototype.remove.apply(this, arguments);
        },

        template: '\
            <input class="<%= options.inputClassName %>" />\
        '

    });

});