define(
    [
        'underscore',
        'jquery',
        'module',
        'views/Base'
    ],
    function(_, $, module, Base) {
        return Base.extend({
            moduleId: module.id,
            tagName: 'form',
            className: 'search',
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);
                this.activate();
                this.set = _.debounce(function() {
                    this.model.entry.content.set('display.prefs.fieldFilter', this.$('input').val());
                }.bind(this), 250);
            },
            startListening: function() {
                this.listenTo(this.model.entry.content, 'change:display.prefs.fieldFilter', this.render);
            },
            events: {
                'keyup input': function(e) {
                    e.preventDefault();
                    var $el = $(e.target);
                    if (e.keyCode == 27) {
                        this.clear();
                        return;
                    }
                    this.set();
                },
                'click .clear': function(e) {
                    this.clear();
                    e.preventDefault();
                },
                'submit': function(e) {
                    e.preventDefault();
                }
            },
            clear: function() {
                this.model.entry.content.set('display.prefs.fieldFilter', '');
                this.render();
                this.$('input').focus();
            },
            render: function() {
                this.$el.html() || this.$el.html('<input type="text" class="input-medium search-query" placeholder="filter"><a href="#" class="clear"><i class="icon-x-circle"></i></a>');
                this.$('input').val(this.model.entry.content.get('display.prefs.fieldFilter'));
                return this;
            }
        });
    }
);
