define(['underscore','module', 'views/Base', 'bootstrap.tooltip'], function(_, module, BaseView /* bootstrap tooltip */) {
    return BaseView.extend({
        moduleId: module.id,
        className: 'stop btn-pill btn-square',
        tagName: 'a',
        attributes: {
            "href": "#"
        },
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.$el.tooltip({animation:false, title:_('Stop').t(), container: this.$el});
        },
        events: {
            "click": function(e) {
                e.preventDefault();
                if (!this.isActive()) {
                	return true;
                } else if (this.model.isQueued() || this.model.isParsing()) {
                    this.model.destroy({
                        success: function() {
                            this.model.clear();
                        }.bind(this)
                    });
                } else {
                    this.model.finalize({
                        success: function() {
                            this.model.fetch();
                        }.bind(this)
                    });
                }
                // Blur the element to avoid a sticky tooltip.
                this.$el.blur();
            }
        },
        isActive: function() {
            return !this.model.isNew() && !this.model.isDone();
        },
        render: function() {
            this.$el.html('<i class="icon-stop"></i><span class="hide-text">' + _("Stop").t() + '</span>');
            return this;
        }
    });
});
