define([
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/shared/litebar/SystemSection.html'
],
function(
    $,
    _,
    module,
    BaseView,
    systemMenuSectionTemplate
){
    return BaseView.extend({
        moduleId: module.id,
        template: systemMenuSectionTemplate,
        className: 'collapsible-group',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            var itemsArray = this.model.get('items');
            itemsArray.sort(function(a,b){
                return parseInt(a.get('order'), 10) - parseInt(b.get('order'), 10);
            });
        },
        render: function() {
            var html = this.compiledTemplate({
                model: this.model,
                groupTitle: this.model.get('label')
            });
            this.$el.html(html);
            this.$el.attr('id', this.model.get('label').toLowerCase().replace(/ /g,''));
            return this;
        }
    });
});