define(
	[
		'underscore',
		'module',
		'views/Base',
		'views/shared/Modal'
	], 
	function(_, module, BaseView, ModalView) {
		return BaseView.extend({
			moduleId: module.id,
			events: {
				'click a.enableEmbedding': function(e) {
					this.model.embed.save();
				}
			},
			render: function() {
				this.$el.html(ModalView.TEMPLATE);
	            this.$(ModalView.HEADER_TITLE_SELECTOR).html(_("Enable Report Embedding").t());
	            this.$(ModalView.BODY_SELECTOR).append('<p>' + _('Are you sure you want to enable embedding for this report? An embedded report can be viewed by anyone with access to the web page(s) in which it is inserted.').t() + '</p>');
	            this.$(ModalView.FOOTER_SELECTOR).append(ModalView.BUTTON_CANCEL);
	            this.$(ModalView.FOOTER_SELECTOR).append('<a href="#" class="btn btn-primary modal-btn-primary pull-right enableEmbedding">' + _('Enable Embedding').t() + '</a>');
	            return this;
			}
		});
	}
);