define(function(require, exports, module) {

    var BaseCellRenderer = require("./BaseCellRenderer");

    return BaseCellRenderer.extend({

        field: null,
        cellRenderer: null,

        initialize: function(field, cellRenderer) {
            if (field == null) {
                throw new Error("Parameter field must be non-null.");
            } else if ((cellRenderer != null) && !(cellRenderer instanceof BaseCellRenderer)) {
                throw new Error("Parameter cellRenderer must be an instance of views/shared/results_table/renderers/BaseCellRenderer.");
            }

            this.field = "" + field;
            this.cellRenderer = cellRenderer || null;
        },

        canRender: function(cellData) {
            return (cellData.field === this.field);
        },

        setup: function($td, cellData) {
            if (this.cellRenderer) {
                this.cellRenderer.setup($td, cellData);
            }
        },

        teardown: function($td, cellData) {
            if (this.cellRenderer) {
                this.cellRenderer.teardown($td, cellData);
            }
        },

        render: function($td, cellData) {
            if (this.cellRenderer) {
                this.cellRenderer.render($td, cellData);
            }
        }

    });

});
