define(
    [
         'jquery',
         'underscore',
         'module',
         'views/Base',
         'views/shared/Modal',
         'uri/route'
     ],
     function($, _, module, Base, Modal, route) {
        return Modal.extend({
            moduleId: module.id,
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);
            },
            events: $.extend({}, Modal.prototype.events, {
                "click .modal-btn-primary": function(e) {
                    e.preventDefault();
                    this.submit();
                }
            }),
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html(_("Show All Settings").t());
                this.$(Modal.BODY_SELECTOR).append(Modal.FORM_HORIZONTAL);

                this.$(Modal.BODY_SELECTOR).append(_('Because search head clustering is enabled, some sections of the settings menu are hidden. Do you wish to re-enable the full settings menu?').t());
                this.$(Modal.BODY_SELECTOR).append(_('<br><br>').t());
                this.$(Modal.BODY_SELECTOR).append(_('Note that system settings modified via re-enabled menus will not be replicated across your search head cluster.').t());
                this.$(Modal.BODY_SELECTOR).append(_('<br><br>').t());

                var docLink = route.docHelp(this.model.application.get("root"), this.model.application.get("locale"), 'manager.shclustering.settings.menu');
                this.$(Modal.BODY_SELECTOR).append('<a href="' + docLink + '" class="external" target="_blank">' + _('Learn more about configuration changes under search head clustering').t() + '</a>');

                this.$(Modal.FOOTER_SELECTOR).append(Modal.BUTTON_CANCEL);
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn btn-primary modal-btn-primary pull-right" data-dismiss="modal">' + _('Show').t() + '</a>');
                return this;
            },
            submit: function() {
                $.when(this.collection.managers.showMore()).then(function() {
                    this.collection.sections.reset();
                }.bind(this));
            }
        });
    }
);
