define(
[
    'underscore',
    'jquery',
    'module',
    'views/shared/PopTart',
    'views/shared/splunkbar/find/ProgressSpinner',
    'uri/route',
    'splunk.util'
],
function(
    _,
    $,
    module,
    PopTartView,
    ProgressSpinner,
    route,
    splunkUtils
){
    return PopTartView.extend({
        moduleId: module.id,
        className: 'dropdown-menu',
        initialize: function() {
            PopTartView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            this.el.innerHTML = PopTartView.prototype.template_menu;
            
            // Open "keyword" in new search
            var searchLink = route.search(
                    this.model.application.get('root'),
                    this.model.application.get('locale'),
                    'search',
                    {data: {q: this.model.state.get('rawSearch')}}
                );
                
            var html = this.compiledTemplate({
                _: _,
                splunkUtils: splunkUtils,
                searchLink: searchLink,
                rawSearch: this.model.state.get('rawSearch')
            });
            this.$el.append(html);

            this.children.spinner = new ProgressSpinner();
            this.$('.findbar-results-spinner').append(this.children.spinner.render().el);
            
            return this;
        },
        template: '\
        <div class="findbar-results-spinner"></div>\
        <ul><li>\
            <a class="primary-link search-link" href="<%- searchLink %>">\
                <i class="icon-search-thin findbar-results-icon"></i>\
                <%- splunkUtils.sprintf(_("Open %s in search").t(), rawSearch) %>\
            </a>\
            <a class="secondary-link search-link" href="<%- searchLink %>" target="_blank">\
                <i class="icon-external"></i>\
            </a>\
        </li></ul>\
        '
    });
});