define(
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/find/results/AlertResults.html', 
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    alertResultsTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: alertResultsTemplate,
        className: 'alertResults',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            var html = this.compiledTemplate({
                _: _,
                alerts: this.collection.alerts,
                app: this.model.application,
                route: route,
                search: this.model.state.get('search') || '',
                rawSearch: this.model.rawSearch.get('rawSearch') || '',
                apps: this.collection.apps,
                alternateApp: this.options.alternateApp
            });
            
            this.$el.html(html);
            return this;
        }
    });
});