define(
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/find/results/DataModelResults.html', 
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    dataModelResultsTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: dataModelResultsTemplate,
        className: 'dataModelResults',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            var appRoot = this.model.application.get('root'),
                appLocale = this.model.application.get('locale'),
                managerApp = (this.model.application.get('app') === 'system') ? 'launcher' : this.model.application.get('app');
            var html = this.compiledTemplate({
                _: _,
                datamodels: this.collection.datamodels,
                route: route,
                search: this.model.state.get('search') || '',
                rawSearch: this.model.rawSearch.get('rawSearch') || '',
                appRoot: appRoot,
                appLocale: appLocale,
                managerApp: managerApp,
                apps: this.collection.apps,
                alternateApp: this.options.alternateApp
            });
            
            this.$el.html(html);
            return this;
        }
    });
});