define(
    [
        'underscore',
        'jquery',
        'module',
        'views/Base',
        'views/shared/vizcontrols/custom_controls/BubbleMinSizeControlGroup',
        'views/shared/vizcontrols/custom_controls/BubbleMaxSizeControlGroup'
    ],
    function(
        _, 
        $,
        module, 
        Base,
        BubbleMinSizeControlGroup,
        BubbleMaxSizeControlGroup
    ){
        return Base.extend({
            moduleId: module.id,
            className: 'form form-horizontal',
            vizToLegendComponents: {
                line:    [],
                bar:     [],
                area:    [],
                column:  [],
                scatter: [],
                bubble: ['minSize', 'maxSize'],
                pie: [],
                radialGauge: [],
                fillerGauge: [],
                markerGauge: [],
                single: [],
                events: [],
                statistics: [] 
            },
            initialize: function(options) {
                Base.prototype.initialize.apply(this, arguments);
                var controls = this.vizToLegendComponents[this.model.get('viz_type')];
                
                if(_.indexOf(controls, 'minSize')>-1) {
                    this.children.minSize = new BubbleMinSizeControlGroup({
                        model: this.model,
                        controlClass: 'controls-block'
                    });
                }
                if(_.indexOf(controls, 'maxSize')>-1) {
                    this.children.maxSize = new BubbleMaxSizeControlGroup({
                        model: this.model,
                        controlClass: 'controls-block'
                    });
                }
            },
            render: function() {
                this.children.minSize && this.children.minSize.render().appendTo(this.$el);
                this.children.maxSize && this.children.maxSize.render().appendTo(this.$el);
                this.children.sizeBy && this.children.sizeBy.render().appendTo(this.$el);
                return this;
            }
        });
    }
);
