define([
            'underscore',
            'module',
            'views/shared/controls/ControlGroup'
        ],
        function(
            _,
            module,
            ControlGroup
        ) {
    
    return ControlGroup.extend({
    
        moduleId: module.id,
    
        /**
         * @constructor
         * @param options {Object} {
         *     model {Model} the model to operate on
         *     axisType {axisX | axisY | axisY2} the charting attribute namespace
         * }
         */

        initialize: function() {
            this.options.label = this.options.label || _("Enabled").t();
            this.options.controlType = 'SyntheticRadio';
            this.options.controlOptions = {
                modelAttribute: 'display.visualizations.charting.' + this.options.axisType + '.enabled',
                model: this.model,
                className: 'btn-group',
                items: [
                    {
                        label: _("Off").t(),
                        value: '0'
                    },
                    {
                        label: _("On").t(),
                        value: '1'
                    }
                ]
            };
            ControlGroup.prototype.initialize.call(this, this.options);
        }
    },
    {
        X_AXIS: 'axisX',
        Y_AXIS: 'axisY',
        Y_AXIS_2: 'axisY2'
    });
    
});