define([
            'underscore',
            'module',
            'views/shared/controls/ControlGroup'
        ],
        function(
            _,
            module,
            ControlGroup
        ) {

    return ControlGroup.extend({

        moduleId: module.id,

        initialize: function() {
            this.options.label = _("Label Truncation").t();
            this.options.controlType = 'SyntheticRadio';
            this.options.controlOptions = {
                modelAttribute: 'display.visualizations.charting.' + this.options.axisType + '.majorLabelStyle.overflowMode',
                model: this.model,
                className: 'btn-group',
                items: [
                    {
                        label: _("Yes").t(),
                        value: "ellipsisMiddle"
                    },
                    {
                        label: _("No").t(),
                        value: "ellipsisNone"
                    }
                ]
            };
            ControlGroup.prototype.initialize.call(this, this.options);
        }

    },
    {
        X_AXIS: 'axisLabelsX',
        Y_AXIS: 'axisLabelsY',
        Y_AXIS_2: 'axisLabelsY2'
    });

});
