define([
            'jquery',
            'underscore',
            'module',
            'views/shared/controls/ControlGroup'
        ],
        function(
            $,
            _,
            module,
            ControlGroup
        ) {

    return ControlGroup.extend({

        moduleId: module.id,

        initialize: function() {
            this.options.label = _("Label Rotation").t();
            this.options.controlType = 'SyntheticRadio';
            this.options.controlOptions = {
                modelAttribute: 'display.visualizations.charting.' + this.options.axisType + '.majorLabelStyle.rotation',
                model: this.model,
                items: [
                    {
                        value: '-90', 
                        icon: 'label-rotation--90',
                        tooltip: '-90&deg;'
                    },
                    {
                        value: '-45', 
                        icon: 'label-rotation--45',
                        tooltip: '-45&deg;'
                    },
                    {
                        value: '0', 
                        icon: 'label-rotation-0',
                        tooltip: '0&deg;'
                    },
                    {
                        value: '45', 
                        icon: 'label-rotation-45',
                        tooltip: '45&deg;'
                    },
                    {
                        value: '90', 
                        icon: 'label-rotation-90',
                        tooltip: '90&deg;'
                    }
                ],
                className: 'btn-group'
            };

            ControlGroup.prototype.initialize.call(this, this.options);
        }

    }, 
    {
        X_AXIS: 'axisLabelsX',
        Y_AXIS: 'axisLabelsY',
        Y_AXIS_2: 'axisLabelsY2'
    });


});
