define([
            'underscore',
            'module',
            'views/shared/controls/ControlGroup'
        ],
        function(
            _,
            module,
            ControlGroup
        ) {

    /**
     * @constructor
     * @param options {Object} {
     *     model {Model} the model to operate on
     *     axisType {axisX | axisY | axisY2} the charting attribute namespace
     * }
     */

    return ControlGroup.extend({

        moduleId: module.id,

        initialize: function() {
            this.options.label = _("Min Value").t();
            this.options.controlType = 'Text';
            this.options.controlOptions = {
                modelAttribute: 'display.visualizations.charting.' + this.options.axisType + '.minimumNumber',
                model: this.model,
                placeholder: _("optional").t(),
                inputClassName: 'input-medium'
            };
            ControlGroup.prototype.initialize.call(this, this.options);
        }

    },
    {
        X_AXIS: 'axisX',
        Y_AXIS: 'axisY',
        Y_AXIS_2: 'axisY2'
    });

});
