define([
            'underscore',
            'module',
            'views/shared/controls/ControlGroup'
        ],
        function(
            _,
            module,
            ControlGroup
        ) {

    return ControlGroup.extend({

        moduleId: module.id,

        /**
         * @constructor
         * @param options {Object} {
         *     model {Model} the model to operate on
         *     axisType {axisX | axisY | axisY2} the charting attribute namespace
         * }
         */

        initialize: function() {
            this.options.label = _("Scale").t();
            this.options.controlType = 'SyntheticRadio';
            var items = [
                {
                    label: _("Linear").t(),
                    value: 'linear'
                },
                {
                    label: _("Log").t(),
                    value: 'log'
                }
            ];
            if(this.options.supportInherit) {
                items.unshift({
                    label: _("Inherit").t(),
                    value: 'inherit'
                });
            }
            this.options.controlOptions = {
                modelAttribute: 'display.visualizations.charting.' + this.options.axisType + '.scale',
                model: this.model,
                className: 'btn-group locale-responsive-layout',
                items: items
            };
            ControlGroup.prototype.initialize.call(this, this.options);
        }

    },
    {
        X_AXIS: 'axisX',
        Y_AXIS: 'axisY',
        Y_AXIS_2: 'axisY2'
    });

});
