define([
            'underscore',
            'module',
            'views/shared/controls/ControlGroup'
        ],
        function(
            _,
            module,
            ControlGroup
        ) {

    return ControlGroup.extend({

        moduleId: module.id,

        initialize: function() {
            this.options.label = _("Url").t();
            this.options.controlType = 'Textarea';
            this.options.help = _('The URL to use for requesting tiles, ex: <br /> http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png').t();
            this.options.controlOptions = {
                modelAttribute: 'display.visualizations.mapping.tileLayer.url',
                model: this.model,
                className: 'control controls-block'
            };
            ControlGroup.prototype.initialize.call(this, this.options);
        }

    });

});
