define([
            'jquery',
            'underscore',
            'module',
            'views/shared/controls/PercentTextControl',
            'views/shared/controls/ControlGroup'
        ],
        function(
            $,
            _,
            module,
            PercentTextControl,
            ControlGroup
        ) {

    return ControlGroup.extend({

        moduleId: module.id,

        initialize: function() {
            this.options.label = _("Minimum Size").t();
            this.options.controls = [
                new PercentTextControl({
                    model: this.model,
                    modelAttribute: 'display.visualizations.charting.chart.sliceCollapsingThreshold'
                })
            ];
            this.options.help = _('Minimum Size is applied when there are more than 10 slices.').t();
            ControlGroup.prototype.initialize.call(this, this.options);
        }

    });

});
