
define('contrib/text!views/shared/splunkbar/AppMenu.html',[],function () { return '<%\n    currentAppname = currentApp ? currentApp.name : \'search\';   // TODO: search fallback is not always safe assumption\n%>\n<a href="#" class="dropdown-toggle"><%- currentApp ? _(\'App: \').t() + _(currentApp.label).t() : _(\'Apps\').t() %><b class="caret"></b></a>\n<div class="dropdown-menu dropdown-menu-selectable dropdown-menu-tall" id="global-apps-menu">\n    <div class="arrow"></div>\n    <ul class="menu-list">\n        <% _.each(apps, function(i) { %>\n        <li>\n            <a href="<%- i.href %>">\n                <% if (currentApp && i.name === currentApp.name) { %> <i class="icon-check"></i><% } %>\n                <% if (i.icon) { %> <img data-icosrc="<%-i.icon%>" alt="menu icon" class="menu-icon" style="display:none;"><% } %>\n                <span class="menu-label"><%- _(i.label).t() %></span>\n            </a>\n        </li>\n        <% }); %>\n    </ul>\n    <ul>\n        <li><a href="<%- make_url(\'manager\', currentAppname, \'apps\',\'local\') %>"><%- _("Manage Apps").t() %></a></li>\n        <% if(canManageRemoteApps){ %>\n        <li id="findMoreAppsNav"><a href="<%- make_url(\'manager\', currentAppname, \'apps\',\'remote\') %>" ><%- _("Find More Apps").t() %></a></li>\n        <%} %>\n    </ul>\n</div>\n';});

define('views/shared/splunkbar/AppMenu',
    [
        'jquery',
        'module',
        'views/Base',
        'views/shared/delegates/Popdown',
        'splunk.util',
        'contrib/text!views/shared/splunkbar/AppMenu.html',
        'uri/route'
    ],
    function(
        $,
        module,
        BaseView,
        Popdown,
        splunk_util,
        appsTemplate,
        route
    ){
        return BaseView.extend({
            moduleId: module.id,
            template: appsTemplate,
            tagName: 'li',
            className: 'dropdown menu-apps',
            initialize: function() {
                this.haveIcons = false;
                BaseView.prototype.initialize.apply(this, arguments);

                if(this.options.activeMenu && this.options.activeMenu.name === 'app'){
                    this.currentApp = this.model.application.get('app');
                }
                this.collection.apps.on('ready change reset', this.debouncedRender, this);
                this.model.user.on('ready change', this.debouncedRender, this);
                // handle the case when collection.apps is already set
                if (this.collection.apps.length > 0) {
                    this.debouncedRender();
                }
            },
            render: function() {
                this.haveIcons = false;
                var that = this,
                    app,
                    curApp = null,
                    apps = this.collection.apps.map(function(model, key, list) {
                        var appIcon = route.appIconAlt(
                            that.model.application.get('root'),
                            that.model.application.get('locale'),
                            that.model.application.get('owner'),
                            model.entry.get('name')
                        );

                        app = {
                            href: splunk_util.make_url('/app/'+ model.entry.get('name')),
                            label: model.entry.content.get('label'),
                            name: model.entry.get('name'),
                            icon: appIcon
                        };
                        if(model.entry.get('name') === that.currentApp) {
                            curApp = app;
                        }
                        return app;
                    }).filter(function(app) {
                        // we don't want to display either the management console or launcher
                        return (app.name !== "splunk_management_console" &&
                                app.name !== "launcher");
                    }),

                    html = this.compiledTemplate({
                        apps: apps,
                        currentApp: curApp,
                        make_url: splunk_util.make_url,
                        canManageRemoteApps: that.model.user.canManageRemoteApps()
                    });

                this.$el.html(html);
                this.popdown = new Popdown({el:this.$('#global-apps-menu').parent(), mode: 'dialog'});
                this.popdown.on('show', this.setIcons, this);
                return this;
            },
            setIcons: function() {
                if(this.haveIcons){
                    return;
                }
                this.haveIcons = true;
                var icons = this.$el.find('.menu-icon');
                icons.each(function(index, ico){
                    ico = $(ico);
                    ico.attr('src', ico.attr('data-icosrc')).show();
                });
            }
        });
    });

define('contrib/text!views/shared/splunkbar/SystemMenuSection.html',[],function () { return '<i class="icon icon-<%-this.model.get(\'icon\')%>"></i>\n<h5><%=this.model.get(\'label\')%></h5>\n<ul class="menu">\n    <% var addedItems = []; %>\n    <%_.each(this.model.get(\'items\'), function(item, i){ %>\n        <% if(_.indexOf(addedItems, item.entry.content.get(\'menu.label\')) === -1) {%>    \n            <li><a href="<%-item.get(\'url\')%>"><%-_(item.entry.content.get(\'menu.label\')).t() || _(item.entry.get(\'name\')).t() || \'\'%></a></li>\n            <% addedItems.push(item.entry.content.get(\'menu.label\')); %>\n        <%}%>\n    <%});%>\n</ul>\n';});

define('views/shared/splunkbar/SystemMenuSection',[
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/SystemMenuSection.html'
],
function(
    $,
    _,
    module,
    BaseView,
    systemMenuSectionTemplate
){
    return BaseView.extend({
        moduleId: module.id,
        template: systemMenuSectionTemplate,
        className: 'menu-section',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            var itemsArray = this.model.get('items');
            itemsArray.sort(function(a,b){
                return parseInt(a.get('order'), 10) - parseInt(b.get('order'), 10);
            });
        },
        render: function() {
            var html = this.compiledTemplate(this.model);
            this.$el.html(html);
            return this;
        }
    });
});
define('views/shared/splunkbar/SystemMenuModal',
    [
         'jquery',
         'underscore',
         'module',
         'views/Base',
         'views/shared/Modal',
         'uri/route'
     ],
     function($, _, module, Base, Modal, route) {
        return Modal.extend({
            moduleId: module.id,
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);
            },
            events: $.extend({}, Modal.prototype.events, {
                "click .modal-btn-primary": function(e) {
                    e.preventDefault();
                    this.submit();
                }
            }),
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html(_("Show All Settings").t());
                this.$(Modal.BODY_SELECTOR).append(Modal.FORM_HORIZONTAL);

                this.$(Modal.BODY_SELECTOR).append(_('Because search head clustering is enabled, some sections of the settings menu are hidden. Do you wish to re-enable the full settings menu?').t());
                this.$(Modal.BODY_SELECTOR).append(_('<br><br>').t());
                this.$(Modal.BODY_SELECTOR).append(_('Note that system settings modified via re-enabled menus will not be replicated across your search head cluster.').t());
                this.$(Modal.BODY_SELECTOR).append(_('<br><br>').t());

                var docLink = route.docHelp(this.model.application.get("root"), this.model.application.get("locale"), 'manager.shclustering.settings.menu');
                this.$(Modal.BODY_SELECTOR).append('<a href="' + docLink + '" class="external" target="_blank">' + _('Learn more about configuration changes under search head clustering').t() + '</a>');

                this.$(Modal.FOOTER_SELECTOR).append(Modal.BUTTON_CANCEL);
                this.$(Modal.FOOTER_SELECTOR).append('<a href="#" class="btn btn-primary modal-btn-primary pull-right" data-dismiss="modal">' + _('Show').t() + '</a>');
                return this;
            },
            submit: function() {
                $.when(this.collection.managers.showMore()).then(function() {
                    this.collection.sections.reset();
                }.bind(this));
            }
        });
    }
);

define('contrib/text!views/shared/splunkbar/SystemMenu.html',[],function () { return '<a href="#" class="dropdown-toggle"><%- _("Settings").t() %><b class="caret"></b></a>\n<div class="popdown-dialog mega-menu" id="global-system-menu">\n    <div class="arrow"></div>\n    \n    <% if(userCanAddData || userCanExploreData || managementConsoleAvailable) { %>\n    <div class="mega-menu-sidebar">\n\t\t<% if(userCanAddData) { %>\n\t    \t<a href="<%= addDataURL %>" class="mega-menu-sidebar-bar-link">\n\t            <svg width="52px" height="52px" viewBox="0 0 52 52" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns">\n\t                <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">\n\t                    <g id="AddData" sketch:type="MSLayerGroup" transform="translate(1.000000, 1.000000)">\n\t                        <path d="M50,25 C50,38.808 38.807,50 25,50 C11.193,50 0,38.808 0,25 C0,11.193 11.193,0 25,0 C38.807,0 50,11.193 50,25 L50,25 Z" id="Stroke-2" stroke="#65A637" stroke-width="2" sketch:type="MSShapeGroup"></path>\n\t                        <path d="M28.714,25.72 C28.908,25.914 28.908,26.233 28.714,26.427 L24.473,30.668 C24.278,30.863 23.96,30.863 23.766,30.668 L19.524,26.42 C19.329,26.225 19.33,25.907 19.525,25.714 L19.831,25.41 C20.027,25.216 20.346,25.217 20.54,25.411 L23.052,27.923 C23.246,28.117 23.405,28.051 23.406,27.776 L23.413,17.866 C23.413,17.591 23.638,17.366 23.913,17.366 L24.34,17.366 C24.615,17.366 24.84,17.591 24.84,17.866 L24.833,27.776 C24.833,28.051 24.992,28.117 25.186,27.923 L27.698,25.411 C27.892,25.217 28.21,25.217 28.405,25.411 L28.714,25.72" id="Fill-4" fill="#65A637" sketch:type="MSShapeGroup"></path>\n\t                        <path d="M24,11 C17.3722529,11 12,12.5669725 12,14.5 C12,16.4330275 17.3722529,18 24,18 C30.6277471,18 36,16.4330275 36,14.5 C36,12.5669725 30.6277471,11 24,11 Z M35,14.4994903 C35,15.8807339 30.0760127,17 24.0005046,17 C17.9249966,17 13,15.8807339 13,14.4994903 C13,13.1192661 17.9249966,12 24.0005046,12 C30.0760127,12 35,13.1192661 35,14.4994903 Z" id="Path" fill="#65A637" sketch:type="MSShapeGroup"></path>\n\t                        <path d="M13.0000071,34.0049738 C13.0000024,34.0038246 13,34.0026752 13,34.0015257 C13.0257725,33.9752197 35,34.0015257 35,34.0015257 C35,34.0033372 34.9999941,34.0051484 34.9999824,34.0069591 C35.6381395,34.0050728 36.0014311,34.0027682 36,34 C36,36.210102 30.6277471,38 24,38 C17.3722529,38 12,36.210102 12,34 C12.0013058,34.0017685 12.3642568,34.0034414 13.0000071,34.0049738 Z M13.0000071,34.0049738 C13.0068329,35.6606217 17.9292108,37.002 24.0005046,37.002 C30.0693715,37.002 34.9892338,35.6616939 34.9999824,34.0069591 C31.09585,34.0184994 16.9041198,34.0143844 13.0000071,34.0049738 Z" id="Fill-7" fill="#65A637" sketch:type="MSShapeGroup"></path>\n\t                        <rect id="Rectangle-1" fill="#65A637" sketch:type="MSShapeGroup" x="12" y="14.5" width="1" height="19.5"></rect>\n\t                        <rect id="Rectangle-2" fill="#65A637" sketch:type="MSShapeGroup" x="35" y="14.5" width="1" height="19.5"></rect>\n\t                    </g>\n\t                </g>\n\t            </svg>\n\t            <%- _("Add Data").t() %>\n\t        </a>\n\t\t<% } %>\n\n        <% if(userCanExploreData) { %>\n        <a href="<%= exploreDataURL %>" class="mega-menu-sidebar-bar-link">\n            <svg width="52px" height="52px" viewBox="0 0 52 52" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns">\n                <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">\n                    <g id="AddData" sketch:type="MSLayerGroup" transform="translate(1.000000, 1.000000)">\n                        <path d="M50,25 C50,38.808 38.807,50 25,50 C11.193,50 0,38.808 0,25 C0,11.193 11.193,0 25,0 C38.807,0 50,11.193 50,25 L50,25 Z" id="Stroke-2" stroke="#65A637" stroke-width="2" sketch:type="MSShapeGroup"></path>\n                        <path transform="translate(13.00000, 17.500000)"  d="M8.77311574,5.419 C7.96336667,5.3545 7.15461852,5.263 6.34937361,5.1435 L6.34937361,6.583 C7.15461852,6.702 7.96336667,6.794 8.77311574,6.8585 L8.77311574,5.419 L8.77311574,5.419 Z M1.56644907,7.696 C1.04146343,7.543 0.518980093,7.3775 0,7.2 L0,8.64 C0.518980093,8.818 1.04146343,8.983 1.56644907,9.136 L1.56644907,7.696 L1.56644907,7.696 Z M6.34937361,8.743 C5.5441287,8.6235 4.74188657,8.4765 3.94414861,8.3025 L3.94414861,9.7425 C4.74188657,9.917 5.5441287,10.064 6.34937361,10.1835 L6.34937361,8.743 L6.34937361,8.743 Z M18.4825977,8.4675 C15.2801352,9.092 12.0136134,9.276 8.77311574,9.0185 L8.77311574,10.459 C12.0136134,10.716 15.2801352,10.5325 18.4825977,9.908 L18.4825977,8.4675 L18.4825977,8.4675 Z M23.2259856,7.2 C22.4472653,7.4665 21.6615384,7.705 20.8703065,7.9165 L20.8703065,9.3565 C21.6615384,9.1455 22.4472653,8.9065 23.2259856,8.64 L23.2259856,7.2 L23.2259856,7.2 Z M23.2259856,3.6005 C21.9282852,4.044 20.6110667,4.4115 19.2813366,4.7025 L19.2813366,6.142 C20.6110667,5.851 21.9282852,5.4835 23.2259856,5.04 L23.2259856,3.6005 L23.2259856,3.6005 Z M16.8761116,5.1435 C14.9973736,5.422 13.1016199,5.5505 11.2068671,5.529 L11.2068671,6.9685 C13.1016199,6.99 14.9973736,6.8615 16.8761116,6.583 L16.8761116,5.1435 L16.8761116,5.1435 Z M23.2259856,14.401 C21.4088046,15.0225 19.5545894,15.494 17.6803556,15.8155 L17.6803556,17.2555 C19.5545894,16.934 21.4088046,16.4625 23.2259856,15.841 L23.2259856,14.401 L23.2259856,14.401 Z M15.2621185,16.146 C10.1398801,16.6695 4.9320625,16.088 0,14.401 L0,15.841 C4.9320625,17.528 10.1398801,18.11 15.2621185,17.5865 L15.2621185,16.146 L15.2621185,16.146 Z M23.2259856,0 C21.4088046,0.6215 19.5545894,1.093 17.6803556,1.4145 L17.6803556,2.8545 C19.5545894,2.533 21.4088046,2.0615 23.2259856,1.44 L23.2259856,0 L23.2259856,0 Z M15.2621185,1.745 C13.9138713,1.8825 12.560119,1.944 11.2068671,1.9285 L11.2068671,3.369 C12.560119,3.384 13.9138713,3.323 15.2621185,3.185 L15.2621185,1.745 L15.2621185,1.745 Z M8.77311574,1.8185 C5.80286806,1.5825 2.8551412,0.9765 0,0 L0,1.44 C2.8551412,2.4165 5.80286806,3.023 8.77311574,3.2585 L8.77311574,1.8185 L8.77311574,1.8185 Z M3.94414861,4.7025 C2.61491898,4.4115 1.29770046,4.044 0,3.6005 L0,5.04 C1.29770046,5.484 2.61491898,5.851 3.94414861,6.142 L3.94414861,4.7025 L3.94414861,4.7025 Z M5.54512963,12.215 C3.6713963,11.8935 1.81718102,11.422 0,10.8005 L0,12.241 C1.81718102,12.862 3.6713963,13.334 5.54512963,13.655 L5.54512963,12.215 L5.54512963,12.215 Z M12.0191185,12.7295 C10.6658667,12.7445 9.31161389,12.6835 7.96386713,12.5455 L7.96386713,13.986 C9.31161389,14.1235 10.6658667,14.185 12.0191185,14.1695 L12.0191185,12.7295 L12.0191185,12.7295 Z M14.4523694,14.0595 L14.4523694,12.619 C17.4226171,12.3835 20.370344,11.777 23.2259856,10.8005 L23.2259856,12.241 C20.370344,13.2175 17.4226171,13.8235 14.4523694,14.0595 Z" id="Imported-Layers" fill="#65A637" sketch:type="MSShapeGroup"></path>\n                        <path d="M24,11 C17.3722529,11 12,12.5669725 12,14.5 C12,16.4330275 17.3722529,18 24,18 C30.6277471,18 36,16.4330275 36,14.5 C36,12.5669725 30.6277471,11 24,11 Z M35,14.4994903 C35,15.8807339 30.0760127,17 24.0005046,17 C17.9249966,17 13,15.8807339 13,14.4994903 C13,13.1192661 17.9249966,12 24.0005046,12 C30.0760127,12 35,13.1192661 35,14.4994903 Z" id="Path" fill="#65A637" sketch:type="MSShapeGroup"></path>\n                        <path d="M13.0000071,34.0049738 C13.0000024,34.0038246 13,34.0026752 13,34.0015257 C13.0257725,33.9752197 35,34.0015257 35,34.0015257 C35,34.0033372 34.9999941,34.0051484 34.9999824,34.0069591 C35.6381395,34.0050728 36.0014311,34.0027682 36,34 C36,36.210102 30.6277471,38 24,38 C17.3722529,38 12,36.210102 12,34 C12.0013058,34.0017685 12.3642568,34.0034414 13.0000071,34.0049738 Z M13.0000071,34.0049738 C13.0068329,35.6606217 17.9292108,37.002 24.0005046,37.002 C30.0693715,37.002 34.9892338,35.6616939 34.9999824,34.0069591 C31.09585,34.0184994 16.9041198,34.0143844 13.0000071,34.0049738 Z" id="Fill-7" fill="#65A637" sketch:type="MSShapeGroup"></path>\n                        <rect id="Rectangle-1" fill="#65A637" sketch:type="MSShapeGroup" x="12" y="14.5" width="1" height="19.5"></rect>\n                        <rect id="Rectangle-2" fill="#65A637" sketch:type="MSShapeGroup" x="35" y="14.5" width="1" height="19.5"></rect>\n                    </g>\n                </g>\n            </svg>\n            <%- _("Explore Data").t() %>\n        </a>\n        <% } %>\n\t\t\n\t\t<% if(managementConsoleAvailable) { %>\n\t    \t<a href="<%= managementConsoleURL %>" class="mega-menu-sidebar-bar-link">\n\t            <svg width="52px" height="52px" viewBox="0 0 52 52" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns">\n\t                <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">\n\t                    <path d="M51,26 C51,39.808 39.807,51 26,51 C12.193,51 1,39.808 1,26 C1,12.193 12.193,1 26,1 C39.807,1 51,12.193 51,26 L51,26 Z" id="Stroke-2" stroke="#65A637" stroke-width="2" sketch:type="MSShapeGroup"></path>\n\t                    <path d="M22.841066,29.158934 C23.7354338,30.0523306 24.7832326,30.5 26,30.5 C28.4199396,30.5 30.5,28.4189685 30.5,26 C30.5,23.5800604 28.4199396,21.5 26,21.5 C23.5810315,21.5 21.5,23.5800604 21.5,26 C21.5,27.2167674 21.9476694,28.2645662 22.841066,29.158934 L22.841066,29.158934 Z M34.6807156,28.1586387 C34.5705253,28.1586387 34.3809185,28.3313695 34.3809185,28.4574431 L33.6721265,30.1907074 C33.5937028,30.3326643 33.5937028,30.4746213 33.6721265,30.6155855 L34.97952,32.9474513 C35.0579438,33.1211748 35.0430532,33.2472485 34.9169796,33.3097889 L33.3097889,34.9169796 C33.2472485,35.0430532 33.1201821,35.0589365 32.9474513,34.97952 L30.6155855,33.6721265 C30.4736286,33.5937028 30.3316716,33.5937028 30.1907074,33.6721265 L28.3949027,34.3809185 C28.1894126,34.4911088 28.0951055,34.5864086 28.0951055,34.6807156 L27.4339635,37.2488454 C27.4339635,37.3739264 27.26024,37.5 27.1341663,37.5 L24.8658337,37.5 C24.7238767,37.5 24.6295697,37.4215762 24.5660365,37.2488454 L23.9048945,34.6807156 C23.9048945,34.5864086 23.8105874,34.4911088 23.6050973,34.3809185 L21.7467521,33.6095861 C21.6047952,33.5301696 21.4628383,33.5301696 21.3208814,33.6095861 L19.0525487,34.97952 C18.8788252,35.0589365 18.7537442,35.0430532 18.6902111,34.9169796 L17.0830204,33.3097889 C16.9569468,33.2472485 16.9420562,33.1211748 17.02048,32.9474513 L18.3914066,30.6791186 C18.4698304,30.5371617 18.4698304,30.3952048 18.3914066,30.2532479 L17.6190815,28.3949027 C17.5088912,28.1904053 17.4145841,28.0951055 17.3192844,28.0951055 L14.7521473,27.4339635 C14.5784238,27.3704303 14.5,27.2761233 14.5,27.1341663 L14.5,24.8658337 C14.5,24.7238767 14.5784238,24.6295697 14.7521473,24.5670292 L17.3192844,23.9048945 C17.4145841,23.9048945 17.5088912,23.8105874 17.6190815,23.60609 L18.3914066,21.7467521 C18.4698304,21.6047952 18.4698304,21.4628383 18.3914066,21.3208814 L17.02048,19.0525487 C16.9420562,18.8798179 16.9569468,18.7537442 17.0830204,18.6902111 L18.6902111,17.0840131 C18.7537442,16.9579395 18.8788252,16.9420562 19.0525487,17.02048 L21.3208814,18.3914066 C21.4628383,18.4698304 21.6047952,18.4698304 21.7467521,18.3914066 L23.5425569,17.6190815 C23.6686305,17.6190815 23.8413613,17.4304674 23.8413613,17.3202771 L24.5660365,14.7521473 C24.5660365,14.6260736 24.73976,14.5 24.8658337,14.5 L27.1341663,14.5 C27.26024,14.5 27.4339635,14.6260736 27.4339635,14.7521473 L28.1586387,17.3202771 C28.1586387,17.4304674 28.3313695,17.6190815 28.4574431,17.6190815 L30.1907074,18.3278735 C30.3316716,18.4072899 30.4736286,18.4072899 30.6155855,18.3278735 L32.9474513,17.02048 C33.1201821,16.9420562 33.2472485,16.9579395 33.3097889,17.0840131 L34.9169796,18.6902111 C35.0430532,18.7537442 35.0579438,18.8798179 34.97952,19.0525487 L33.6721265,21.3844145 C33.5937028,21.5263714 33.5937028,21.6683284 33.6721265,21.8092926 L34.3809185,23.5425569 C34.3809185,23.6686305 34.5705253,23.842354 34.6807156,23.842354 L37.2478527,24.5670292 C37.3739264,24.5670292 37.5,24.73976 37.5,24.8658337 L37.5,27.1341663 C37.5,27.26024 37.3739264,27.4339635 37.2478527,27.4339635 L34.6807156,28.1586387 Z" id="Stroke-4" stroke="#65A637" sketch:type="MSShapeGroup"></path>\n\t                    <path d="M40.091,35.629 C40.552,35.913 40.782,36.197 40.782,36.496 L40.782,37.617 L29.576,37.617 L29.576,36.496 C29.576,36.366 29.645,36.235 29.783,36.12 C29.913,36.005 30.121,35.875 30.389,35.714 C30.95,35.391 31.61,35.092 32.377,34.816 C33.114,34.562 33.467,34.401 33.736,34.148 C34.005,33.895 34.058,33.634 34.058,33.15 C33.145,32.329 32.377,30.901 32.377,29.773 C32.377,27.585 33.452,26.411 35.179,26.411 C36.906,26.411 37.98,27.585 37.98,29.773 C37.98,30.901 37.213,32.329 36.3,33.15 C36.3,34.048 36.561,34.271 37.98,34.816 C38.134,34.869 38.886,35.13 39.162,35.23 C39.439,35.33 39.884,35.506 40.091,35.629" id="Fill-5" fill="#65A637" sketch:type="MSShapeGroup"></path>\n\t                </g>\n\t            </svg>\n\t            <%- _("Distributed Management Console").t() %>\n\t        </a>\n\t\t<% } %>\n    </div>\n    <% } %>\n    \n    <div class="popdown-dialog-body">\n    </div><!-- /.popdown-dialog-body -->\n    <div class="popdown-dialog-footer" style="display: none;">\n        <a href="#" class="show-all-sections btn pull-right"><%- _("Show All Settings").t() %></a>\n    </div>\n</div><!-- /.podown -->\n';});

define('views/shared/splunkbar/SystemMenu',[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'splunk.util',
    'util/string_utils',
    'views/Base',
    'views/shared/delegates/Popdown',
    'views/shared/splunkbar/SystemMenuSection',
    'views/shared/splunkbar/SystemMenuModal',
    'uri/route',
    'contrib/text!views/shared/splunkbar/SystemMenu.html'
],
function(
    $,
    _,
    Backbone,
    module,
    splunk_util,
    string_utils,
    BaseView,
    Popdown,
    SystemMenuSection,
    SystemMenuModal,
    route,
    systemMenuTemplate
){
    return BaseView.extend({
        moduleId: module.id,
        template: systemMenuTemplate,
        tagName: 'li',
        className: 'dropdown menu-system',
        initialize: function() {
            var self = this;
            BaseView.prototype.initialize.apply(this, arguments);
            self.debouncedRender();
            this.collection.sections.on('ready', function(){
                self.debouncedRender();
            }, this);
        },
        events: {
            'click .show-all-sections': 'showAllSections'
        },
        render: function() {
            var root = this.model.application.get('root');
            var locale = this.model.application.get('locale');
            var app = this.model.application.get('app');
            var managementConsoleApp = this.collection.apps.findByEntryName('splunk_management_console');
            var managementConsoleAvailable = (managementConsoleApp && !managementConsoleApp.entry.content.get("disabled"));
            var html = this.compiledTemplate({
                userCanAddData:
                    this.model.user.canAddData() &&
                    this.collection.managers.findByEntryName('adddata'),
                addDataURL: route.addData(root, locale, app),
                userCanExploreData: this.model.user.canExploreData(),
                exploreDataURL: route.exploreData(root, locale, app),
                managementConsoleAvailable: managementConsoleAvailable,
                managementConsoleURL: route.managementConsole(root, locale)
            });
            var $html = $(html);
            var $menu = $html.find('.popdown-dialog-body');
                
            this.addSections($menu);
            if(this.sectionCount < 2) {
                $menu.parent().addClass('mega-menu-narrow');
            }

            var $footer = $html.find('.popdown-dialog-footer');
            if (this.collection.managers.canShowMore()) {
                $footer.show();
            } else {
                $footer.hide();
            }

            this.$el.html($html);
            
            var popup = this.$el.find('#global-system-menu');
            this.children.popdown = new Popdown({el:popup.parent(), mode: 'dialog'});

            return this;
        },
        addSections: function($menu){
            var self = this;
            this.sectionCount = 0;
            this.collection.sections.each(function(section){
                if (section.get('items') && section.get('items').length === 0) {
                    return;
                }
                var sectionView = self.children[section.get('id')] = new SystemMenuSection({
                    model: section
                });
                
                self.sectionCount++;
                $menu.append(sectionView.render().el);
            });
        },
        showAllSections: function(evt) {
            this.children.dialog = new SystemMenuModal({
                collection: {
                    managers: this.collection.managers,
                    sections: this.collection.sections
                },
                model: {
                    application: this.model.application
                },
                onHiddenRemove: true
            });
            this.children.popdown.hide();
            this.modalWrapper = $('<div class="splunk-components"></div>').appendTo($("body"));
            this.modalWrapper.append(this.children.dialog.render().el);
            this.children.dialog.show();
        }
    });
});

define('contrib/text!views/shared/splunkbar/UserMenu.html',[],function () { return '<a href="#" class="dropdown-toggle"><span class="realname"><%-realName%></span><b class="caret"></b></a>\n<div class="dropdown-menu dropdown-menu-narrow global-user-menu">\n    <div class="arrow"></div>\n    <ul>\n        <li><a href="<%-accountLink%>" class="edit"><%- _("Edit Account").t() %></a></li>\n        <% if (logoutLink) { %>\n        <li><a href="<%-logoutLink%>" class="logout"><%- _("Logout").t() %></a></li>\n        <% } %>\n    </ul>\n</div>';});

define('views/shared/splunkbar/UserMenu',[
    'underscore',
    'module',
    'views/Base',
    'views/shared/delegates/Popdown',
    'contrib/text!views/shared/splunkbar/UserMenu.html',
    'uri/route'
],
function(
    _,
    module,
    BaseView,
    Popdown,
    userMenuTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: userMenuTemplate,
        tagName: 'li',
        className: 'dropdown user',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.user.on('change', this.render, this);
            this.model.webConf.on('change reset', this.render, this);
            if (this.model.user.entry.get('name')) {
                this.render();
            }
        },
        render: function() {

            var realName = this.model.user.entry.content.get('realname'),
                userName = this.model.user.entry.get('name');
            if (!realName || !realName.length) {
                realName = userName;
            }

            var rootUrl = this.model.application.get('root');
            var locale = this.model.application.get('locale');

            var accountLink = route.manager(
                rootUrl,
                locale,
                this.model.application.get('app'),
                [
                    'authentication',
                    'changepassword',
                    userName
                ],
                {
                    data: { action: 'edit' }
                }
            );
            
            var logoutLink = this.model.config.get('SSO_CREATED_SESSION') ? null : route.logout(rootUrl, locale);
            var html = this.compiledTemplate({
                userName: userName,
                realName: realName,
                accountLink: accountLink,
                logoutLink: logoutLink
            });
            this.$el.html(html);

            var popup = this.$el.find('.global-user-menu');
            this.popdown = new Popdown({el:popup.parent(), mode: 'dialog'});
            return this;
        }
    });
});

define('views/shared/litebar/RestartDialog',
    [
        'jquery',
        'underscore',
        'backbone',
        'module',
        'views/shared/controls/ControlGroup',
        'views/shared/Modal'
    ],
    function($, 
        _, 
        backbone, 
        module, 
        ControlGroup, 
        Modal
    ){
        return Modal.extend({
            moduleId: module.id,
            initialize: function() {
                Modal.prototype.initialize.apply(this, arguments);
            },

            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_SELECTOR).html('<h3>' + _("Restart initiated.").t() + '</h3>');

                this.$(Modal.BODY_SELECTOR).append(Modal.FORM_HORIZONTAL);
                this.$(Modal.BODY_SELECTOR).append(_("Splunk is restarting. Please wait. This may take a few minutes.").t());
            }
        });
    }
);

// splunk bar
define('views/shared/splunkbar/messages/Message',
[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'views/Base',
    'views/shared/litebar/RestartDialog',
    'splunk.util',
    'util/time'
],
function(
    $,
    _,
    Backbone,
    module,
    BaseView,
    RestartDialog,
    splunk_util,
    time_utils
){
    /**
     * View Hierarchy:
     *
     * Messages
     */
    return BaseView.extend({
        moduleId: module.id,

        messageMap: {
            'restart_required': _('Splunk must be restarted for changes to take effect. [[/manager/search/control|Click here to restart from the Manager]].').t()
        },

        messageMapForLite: {
            'restart_required': _('Restart for changes to take effect. [[/manager/search/control|Click here to restart]].').t()
        },

        tagName: 'li',

        isLiteRestart : false,

        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);

            //listen for restart events
            $(document).on('restart_failed', function() {
                this.hideRestartModal();
            }.bind(this));

        },

        events: {
            'click .message-content a' : 'checkRestartForLite'     
        },

        checkRestartForLite: function(e) {
            if (this.isLiteRestart) {
                e.preventDefault();
                if (confirm(_("Are you sure you want to restart Splunk?").t())) {
                    this.showRestartModal();
                    splunk_util.restart_server();
                }
            }
        },

        showRestartModal: function() {
            this.children.restartDialog = new RestartDialog({backdrop: 'static'});
            // Necessary for modal to render correctly in manager.
            $("body").append('<div class="splunk-components restartModal"></div>');
            $(".restartModal").append(this.children.restartDialog.render().el);
            this.children.restartDialog.show();
        },
 
        hideRestartModal: function() {
            if (this.children.restartDialog) {
                this.children.restartDialog.hide();
            }
        },

        render: function() {
            var msgFullId = this.model.id,
                msgId = (this.model.entry.get('name')||''),
                msg,
                msgLevel = this.model.entry.content.get('severity') || 'warn',
                contactToken = '$CONTACT_SPLUNK_SALES_TEXT$',
                contactStr = '[http://www.splunk.com/r/getlicense Contact Splunk] (sales@splunk.com or +1.866.GET.SPLUNK) for details on how to renew.',
                contactStrLite = 'To manage your license or to learn how to renew your license go the licensing management page.';

            var isLite = false;
            if (this.options.serverInfo && this.options.serverInfo.isLite()) {
                isLite = true;
            }

            var messageMap = isLite ? this.messageMapForLite : this.messageMap;
            if (msgId && messageMap[msgId]) {
                msg = messageMap[msgId]; 
            } else {
                msg = this.model.entry.content.get("message") || "";
            }

            if (msg.indexOf(contactToken) != -1) {
                msg = msg.replace(contactToken, (isLite) ? contactStrLite : contactStr);
            }

            var msgTime = this.model.entry.content.get("timeCreated_iso");
            if(msgTime){
                var dateObj = time_utils.isoToDateObject(msgTime);
                msgTime = dateObj.toLocaleString();
            }

            var formattedMsg = splunk_util.getWikiTransform(msg);
            if ((msgId == 'restart_required') && isLite) {
                this.isLiteRestart = true;
            }                                                                                             

            var html = this.compiledTemplate({
                msg: formattedMsg,
                msgLevel: msgLevel,
                msgTime: msgTime || ''
            });

            this.$el.html(html);
            this.$el.addClass(msgLevel);
            this.$el.attr('data-id', msgFullId);

            return this;
        },
        template: '<i class="message-icon icon-<%- msgLevel %>"></i>\
                <span class="message-content"><%= msg %></span>\
                <span class="message-time"><%= msgTime %></span>\
                <a href="#" class="delete-message"><i class="icon-x-circle"></i></a>'
    });
});

// splunk bar
define('views/shared/splunkbar/messages/LegacyMessage',
    [
        'jquery',
        'underscore',
        'backbone',
        'module',
        'views/Base',
        'splunk.util'
    ],
    function(
        $,
        _,
        Backbone,
        module,
        BaseView,
        splunk_util
        ){
        /**
         * View Hierarchy:
         *
         * Messages
         */
        return BaseView.extend({
            moduleId: module.id,
            className: 'view-navbar-global navbar navbar-fixed-top',
            messageMap: {
                'restart_required': _('Splunk must be restarted for changes to take effect. [[/manager/search/control|Click here to restart from the Manager]].').t()
            },
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
            },
            render: function() {

                var msgId = (this.model.get('id')||'').toLowerCase(),
                    msg,
                    msgLevel = this.model.get('severity') || 'warn';
                if (msgId && this.messageMap[msgId]) {
                    msg = this.messageMap[msgId];
                } else {
                    msg = this.model.get("content") || "";
                }
                var html = this.compiledTemplate({
                    msgId: msgId,
                    msg: splunk_util.getWikiTransform(msg),
                    msgLevel: msgLevel
                });
                this.$el = $(html);
                return this;
            },
            template: '<li class="<%- msgLevel %>" data-islegacy="1" data-id="<%- msgId %>">\
                <span class="message-content"><%= msg %></span>\
                <a href="#" class="delete-message"><i class="icon-x-circle"></i></a>\
            </li>'
        });
    });

define('contrib/text!views/shared/splunkbar/messages/Master.html',[],function () { return '<a href="#" class="dropdown-toggle">\n    <span class="label label-warning" style="display: none;"><%- collection.length %></span> <%- _("Messages").t() %><b class="caret"></b>\n</a>\n<div class="dropdown-menu" id="global-messages-menu">\n\n    <div class="arrow"></div>\n    <ul class="message-list" style="display: none;">\n    </ul>\n    <div class="no-messages">\n        <%- _("You have no messages.").t() %>\n    </div>\n    <div class="popdown-dialog-footer" style="display: none;">\n        <a href="#" class="delete-all-messages btn pull-right"><%- _("Delete All").t() %></a>\n    </div>\n</div>\n';});

define('views/shared/splunkbar/messages/Master',
    [
        'jquery',
        'underscore',
        'module',
        'views/Base',
        'views/shared/delegates/Popdown',
        'views/shared/delegates/StopScrollPropagation',
        'collections/services/Messages',
        'views/shared/splunkbar/messages/Message',
        'views/shared/splunkbar/messages/LegacyMessage',
        'contrib/text!views/shared/splunkbar/messages/Master.html',
        'util/general_utils'
    ],
    function($, _, module, BaseView, Popdown, StopScrollPropagation, MessagesCollection, MessageView, LegacyMessageView, MasterTemplate, general_utils) {
        return BaseView.extend({
            moduleId: module.id,
            template: MasterTemplate,
            tagName: 'li',
            className: 'dropdown messages',
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
                this.legacyMessages = this.collection.legacyMessages || false;
                this.collection = this.collection.messages;
                this.collection.on('change reset remove', this.renderMessages, this);
                if(this.legacyMessages){
                    this.legacyMessages.on('reset remove', this.renderMessages, this);
                }
                this.isLocalMouseSelection = false;
            },
            events: {
                'click .message-list .delete-message': 'deleteMessage',
                'click .delete-all-messages': 'deleteAllMessages',
                'mouseup .message-list': function() {
                    // this is to stop message refresh only when selection is LOCAL to .message-list
                    this.isLocalMouseSelection = true;
                }
            },
            render: function() {
                //destroy already existing popdowns...
                var html = this.compiledTemplate({collection: this.collection});
                this.$el.html(html);
                this.children.popdown = new Popdown({el:this.el, mode: 'dialog'});
                this.children.stopScrollPropagation = new StopScrollPropagation({el:this.$('#global-messages-menu ul'), mode: 'dialog'});

                return this;
            },
            renderMessages: function(forceUpdate) {
                if(forceUpdate !== true &&
                    this.isLocalMouseSelection &&
                    general_utils.getMouseSelection() && general_utils.getMouseSelection().length>0) {
                    return;
                }
                this.isLocalMouseSelection = false;
                var numMessages = this.collection.length;
                if(this.legacyMessages){
                    numMessages = numMessages + this.legacyMessages.length;
                }

                this.$('.label-warning').text(numMessages);

                //remove existing message children
                _.each(this.children, function(view, key){
                    if (key.substr(0, 7) == 'message') {
                        this.children[key].remove();
                        delete this.children[key];
                    }
                }, this);

                //iterate through collection
                var messageView;

                this.collection.each(function(model, key){
                    //create view
                    var serverInfoModel = (this.model && this.model.serverInfo) ? this.model.serverInfo : {};
                    messageView = new MessageView({model: model, serverInfo: serverInfoModel});
                    this.children['message' + model.get("id")] = messageView;
                    this.$('#global-messages-menu .message-list').append(messageView.render().$el);
                    //bind destruction of model to delete view
                }, this);

                var numLegacyMessages = 0;
                if(this.legacyMessages){
                    numLegacyMessages = this.legacyMessages.length;
                    this.legacyMessages.each(function(model){
                        messageView = new LegacyMessageView({model: model});
                        this.children['messageLegacy' + model.get("id")] = messageView;
                        this.$('#global-messages-menu .message-list').append(messageView.render().$el);
                    }, this);
                }


                if (this.collection.length > 0 || numLegacyMessages > 0) {
                    this.$(".label-warning, .popdown-dialog-footer, .message-list, .message_count_wrapper").show();
                    this.$('#global-messages-menu').addClass('dropdown-menu-wide');
                    this.$(".no-messages").hide();

                    if(this.$('#global-messages-menu').is(':visible')) {
                        this.children.popdown.adjustPosition();
                    }
                } else {
                    this.$(".label-warning, .popdown-dialog-footer, .message-list, .message_count_wrapper").hide();
                    this.$('#global-messages-menu').removeClass('dropdown-menu-wide');
                    this.$(".no-messages").show();
                }

            },
            deleteMessage: function(evt) {
                evt.preventDefault();
                var $li = $(evt.currentTarget).parent();
                var id = $li.data('id');
                var isLegacy = $li.data('islegacy');

                var toRemove;
                if(this.legacyMessages && isLegacy){
                    toRemove = this.legacyMessages.get(id);
                    if(toRemove){
                        this.legacyMessages.remove( toRemove );
                    }
                }else{
                    toRemove = this.collection.get(id);
                    if(toRemove){
                        toRemove.destroy();
                    }
                }

                if (this.collection.length === 0 && (this.legacyMessages === false || this.legacyMessages.length === 0)) {
                    this.children.popdown.hide();
                }

                this.renderMessages(true);
            },
            deleteAllMessages: function(evt) {
                evt.preventDefault();
                this.collection.destroyAll();

                if(this.legacyMessages){
                    this.legacyMessages.reset();
                }
                this.children.popdown.hide();
            }
        });
    }
);

define('contrib/text!views/shared/splunkbar/ActivityMenu.html',[],function () { return '<a href="#" class="dropdown-toggle"><%- _("Activity").t() %><b class="caret"></b></a>\n<div class="dropdown-menu dropdown-menu-narrow" id="global-activity-menu">\n    <div class="arrow"></div>\n    <ul>\n        <li>\n            <a class="primary-link" href="<%= jobLink %>"><%- _("Jobs").t() %></a>\n            <a class="secondary-link" href="<%= jobLink %>" target="_blank"><i class="icon-external"></i></a>\n        </li>\n    <% if (typeof alertsLink !== "undefined" && alertsLink !== null) { %>\n        <li>\n            <a class="primary-link" href="<%= alertsLink %>"><%- _("Triggered Alerts").t() %></a>\n            <a class="secondary-link" href="<%= alertsLink %>" target="_blank"><i class="icon-external"></i></a>\n        </li>\n    <% } %>\n\t<% if (typeof statusLink !== "undefined" && statusLink !== null) { %>\n\t\t<li>\n\t\t    <a class="primary-link" href="<%= statusLink %>"><%- _("System Activity").t() %></a>\n\t\t    <a class="secondary-link" href="<%= statusLink %>" target="_blank"><i class="icon-external"></i></a>\n\t\t</li>\n\t<% } %>\n    </ul>\n</div>\n';});

define('views/shared/splunkbar/ActivityMenu',
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'views/shared/delegates/Popdown',
    'contrib/text!views/shared/splunkbar/ActivityMenu.html',
    'splunk.util',
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    Popdown,
    activityMenuTemplate,
    splunk_util,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: activityMenuTemplate,
        tagName: 'li',
        className: 'dropdown activity',
        initialize: function(){
            BaseView.prototype.initialize.apply(this, arguments);
            this.render();
            this.model.application.on('change', this.render);
            this.model.user.on('change', this.render);
        },
        render: function(){
            // can't render unless we have app and roles info
            if (typeof this.model.application.get('app') === "undefined" ||
                typeof this.model.user.entry.content.get('roles') === "undefined") {
                return this;
            } else {
                var app = this.model.application.get('app'),
                    isAdmin = (this.model.user.entry.content.get('roles').indexOf('admin') > -1),
                    jobLink = route.page(
                        this.model.application.get('root'),
                        this.model.application.get('locale'),
                        app,
                        'job_management'
                    ),
                    statusLink = null,
                    alertsLink = null;
                
                if (this.model.user.canUseAlerts()) {
                    alertsLink = route.triggeredAlerts(this.model.application.get('root'), this.model.application.get('locale'), app);
                }

                // if we are currently in the system namespace, route job link through search namespace
                //  job_management page cannot be loaded within system namespace
                if (app == 'system') {
                    jobLink = route.page(
                        this.model.application.get('root'),
                        this.model.application.get('locale'),
                        'search',
                        'job_management'
                    );
                }

                if (isAdmin) {
                    // only build statusLink if the user is admin
                    statusLink = route.page(
                        this.model.application.get('root'),
                        this.model.application.get('locale'),
                        'search',
                        'status_index');
                }
                
                var html = this.compiledTemplate({jobLink:jobLink, alertsLink:alertsLink, statusLink:statusLink});
                this.$el.html(html);

                this.children.popdown = new Popdown({el:this.el, mode: 'dialog'});

                return this;
            }
        }
    });
});

define('contrib/text!views/shared/AboutDialog.html',[],function () { return '<dl class="list-dotted">\n    <dt><%= _(\'Splunk Version\').t() %></dt>\n    <dd><%- version %></dd>\n    <dt><%= _(\'Splunk Build\').t() %></dt>\n    <dd><%- build %></dd>\n</dl>\n<% if (!isLite) { %>\n<dl class="list-dotted">\n    <dt><%= _(\'Current App\').t() %></dt>\n    <dd><%- currentApp %></dd>\n    <% if (appVersion) { %>\n        <dt><%= _(\'App Version\').t() %></dt>\n        <dd><%- appVersion %></dd>\n    <% } %>\n    <% if (appBuild) { %>\n        <dt><%= _(\'App Build\').t() %></dt>\n        <dd><%- appBuild %></dd>\n    <% } %>\n</dl>\n<% } %>\n<% if (listOfProducts && !isLite) { %>\n<dl class="list-dotted">\n    <dt><%= _(\'List of Products:\').t() %></dt>\n    <dd><%- listOfProducts %></dd>\n</dl>\n<% } %>\n<dl class="list-dotted">\n    <dt><%= _(\'Server Name\').t() %></dt>\n    <dd><%- serverName %></dd>\n</dl>\n<p>\n    &copy; <%- copyrightYear %> <%= _(\'Splunk Inc.  All rights reserved.\').t()%>\n</p>\n<p>\n    <% if (isEnterprise) { %>\n        <%= _(\'All use of this Software is subject to the terms and conditions accepted upon installation of and/or purchase of license for the Software.\').t() %>\n    <% } else { %>\n        <%= _(\'All use of this Software is subject to the terms and conditions of the\').t() %>\n        <a href="http://www.splunk.com/view/SP-CAAAAFA" target="_blank"><%= _(\'Splunk Software License Agreement.\').t() %></a>\n    <% } %>\n</p>\n<p>\n    <a href="<%- thirdPartyCredits %>" target="_blank"><%= _(\'Third-Party Software Credits and Attributions\').t() %></a>\n</p>';});

define('views/shared/AboutDialog',
    [
        'underscore',
        'module',
        'uri/route',
        'views/Base',
        'views/shared/Modal',
        'contrib/text!views/shared/AboutDialog.html',
        'splunk.time'
    ],
    function(
        _,
        module,
        route,
        Base,
        Modal,
        Template,
        Time
    ){
        return Modal.extend({
            moduleId: module.id,
            template: Template,
            initialize: function() {
                Modal.prototype.initialize.apply(this, arguments);
                var that = this,
                    currentAppName = that.model.applicationModel.get('app'),
                    currentApp,
                    date = new Time.DateTime();

                this.year = date.getYear();
                this.logoFlavors = {
                    'hunk':       '&#xF000;',
                    'enterprise': '&#xF001;',
                    'cloud':      '&#xF002;',
                    'lite':       '&#xF003;',
                    'lite_free':  '&#xF003;'
                };
                if (currentAppName === 'launcher') {
                    that.currentAppLabel = _('Home').t();
                } else {
                    if (that.collection) {
                        currentApp = that.collection.find(function(app) {
                            return app.entry.get('name') === currentAppName;
                        });
                    }
                    that.currentAppLabel = currentApp ? currentApp.entry.content.get('label') : _('N/A').t();
                }

                this.model.serverInfo.on('change reset', function() {
                    this.render();
                }, this);
            },
            getListOfProducts: function() {
                var addOns = this.model.serverInfo.entry.content.get('addOns'),
                    result;
                if (addOns && !$.isEmptyObject(addOns)) {
                    result = _(addOns).keys().join(', ');
                }
                return result;
            },
            getLogoFlavorIcon: function() {
                var branding = this.model.serverInfo.getBranding(),
                    icon = '';
                if (this.logoFlavors.hasOwnProperty(branding)) {
                    icon = this.logoFlavors[branding];
                }
                return icon;
            },
            render: function() {
                this.$el.html(Modal.TEMPLATE);
                this.$(Modal.HEADER_TITLE_SELECTOR).html('splunk<span class="prompt">&gt;&#x00AE;'+this.getLogoFlavorIcon()+'</span>');
                var isLite = this.model.serverInfo.isLite(),
                    isLiteFree = this.model.serverInfo.isLiteFree(),
                    versionNumberText = this.model.serverInfo.entry.content.get('version') || _('N/A').t(),
                    liteVersionText = (isLiteFree) ? _('Splunk Light Free Version ' + versionNumberText).t() : _('Splunk Light Version ' + versionNumberText).t(),
                    versionText = (isLite) ? liteVersionText : versionNumberText,
                    template = this.compiledTemplate({
                        serverName: this.model.serverInfo.entry.content.get('serverName') || _('N/A').t(),
                        version: versionText,
                        isEnterprise: this.model.serverInfo.isEnterprise(),
                        build: this.model.serverInfo.entry.content.get('build') || _('N/A').t(),
                        appVersion: this.model.appLocal.entry.content.get('version') || null,
                        appBuild: this.model.appLocal.entry.content.get('build') || null,
                        listOfProducts: this.getListOfProducts(),
                        currentApp: this.currentAppLabel,
                        isLite: this.isLite,
                        thirdPartyCredits: route.docHelp(this.model.applicationModel.get('root'), this.model.applicationModel.get('locale'), 'ReleaseNotes.Credits'),
                        copyrightYear: this.year
                    });
                this.$(Modal.BODY_SELECTOR).html(template);

                return this;
            }
        });
    });

define('contrib/text!views/shared/whatsnewdialog/Master.html',[],function () { return '<h2><%=_("Mission Critical Enterprise").t()%></h2>\n<div class="feature">\n    <h3><%=_("Search Head Clustering").t()%></h3>\n    <p><%=_("High availability of mission critical applications at the search head tier").t()%></p>\n    <a href="<%=docLink%>whatsnew.searchheadclustering" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("Indexer Cluster Monitoring").t()%></h3>\n    <p><%=_("Easily monitor large scale clusters, providing an in–depth view of all cluster related recovery operations.").t()%></p>\n    <a href="<%=docLink%>whatsnew.indexerclustermonitoring" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("Distributed Management Console").t()%></h3>\n    <p><%=_("Monitor key usage and performance metrics across entire Splunk Enterprise deployment.").t()%></p>\n    <a href="<%=docLink%>whatsnew.distributedmonitoringconsole" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n\n<h2><%=_("Knowledge Management").t()%></h2>\n<div class="feature">\n    <h3><%=_("Getting Data In").t()%></h3>\n    <p><%=_("Wizard style interface for rapidly adding data, including new Forwarder Inputs feature and new version of Data Preview").t()%></p>\n    <a href="<%=docLink%>whatsnew.knowledgemanagement" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("Advanced Field Extractor").t()%></h3>\n    <p><%=_("Improve accuracy and efficiency of field extraction and better prepare data for further analysis.").t()%></p>\n    <a href="<%=docLink%>whatsnew.advancedfieldextractor" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("App Key Value Store").t()%></h3>\n    <p><%=_("Highly scalable app data storage and retrieval capabilities for Splunk App Developers.").t()%></p>\n    <a href="<%=docLink%>whatsnew.appkeyvaluestore" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<h2><%=_("Data Exploration").t()%></h2>\n<div class="feature">\n    <h3><%=_("Event Pattern Detection").t()%></h3>\n    <p><%=_("Auto-discover meaningful patterns in machine data with a single click").t()%></p>\n    <a href="<%=docLink%>whatsnew.eventpatterndetection" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("Instant Pivot").t()%></h3>\n    <p><%=_("Pivot directly on data, bypassing the Data Model step.").t()%></p>\n    <a href="<%=docLink%>whatsnew.instantpivot" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("Home Page Redesign").t()%></h3>\n    <p><%=_("Create custom home page using any dashboard Bubble Chart – New visualization for multi-dimensional numeric analytics.").t()%></p>\n    <a href="<%=docLink%>whatsnew.homepageredesign" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n\n<h2><%=_("Dashboard Enhancements").t()%></h2>\n<div class="feature">\n    <h3><%=_("Panels").t()%></h3>\n    <p><%=_("Build dashboards faster using pre-built dashboard panels packaged within apps").t()%></p>\n    <a href="<%=docLink%>whatsnew.panels" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n<div class="feature">\n    <h3><%=_("Multi-Search and Post-Process Management").t()%></h3>\n    <p><%=_("Configure multiple background searches, with explicit post process references throughout your dashboard").t()%></p>\n    <a href="<%=docLink%>whatsnew.multisearch" class="external" target="_blank"><%=_("Documentation").t()%></a>\n</div>\n\n';});

define('views/shared/whatsnewdialog/Master',
[
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'views/shared/Modal',
    'uri/route',
    'splunk.util',
    'contrib/text!views/shared/whatsnewdialog/Master.html'
],
function(
    $,
    _,
    module,
    Base,
    Modal,
    route,
    splunk_util,
    Template
){
    return Modal.extend({
        moduleId: module.id,
        template: Template,
        initialize: function() {
            Modal.prototype.initialize.apply(this, arguments);
            var self = this;
            this.on('hidden', function(){
                self.$el.remove();
                self.modalWrapper.remove();
            });
            this.render();
        },
        render: function() {
            var imgPath = splunk_util.make_url('/static/img/');
            var docLink = route.docHelp(this.model.application.get("root"), this.model.application.get("locale"), '');
            var template = this.compiledTemplate({imgPath: imgPath, docLink: docLink});

            this.$el.html(Modal.TEMPLATE);
            this.$(Modal.HEADER_TITLE_SELECTOR).html(_("What's new in 6.2").t());
            this.$(Modal.BODY_SELECTOR).html(template);
            this.modalWrapper = $('<div class="splunk-components"></div>');
            $(this.el).appendTo(this.modalWrapper);
            this.modalWrapper.appendTo('body');
            this.show();
            return this;
        }
    });
});

define('contrib/text!views/shared/splunkbar/HelpMenu.html',[],function () { return '<a href="#" class="dropdown-toggle">\n    <% if(isLite) { %>\n        <i class="icon icon-question-circle"></i>\n    <% } else { %>\n        <%- _("Help").t() %><b class="caret"></b>\n    <% } %>\n</a>\n<div class="dropdown-menu" id="global-help-menu">\n    <div class="arrow"></div>\n    <ul>\n        <% if (!isLite) { %>\n            <li><a class="whatsnew" href="#"><%- _("What\'s New in 6.2").t() %></a></li>\n        <% } %>\n        <li><a class="external" href="<%- makeDocLink(\'search_app.tutorial\') %>" target="_blank"><%- _("Tutorials").t() %></a></li>\n        <li><a class="external" href="http://splunk-base.splunk.com/" target="_blank"><%- _("Splunk Answers").t() %></a></li>\n        <li><a class="external" href="http://www.splunk.com/support" target="_blank"><%- _("Contact Support").t() %></a></li>\n        <li><a class="external" href="<%- docLink %>" target="_blank"><%- _("Documentation").t() %></a></li>\n        <li><a class="about-splunk" href="#"><%- _("About").t() %></a></li>\n    </ul>\n    <form class="form-search" action="#help" method="get">\n    </form>\n</div>\n';});

define('views/shared/splunkbar/HelpMenu',
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'views/shared/delegates/Popdown',
    'views/shared/AboutDialog',
    'views/shared/controls/TextControl',
    'views/shared/whatsnewdialog/Master',
    'contrib/text!views/shared/splunkbar/HelpMenu.html',
    'splunk.util',
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    Popdown,
    AboutDialogView, 
    TextControl,
    WhatsNewDialogView,
    helpMenuTemplate,
    splunk_util,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: helpMenuTemplate,
        tagName: 'li',
        className: 'dropdown help',
        initialize: function(){
            BaseView.prototype.initialize.apply(this, arguments);
            this.children.searchInput = new TextControl({
                placeholder: _('Search Documentation').t(),
                inputClassName: 'input-medium search-query'
            });
            this.model.appLocal.on('change reset', this.debouncedRender, this);
            this.debouncedRender();
        },
        events: {
            'keypress input': "onDocsSearch",
            'click .whatsnew': 'onWhatsNew',
            'click .dropdown-menu a': 'closePopdown', 
            'click .about-splunk': function(e) {
                this.children.aboutDialog = new AboutDialogView({
                    collection: this.collection.apps,
                    model: {
                        applicationModel: this.model.application,
                        appLocal: this.model.appLocal,
                        serverInfo: this.model.serverInfo
                    },
                    onHiddenRemove: true
                });

                //for compatibility with the module system, this needs to be wrapped in an extra div.
                this.modalWrapper = $('<div class="splunk-components">').appendTo("body").append(this.children.aboutDialog.render().el);
                        
                this.children.aboutDialog.show();
                e.preventDefault();
            }
        },
        render: function(){
            var html = this.compiledTemplate({
                docLink: this.makeDocLinkForPage(),
                makeDocLink: this.makeDocLink.bind(this),
                isLite: this.model.serverInfo.isLite()
            });
            this.$el.html(html);

            var popup = this.$('#global-help-menu');
            popup.find('.form-search').append(this.children.searchInput.render().el);
            this.children.popdown = new Popdown({el:popup.parent(), mode: 'dialog'});
            return this;
        },
        onDocsSearch: function(evt){
            if (evt.keyCode === 13){ //ENTER
                var s = $(evt.target).val();
                evt.preventDefault();
                evt.stopPropagation();
                $.when(this.serverInfoDfd).then(function(){
                    var url = route.docSearch(this.model.application.get('locale'), this.model.serverInfo.entry.content.get('version'), splunk_util.normalizeBoolean(this.model.serverInfo.entry.content.get('isFree')), splunk_util.normalizeBoolean(this.model.serverInfo.entry.content.get('isTrial')), s);
                    window.open(url);
                }.bind(this));
                $(evt.target).val('');
                this.closePopdown();
                evt.preventDefault();
            }
        },
        makeDocLink: function(location) {
            return route.docHelpInAppContext(
                this.model.application.get("root"),
                this.model.application.get("locale"),
                location,
                this.model.application.get("app"),
                this.model.appLocal.entry.content.get('version'),
                this.model.appLocal.appAllowsDisable(),
                this.model.appLocal.entry.content.get('docs_section_override')
            );
        },
        makeDocLinkForPage: function() {
            //this is the generic doc link based on the current location
            var link = '/help',
                location;

            if(this.model.application.get('page') === '_admin'){
                // making help link for manager page
                location = 'manager';
                if(window && window.location && typeof window.location.pathname === 'string'){
                    //get the location from the browser
                    var pathname = window.location.pathname;
                    //remove '/manager/' and all characters before
                    pathname = pathname.substring(pathname.indexOf('/manager/')+9);
                    //next we should have app namespace to remove
                    pathname = pathname.substring(pathname.indexOf('/')+1);
                    //change slashes to dots
                    pathname = pathname.replace(new RegExp('/', 'g'), '.');
                    location += '.'+pathname;
                }

                link = route.docHelp(
                    this.model.application.get("root"),
                    this.model.application.get("locale"),
                    location
                );

            }else{
                // making help link for app page
                // location is in form: app.<app_name>.<page_name>
                location = [
                    'app',
                    this.model.application.get('app'),
                    this.model.application.get('page')
                ].join(".");

                link = this.makeDocLink(location);

            }
            return link;
        },
        onWhatsNew: function(e){
            if(e){
                e.preventDefault();
            }
            this.children.whatsNewDialog = new WhatsNewDialogView({
                model: this.model
            });
        },
        closePopdown: function(e){
            this.children.popdown.hide();
        }
    });
});

/**
 * PopTart.show() now has the following signature: 
 * 
 * show($pointTo[, options]) 
 * 
 * Where the options are: 
 * 
 * $toggle: Clicking on this element will trigger opening and closing of the PopTart. Defaults to the $pointTo element. 
 * $onOpenFocus: When the PopTart opens, this element is then given focus. Defaults to the first anchor element inside the opened PopTart. 
 * $onCloseFocus: When the PopTart closes, this element is then given focus. Defaults to the $toggle element. 
 * $onClickCloseFocus: When the PopTart closes via a click event, this element is then given focus. Defaults to the $onCloseFocus element. 
 */
 
define('views/shared/PopTart',
    [
        'underscore',
        'module',
        'views/Base',
        'views/shared/delegates/PopdownDialog'
    ],
    function(_, module, Base, PopdownDialogDelegate) {
        return Base.extend({
            moduleId: module.id,
            className: 'popdown-dialog',
            initialize: function(options) {
                options = options || {};
                var defaults = {
                    direction:'auto',
                    adjustPosition: true
                };
                _.defaults(options, defaults);
                
                Base.prototype.initialize.apply(this, arguments);
                this.children.popdownDialogDelegate = new PopdownDialogDelegate({
                    el: this.el,
                    ignoreClasses: this.options.ignoreClasses, 
                    adjustPosition: this.options.adjustPosition,
                    show: this.options.show,
                    mode: this.options.mode, // "menu" or "dialog"
                    direction: this.options.direction,
                    arrow: this.options.arrow,
                    minMargin: this.options.minMargin,
                    allowPopUp: this.options.allowPopUp,
                    scrollContainer: this.options.scrollContainer,
                    /**
                     * If ignoreToggleMouseDown is enabled, the PopTart will take no action when
                     * clicking on the PopTart's toggle activator element. This allows the 
                     * creator of the PopTart to fully manage closing the opened PopTart.
                     */
                    ignoreToggleMouseDown: this.options.ignoreToggleMouseDown
                });
                this.activate();
            },
            startListening: function() {
                this.listenTo(this.children.popdownDialogDelegate, 'all', function() {
                    this.trigger.apply(this, arguments);
                });
                this.listenTo(this, 'shown', function() {
                    this.shown = true;
                    if (this.$onOpenFocus) {
                        this.$onOpenFocus.focus();
                    } else {
                        this.children.popdownDialogDelegate.$el.find('a').first().focus();
                    }

                    $(window).on("resize." + this.cid, function() {
                        this.children.popdownDialogDelegate.adjustPosition(this.$pointTo);
                    }.bind(this));
                });
                this.listenTo(this, 'hidden', function(e) {
                    this.shown = false;
                    if (this.options.onHiddenRemove) {
                        this.remove();
                    }

                    $(window).off("resize." + this.cid);

                    // Focus on activator
                    var x = window.scrollX,
                        y = window.scrollY;
                    if (e && e.type === 'click') {
                        this.$onClickCloseFocus.focus();
                    } else {
                        this.$onCloseFocus.focus();
                    }
                    window.scrollTo(x, y);
                });
            },
            toggle: function() {
                return this.children.popdownDialogDelegate.toggle();
            },
            show: function($pointTo, options) {
                options = options || {};
                
                this.$pointTo = $pointTo;
                this.$toggle = options.$toggle || this.$pointTo;
                this.$onOpenFocus = options.$onOpenFocus;
                this.$onCloseFocus = options.$onCloseFocus || this.$toggle;
                this.$onClickCloseFocus = options.$onClickCloseFocus || this.$onCloseFocus;

                this.children.popdownDialogDelegate.show(this.$pointTo, this.$toggle);
            },
            hide: function(e) {
                this.children.popdownDialogDelegate.hide(e);
            },
            render: function() {
                this.el.innerHTML = this.template;
                return this;
            },
            remove: function() {
                if (this.shown) {
                    this.hide();
                }
                Base.prototype.remove.apply(this, arguments);
            },
            template: '\
                <div class="arrow"></div>\
                <div class="popdown-dialog-body popdown-dialog-padded"></div>\
            ',
            template_menu: '\
                <div class="arrow"></div>\
            '
        });
    }
);

define('contrib/text!views/shared/splunkbar/find/results/DashboardResults.html',[],function () { return '<div class="findbar-results-header"><%- _(\'Dashboards\').t() %></div>\n<ul class="dashboards">\n    <% dashboards.each(function(dash) { %>\n        <% var appName = dash.entry.content.get(\'eai:appName\'); %>\n        <% var dashApp = _.find(apps.models, function(app) {return app.entry.get(\'name\') === appName;}); %>\n        <% var openInApp = dashApp && dashApp.entry.content.get("visible") ? appName : alternateApp; %>\n        <li class=\'findbar-results-row\'>\n            <a class="primary-link" href="<%- route.page(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        openInApp,\n                        dash.entry.get(\'name\')) %>">\n                <i class="icon-dashboard findbar-results-icon"></i>\n                <%- dash.meta.get(\'label\') %>\n            </a>\n            <a class="secondary-link" href="<%- route.page(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        openInApp,\n                        dash.entry.get(\'name\')) %>" target="_blank">\n                <i class="icon-external"></i>    \n            </a>\n        </li>\n    <% }); %>\n    <% if (dashboards.models[0].paging.get(\'perPage\') < dashboards.models[0].paging.get(\'total\')) { %>\n        <li class="findbar-more-link">\n            <a class="primary-link" href="<%- route.manager(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        \'system\',\n                        [\'dashboards\'],\n                        {data: {search: search, rawSearch: rawSearch}}) %>">\n                <%- _(\'More Dashboard results\').t() %>\n            </a>\n            <a class="secondary-link" href="<%- route.manager(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        \'system\',\n                        [\'dashboards\'],\n                        {data: {search: search, rawSearch: rawSearch}}) %>" target="_blank">\n                <i class="icon-external"></i>\n            </a>\n        </li>\n    <% } %>\n</ul>';});

define('views/shared/splunkbar/find/results/DashboardResults',
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/find/results/DashboardResults.html', 
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    dashboardResultsTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: dashboardResultsTemplate,
        className: 'dashboardResults',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            var html = this.compiledTemplate({
                _: _,
                dashboards: this.collection.dashboards,
                app: this.model.application,
                route: route,
                search: this.model.state.get('search') || '',
                rawSearch: this.model.rawSearch.get('rawSearch') || '',
                apps: this.collection.apps,
                alternateApp: this.options.alternateApp
            });
            
            this.$el.html(html);
            return this;
        }
    });
});
define('contrib/text!views/shared/splunkbar/find/results/ReportResults.html',[],function () { return '<div class="findbar-results-header"><%- _(\'Reports\').t() %></div>\n<ul class="reports">\n    <% reports.each(function(report) { %>\n        <% var appName = report.entry.acl.get(\'app\'); %>\n        <% var reportApp = _.find(apps.models, function(app) {return app.entry.get(\'name\') === appName;}); %>\n        <% var openInApp = reportApp && reportApp.entry.content.get("visible") ? appName : alternateApp; %>\n        <li class=\'findbar-results-row\'>\n            <a class="primary-link" href="<%- route.report(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        openInApp,\n                        {data: {s: report.id }}) %>">\n                <i class="icon-report findbar-results-icon"></i>\n                <%- report.entry.get(\'name\') %>\n            </a>\n            <a class="secondary-link" href="<%- route.report(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        openInApp,\n                        {data: {s: report.id }}) %>" target="_blank">\n                <i class="icon-external"></i>    \n            </a>\n        </li>\n    <% }); %>\n    <% if (reports.models[0].paging.get(\'perPage\') < reports.models[0].paging.get(\'total\')) { %>\n        <li class="findbar-more-link">\n            <a class="primary-link" href="<%- route.manager(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        \'system\',\n                        [\'reports\'],\n                        {data: {search: search, rawSearch: rawSearch}}) %>">\n                <%- _(\'More Report results\').t() %>\n            </a>\n            <a class="secondary-link" href="<%- route.manager(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        \'system\',\n                        [\'reports\'],\n                        {data: {search: search, rawSearch: rawSearch}}) %>" target="_blank">\n                <i class="icon-external"></i>\n            </a>\n        </li>\n    <% } %>\n</ul>';});

define('views/shared/splunkbar/find/results/ReportResults',
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/find/results/ReportResults.html', 
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    reportResultsTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: reportResultsTemplate,
        className: 'reportResults',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            var html = this.compiledTemplate({
                _: _,
                reports: this.collection.reports,
                app: this.model.application,
                route: route,
                search: this.model.state.get('search') || '',
                rawSearch: this.model.rawSearch.get('rawSearch') || '',
                apps: this.collection.apps,
                alternateApp: this.options.alternateApp
            });
            
            this.$el.html(html);
            return this;
        }
    });
});
define('contrib/text!views/shared/splunkbar/find/results/AlertResults.html',[],function () { return '<div class="findbar-results-header"><%- _(\'Alerts\').t() %></div>\n<ul class="alerts">\n    <% alerts.each(function(alert) { %>\n        <% var appName = alert.entry.acl.get(\'app\'); %>\n        <% var alertApp = _.find(apps.models, function(app) {return app.entry.get(\'name\') === appName;}); %>\n        <% var openInApp = alertApp && alertApp.entry.content.get("visible") ? appName : alternateApp; %>\n        <li class=\'findbar-results-row\'>\n            <a class="primary-link" href="<%- route.alert(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        openInApp,\n                        {data: {s: alert.id }}) %>">\n                <i class="icon-bell findbar-results-icon"></i>\n                <%- alert.entry.get(\'name\') %>\n            </a>\n            <a class="secondary-link" href="<%- route.alert(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        openInApp,\n                        {data: {s: alert.id }}) %>" target="_blank">\n                <i class="icon-external"></i>    \n            </a>\n        </li>\n    <% }); %>\n    <% if (alerts.models[0].paging.get(\'perPage\') < alerts.models[0].paging.get(\'total\')) { %>\n        <li class="findbar-more-link">\n            <a class="primary-link" href="<%- route.manager(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        \'system\',\n                        [\'alerts\'],\n                        {data: {search: search, rawSearch: rawSearch}}) %>">\n                <%- _(\'More Alert results\').t() %>\n            </a>\n            <a class="secondary-link" href="<%- route.manager(\n                        app.get(\'root\'),\n                        app.get(\'locale\'),\n                        \'system\',\n                        [\'alerts\'],\n                        {data: {search: search, rawSearch: rawSearch}}) %>" target="_blank">\n                <i class="icon-external"></i>\n            </a>\n        </li>\n    <% } %>\n</ul>';});

define('views/shared/splunkbar/find/results/AlertResults',
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/find/results/AlertResults.html', 
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    alertResultsTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: alertResultsTemplate,
        className: 'alertResults',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            var html = this.compiledTemplate({
                _: _,
                alerts: this.collection.alerts,
                app: this.model.application,
                route: route,
                search: this.model.state.get('search') || '',
                rawSearch: this.model.rawSearch.get('rawSearch') || '',
                apps: this.collection.apps,
                alternateApp: this.options.alternateApp
            });
            
            this.$el.html(html);
            return this;
        }
    });
});
define('contrib/text!views/shared/splunkbar/find/results/DataModelResults.html',[],function () { return '<div class="findbar-results-header"><%- _(\'Data Models\').t() %></div>\n<ul class="datamodels">\n    <% datamodels.each(function(data) { %>\n        <% var appName = data.entry.acl.get(\'app\'); %>\n        <% var dataApp = _.find(apps.models, function(app) {return app.entry.get(\'name\') === appName;}); %>\n        <% var openInApp = dataApp && dataApp.entry.content.get("visible") ? appName : alternateApp; %>\n        <li class=\'findbar-results-row\'>\n            <a class="primary-link" href="<%- route.pivot(\n                        appRoot,\n                        appLocale,\n                        openInApp,\n                        {data: {model: data.get(\'id\')}}) %>">\n                <i class="icon-data findbar-results-icon"></i>\n                <%- data.entry.content.get(\'displayName\') %>\n            </a>\n            <a class="secondary-link" href="<%- route.pivot(\n                        appRoot,\n                        appLocale,\n                        openInApp,\n                        {data: {model: data.get(\'id\')}}) %>" target="_blank">\n                <i class="icon-external"></i>    \n            </a>\n        </li>\n    <% }); %>\n    <% if (datamodels.models[0].paging.get(\'perPage\') < datamodels.models[0].paging.get(\'total\')) { %>\n        <li class="findbar-more-link">\n            <a class="primary-link" href="<%- route.data_model_manager(\n                        appRoot,\n                        appLocale,\n                        managerApp,\n                        {data: {owner: \'*\', nameFilter: rawSearch, app: \'-\'}}) %>">\n                <%- _(\'More Data Model results\').t() %>\n            </a>\n            <a class="secondary-link" href="<%- route.data_model_manager(\n                        appRoot,\n                        appLocale,\n                        managerApp,\n                        {data: {owner: \'*\', nameFilter: rawSearch, app: \'-\'}}) %>" target="_blank">\n                <i class="icon-external"></i>\n            </a>\n        </li>\n    <% } %>\n</ul>';});

define('views/shared/splunkbar/find/results/DataModelResults',
[
    'underscore',
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/shared/splunkbar/find/results/DataModelResults.html', 
    'uri/route'
],
function(
    _,
    $,
    module,
    BaseView,
    dataModelResultsTemplate,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        template: dataModelResultsTemplate,
        className: 'dataModelResults',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            var appRoot = this.model.application.get('root'),
                appLocale = this.model.application.get('locale'),
                managerApp = (this.model.application.get('app') === 'system') ? 'launcher' : this.model.application.get('app');
            var html = this.compiledTemplate({
                _: _,
                datamodels: this.collection.datamodels,
                route: route,
                search: this.model.state.get('search') || '',
                rawSearch: this.model.rawSearch.get('rawSearch') || '',
                appRoot: appRoot,
                appLocale: appLocale,
                managerApp: managerApp,
                apps: this.collection.apps,
                alternateApp: this.options.alternateApp
            });
            
            this.$el.html(html);
            return this;
        }
    });
});
define('views/shared/splunkbar/find/results/Master',
[
    'underscore',
    'jquery',
    'module',
    'views/shared/PopTart',
    'views/shared/splunkbar/find/results/DashboardResults',
    'views/shared/splunkbar/find/results/ReportResults',
    'views/shared/splunkbar/find/results/AlertResults',
    'views/shared/splunkbar/find/results/DataModelResults',
    'uri/route',
    'splunk.util'
],
function(
    _,
    $,
    module,
    PopTartView,
    DashboardResults,
    ReportResults,
    AlertResults,
    DataModelResults,
    route,
    splunkUtils
){
    return PopTartView.extend({
        moduleId: module.id,
        className: 'dropdown-menu',
            /**
             * @param {Object} options {
             *     collection: {
             *         dashboards: <collections.shared.Dashboards>,
             *         reports: <collections.search.Reports>,
             *         alerts: <collections.search.Reports>,
             *         datamodels: <collections.services.datamodel.DataModels>,
             *         apps: <collections.services.appLocal>
             *     model: {
             *         state: <models.State>,
             *         application: <models.shared.Application>,
             *         rawSearch: <models.Base>
             *     },
             *     mode: <string>,
             *     onHiddenRemove: <Boolean>
             * }
             */
        initialize: function() {
            PopTartView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            this.el.innerHTML = PopTartView.prototype.template_menu;
            
            if (!this.collection.reports.size() &&
                !this.collection.dashboards.size() &&
                !this.collection.alerts.size() &&
                !this.collection.datamodels.size()) {
                this.$el.append('<div class="no-results">' + _("No Results for this search.").t() + '</div>');
            }
            var currentApp = this.model.application.get('app'),
                alternateApp = currentApp !== 'system' ? currentApp : 'search';
            var searchApp = _.find(this.collection.apps.models, function(app) {
                return app.entry.get('name') === 'search';
            });
            if (alternateApp === 'search' && searchApp && searchApp.entry.content.get("disabled")) {
                this.collection.apps.sortWithString(this.model.userPref.entry.content.get('appOrder'));
                alternateApp = this.collection.apps.models[0].entry.get('name');
            }
            
            // Report Results
            if (this.collection.reports.size()) {
                this.children.reportResults = new ReportResults({
                    collection: {
                        reports: this.collection.reports,
                        apps: this.collection.apps
                    },
                    model: {
                        application: this.model.application,
                        state: this.model.state,
                        rawSearch: this.model.rawSearch
                    },
                    alternateApp: alternateApp
                });
                this.$el.append(this.children.reportResults.render().el);
            }
            
            // Dashboard Results
            if ( this.collection.dashboards.size()) {
                this.children.dashboardResults = new DashboardResults({
                    collection: {
                        dashboards: this.collection.dashboards,
                        apps: this.collection.apps
                    },
                    model: {
                        application: this.model.application,
                        state: this.model.state,
                        rawSearch: this.model.rawSearch
                    },
                    alternateApp: alternateApp
                });
                this.$el.append(this.children.dashboardResults.render().el);
            }
                            
            // Alert Results
            if (this.collection.alerts.size()) {
                this.children.alertResults = new AlertResults({
                    collection: {
                        alerts: this.collection.alerts,
                        apps: this.collection.apps
                    },
                    model: {
                        application: this.model.application,
                        state: this.model.state,
                        rawSearch: this.model.rawSearch
                    },
                    alternateApp: alternateApp
                });
                this.$el.append(this.children.alertResults.render().el);
            }
            
            // Data Model Results
            if (this.collection.datamodels.size()) {
                this.children.dataModelResults = new DataModelResults({
                    collection: {
                        datamodels: this.collection.datamodels,
                        apps: this.collection.apps
                    },
                    model: {
                        application: this.model.application,
                        state: this.model.state,
                        rawSearch: this.model.rawSearch
                    },
                    alternateApp: alternateApp
                });
                this.$el.append(this.children.dataModelResults.render().el);
            }
            
            // Open "keyword" in new search
            var searchLink = route.search(
                    this.model.application.get('root'),
                    this.model.application.get('locale'),
                    'search',
                    {data: {q: this.model.rawSearch.get('rawSearch')}}
                );

            var html = this.compiledTemplate({
                _: _,
                splunkUtils: splunkUtils,
                searchLink: searchLink,
                rawSearch: this.model.rawSearch.get('rawSearch')
            });
            this.$el.append(html);

            return this;
        },
        template: '\
        <ul><li>\
            <a class="primary-link search-link" href="<%- searchLink %>">\
                <i class="icon-search-thin findbar-results-icon"></i>\
                <%- splunkUtils.sprintf(_("Open %s in search").t(), rawSearch) %>\
            </a>\
            <a class="secondary-link search-link" href="<%- searchLink %>" target="_blank">\
                <i class="icon-external"></i>\
            </a>\
        </li></ul>\
        '
    });
});
define('views/shared/WaitSpinner',['underscore', 'module', 'views/Base'], function(_, module, BaseView, splunkUtil) {
    
    
    return BaseView.extend({
        moduleId: module.id,
        tagName: 'div',
        initialize: function(){
            var defaults = {
              size: 'small',
              color: 'gray',
              frameWidth: 14, //px
              frameCount: 8,
              fps: 10
            };
            
            _.defaults(this.options, defaults);
        
            BaseView.prototype.initialize.apply(this, arguments);
            
            this.$el.addClass('spinner-' + this.options.size + '-' + this.options.color);
            this.frame=0;
        },
        stop:  function() {
            this.active=false;
            this.interval && window.clearInterval(this.interval);
            return this;
        },
        start:  function() {
            this.active=true;
            this.interval && window.clearInterval(this.interval);
            this.interval=setInterval(this.step.bind(this), 1000/this.options.fps);
            return this;
        },
        step:  function() {
            this.$el.css('backgroundPosition', '-' + (this.frame * this.options.frameWidth) + 'px top ');
            
            this.frame++;
            this.frame = this.frame == this.options.frameCount ? 0 : this.frame; 
        
            return this;
        },
        remove: function() {
            this.stop();
            BaseView.prototype.remove.apply(this, arguments);
        },
        render: function() {
            return this;
        }
    });
});

define('views/shared/splunkbar/find/ProgressSpinner',
[
    'underscore',
    'module',
    'views/shared/WaitSpinner',
    'splunk.util'],
function(
    _,
    module,
    SpinnerView,
    splunkutil
){
    return SpinnerView.extend({
        className: 'center',
        moduleId: module.id,
        initialize: function() {
           SpinnerView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            this.$el.show()['addClass']('active');
            this.start();
            this.spinning = true;
            return this;
        }
    });
});

define('views/shared/splunkbar/find/FindProgress',
[
    'underscore',
    'jquery',
    'module',
    'views/shared/PopTart',
    'views/shared/splunkbar/find/ProgressSpinner',
    'uri/route',
    'splunk.util'
],
function(
    _,
    $,
    module,
    PopTartView,
    ProgressSpinner,
    route,
    splunkUtils
){
    return PopTartView.extend({
        moduleId: module.id,
        className: 'dropdown-menu',
        initialize: function() {
            PopTartView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            this.el.innerHTML = PopTartView.prototype.template_menu;
            
            // Open "keyword" in new search
            var searchLink = route.search(
                    this.model.application.get('root'),
                    this.model.application.get('locale'),
                    'search',
                    {data: {q: this.model.state.get('rawSearch')}}
                );
                
            var html = this.compiledTemplate({
                _: _,
                splunkUtils: splunkUtils,
                searchLink: searchLink,
                rawSearch: this.model.state.get('rawSearch')
            });
            this.$el.append(html);

            this.children.spinner = new ProgressSpinner();
            this.$('.findbar-results-spinner').append(this.children.spinner.render().el);
            
            return this;
        },
        template: '\
        <div class="findbar-results-spinner"></div>\
        <ul><li>\
            <a class="primary-link search-link" href="<%- searchLink %>">\
                <i class="icon-search-thin findbar-results-icon"></i>\
                <%- splunkUtils.sprintf(_("Open %s in search").t(), rawSearch) %>\
            </a>\
            <a class="secondary-link search-link" href="<%- searchLink %>" target="_blank">\
                <i class="icon-external"></i>\
            </a>\
        </li></ul>\
        '
    });
});
define('views/shared/tablecaption/Input',
    [
        'module',
        'underscore',
        'views/Base',
        'util/splunkd_utils'
    ],
    function(
        module,
        _,
        BaseView,
        splunkdUtils
    )
    {
        return BaseView.extend({
            moduleId: module.id,
            tagName: 'form',
            className: 'search-query-control',
            /**
             * @param {Object} options {
             *     model: {
             *          state: <models.State>,
             *          rawSearch: <models.Base> (Optional)
             *     }
             *     findBar: <boolean> true if this view is for the findBar
             * }
             */
            initialize: function(options) {
                BaseView.prototype.initialize.apply(this, arguments);
                this.key = this.options.key || "name";
                this.fetchDataFilter = this.options.fetchDataFilter || false;

                this.nativePlaceholder = this.supportsNativePlaceholder();
            },
            events: {
                'keyup input': function(e) {
                    e.preventDefault();
                    if (e.keyCode == 27) {
                        this.clear();
                    } else {
                        this.set(this.$input.val());
                    }
                    this.updateClear();
                    this.updatePlaceholder();
                },
                'click .placeholder': function(e) {
                    this.$input.focus();
                },
                'mouseup input': function(e) { //could result in pasted text
                    this.updatePlaceholder();
                },
                'submit': function(e) {
                    return false;
                },
                'click a.search-query-clear': function(e) {
                    e.preventDefault();
                    this.clear();
                    this.updateClear();
                    this.updatePlaceholder();
                }
            },
            clear: function(){
                this.$input.val('');
                this.set('');
            },
            updateClear: function(){
                this.$clear[this.$input.val() ? 'show' : 'hide']();
            },
            set: _.debounce(function(value) {
                if(this.fetchDataFilter && !value) {
                    this.model.state.unset('filter');
                } else {
                    this.model.state.set({
                        'offset': '0'
                    });
                    var keys = _.isArray(this.key) ? this.key : this.key.split(' ');
                    if(this.fetchDataFilter) {
                        //in the future, consumers of the shared input should refactor away
                        //from passing fetch data as the state model 
                        this.model.state.set('filter', splunkdUtils.createSearchFilterObj(value, keys));
                    } else {
                        this.model.state.set('search', splunkdUtils.createSearchFilterString(value, keys));
                        if (this.model.rawSearch ){
                            this.model.rawSearch.set('rawSearch', value);
                        }
                    }
                }
            }, 250),
            updatePlaceholder: function() {
                if (!this.nativePlaceholder) {
                    this.$placeholder[this.$input.val() === '' ? 'show' : 'hide']();
                }
            },
            supportsNativePlaceholder: function() {
                var test = document.createElement('input');
                return ('placeholder' in test);
            },
            isEmpty: function() {
                return this.$input.val() == '';
            },
            render: function() {
                var placeholder = _("filter").t();
                if (this.options.findBar) {
                    placeholder = _("Find").t();
                }
                this.$el.html(this.compiledTemplate({
                    _: _,
                    nativePlaceholder: this.nativePlaceholder,
                    placeholder: placeholder
                }));
                if (!this.nativePlaceholder) {
                    this.$placeholder = this.$('.placeholder');
                }
                this.$clear = this.$('.search-query-clear');
                this.$input = this.$('input');
                if (this.model.rawSearch && this.model.rawSearch.get('rawSearch')) {
                    this.$input.val(this.model.rawSearch.get('rawSearch'));
                }
                return this;
            },
            template: '<input type="text" class="input-medium search-query" <% if(nativePlaceholder){ %>placeholder="<%- placeholder %>"<%}%> >\
                <a href="#" class="search-query-clear" style="display:none"><i class="icon-x-circle"></i></a>\
                <% if(!nativePlaceholder){ %> <span class="placeholder"><%= placeholder %></span><% } %>'
        });
    }
);

/**
 * @author jszeto
 * @date 4/25/13
 *
 * Represents the acceleration specific settings for a DataModel.
 *
 *
 */
define('models/services/datamodel/private/Acceleration',
    [
        'models/Base'
    ],
    function(BaseModel) {

        return BaseModel.extend({

                defaults: {
                    enabled: false

                }
        });
    }
);
/**
 * A replacement for the <models/SplunkDWhiteList> in <models/services/datamodel/DataModel>.
 *
 * The services/datamodel endpoint does not yet support _new, so we hard-code the required and optional fields here.
 */

define('models/services/datamodel/private/DataModelWhiteList',[
            'jquery',
            'models/SplunkDWhiteList'
        ],
        function(
            $,
            SplunkDWhiteListV2
        ) {

    var CREATE_DATA_MODEL_WHITELIST = {
        entry: [
            {
                fields: {
                    required: [
                        'name'
                    ],
                    optional: [
                        'acceleration',
                        'description'
                    ],
                    wildcard: []
                }
            }
        ]
    };

    var UPDATE_DATA_MODEL_WHITELIST = {
        entry: [
            {
                fields: {
                    required: [],
                    optional: [
                        'acceleration',
                        'description'
                    ],
                    wildcard: []
                }
            }
        ]
    };

    var UPDATE_NO_ACCELERATION_WHITELIST = {
        entry: [
            {
                fields: {
                    required: [],
                    optional: [
                        'description'
                    ],
                    wildcard: []
                }
            }
        ]
    };

    var DataModelWhiteList = SplunkDWhiteListV2.extend({

        sync: function(method, model, options) {
            if(method !== 'read') {
                throw new Error('Method not supported: ' + method);
            }
            var response;
            if(options.url.indexOf(model.url + '/_new') > -1) {
                response = CREATE_DATA_MODEL_WHITELIST;
            }
            else {
                response = DataModelWhiteList.canEditAcceleration ? UPDATE_DATA_MODEL_WHITELIST : UPDATE_NO_ACCELERATION_WHITELIST;
            }
            model.trigger('request', model, response, options);
            options.success(response);

            // Don't pass anything to resolve because we didn't make an AJAX call to proxy
            // We don't fake any arguments either, because there is no standard coming back from the jQuery AJAX call
            return $.Deferred().resolve();
        }

    },
    {
        canEditAcceleration: true
    });

    return DataModelWhiteList;
});

/**
 * A model representing a single data model object field.
 *
 * To be used only as a model inside the "collections/services/datamodel/private/Fields" collection
 *
 * For a description of possible attributes, see http://eswiki.splunk.com/Data_Model_JSON_Specification#Field
 */

define('models/services/datamodel/private/Field',
    [
        'underscore',
        'models/Base'
    ],
    function(_, BaseModel) {

        var Field =  BaseModel.extend({

            idAttribute: 'fieldName',

            defaults: {
                type: 'string',
                constraints: [],
                fieldName: '',
                required: false,
                multivalue: false,
                hidden: false,
                editable: true
            },

            validation: {
                fieldName: [
                    {
                        required: true,
                        msg: _("Field Name is required.").t()
                    },
                    {
                        pattern: /^((?![{}"\s*']).)*$/g,
                        msg: _("Field Name can not contain whitespace, double quotes, single quotes, curly braces or asterisks.").t()
                    }
                ],
                displayName: [
                    {
                        required: false
                    },
                    {
                        pattern: /^((?!\*).)*$/,
                        msg: _("Display Name can not contain an asterisk.").t()
                    }
                ]
            },

            getBasicDescription: function() {
                return ({
                    displayName: this.get('displayName'),
                    fieldName: this.get('fieldName'),
                    type: this.get('type'),
                    localizedType: this.getLocalizedType(),
                    hidden: this.get('hidden'),
                    required: this.get('required'),
                    owner: this.get('owner'),
                    editable: this.get('editable')
                });
            },

            getLocalizedType: function() {
                var type = this.get("type");
                var localizedType = type;
                switch (type) {
                    case "string":
                        localizedType = _("String").t();
                        break;
                    case "number":
                        localizedType = _("Number").t();
                        break;
                    case "timestamp":
                        localizedType = _("Time").t();
                        break;
                    case "boolean":
                        localizedType = _("Boolean").t();
                        break;
                    case "ipv4":
                        localizedType = _("IPv4").t();
                        break;
                }

                return localizedType;
            }
        },
        {
            createRawField: function() {
                return new Field({multivalue: false,
                                  owner: "BaseEvent",
                                  fieldSearch: "",
                                  fieldName: "_raw",
                                  type: "string",
                                  displayName: "_raw",
                                  hidden: false,
                                  required: false,
                                  editable: true});
            }
        });
        return Field;
    }
);
/**
 * @author sfishel
 *
 * A collection of fields contained in each data model object.
 *
 * To be used only as an internal members of the "models/services/datamodel/private/Object" module
 * and the "models/services/datamodel/private/Calculation" module
 */

define('collections/services/datamodel/private/Fields',['collections/Base', 'models/services/datamodel/private/Field'], function(Base, Field) {

    return Base.extend({ model: Field });

});
/**
 * Util package for working with models.
 */

define('util/model_utils',['underscore'], function(_) {

    var collectionsAreEquivalent = function(coll1, coll2) {
        return _(coll1.toJSON()).isEqual(coll2.toJSON());
    };

    /**
     * @author sfishel
     *
     * A method to reset a collection, first checks that the new data is different from the data already there
     *
     * @param collection {Collection} the collection to reset
     * @param data {Array<Object>} the data to reset the collection
     * @param options {Object} options to be passed to Backbone's reset method
     */

    var safeResetCollection = function(collection, data, options) {
        var comparisonCollection = new collection.constructor();
        comparisonCollection.reset(data, options);
        if(!collectionsAreEquivalent(collection, comparisonCollection)) {
            collection.reset(data, options);
        }
    };

    /**
     * @author sfishel
     *
     * Parse out and handle the JSON representation of a nested collection from a raw sync response.
     *
     * @param model {Model} - the parent model
     * @param response {Object} - the JSON sync response
     * @param keyName {String} - the name of the model attribute that should contain the collection
     * @param collType {Constructor} - the constructor for the nested collection
     */

    var parseNestedCollection = function(model, response, keyName, collType) {
        response = response || {};
        // if the nested collection doesn't exist yet, create a new one
        if(!model.attributes || !model.get(keyName)) {
            // TODO: what if we needed to parse at the collection level here?
            response[keyName] = new collType(response[keyName] || [], { parse: true });
        }
        // otherwise reset the collection if new models were specified in the response
        else if(response[keyName]) {
            var collection = model.get(keyName),
            // have to explicitly call the collection's parse method
                parsedModels = collection.parse.call(collection, response[keyName]),
            // create new collection to compare to the old one to see if anything changed
                comparisonCollection = new collType(parsedModels, { parse: true });

            // if the two collections are different, reset the model's collection to the contents of the new one
            if(!collectionsAreEquivalent(collection, comparisonCollection)) {
                collection.reset(comparisonCollection.toArray());
            }
            // remove the objects from the response so they don't get passed to 'set'
            delete(response[keyName]);
        }
    };

    /**
     * @author sfishel
     *
     * Bind to a nested collection and bubble up some custom events at the model level.
     *
     * @param model {Model} - the parent model
     * @param keyName {String} - the name of the model attribute that contains the collection
     * @param collType {Constructor} - the constructor for the nested collection
     */
    
    var bindNestedCollection = function(model, keyName, collType, options) {
        if(!model.get(keyName)) {
            model.set(keyName, new collType(), options);
        }
        var collection = model.get(keyName);
        // TODO: should we pass some information along when these events are triggered?
        collection.on('add', function(added, collection, options) {
            model.trigger('add:' + keyName, added, collection, options);
            model.trigger('change');
        });
        collection.on('remove', function(removed, collection, options) {
            model.trigger('remove:' + keyName, removed, collection, options);
            model.trigger('change');
        });
        collection.on('reset', function(collection, options) {
            model.trigger('reset:' + keyName, collection, options);
            model.trigger('update:' + keyName);
            model.trigger('change');
        });
        collection.on('change', function(changed, options) {
            model.trigger('change:' + keyName, changed, options);
            model.trigger('update:' + keyName);
            model.trigger('change');
        });
    };
    
    return ({
        safeResetCollection: safeResetCollection,
        parseNestedCollection: parseNestedCollection,
        bindNestedCollection: bindNestedCollection
    });
    
});
/**
 * A model representing a single calculation operation.
 *
 * To be used only as a model inside the "collections/services/datamodel/private/Calculations" collection
 *
 * For a description of available attributes, see http://eswiki.splunk.com/Data_Model_JSON_Specification#Calculation
 */

define('models/services/datamodel/private/Calculation',[
            'jquery',
            'underscore',
            'collections/services/datamodel/private/Fields',
            'models/Base',
            'util/model_utils'
        ],
        function(
            $,
            _,
            Fields,
            BaseModel,
            modelUtils
        ) {

    return BaseModel.extend({

        idAttribute: 'calculationID',
        outputFieldsClass: Fields,

        initialize: function(attrs, options) {
            BaseModel.prototype.initialize.call(this, attrs, options);
            this.initializeAssociated();
        },

        getBasicDescription: function() {
            return ({
                calculationID: this.get('calculationID'),
                calculationType: this.get('calculationType'),
                expandedType: this.getExpandedType(),
                outputFields: this.getFieldList(),
                expression: this.get('expression'),
                owner: this.get('owner'),
                editable: this.get('editable')
            });
        },

        getFieldAt: function(index) {
            return this.outputFields.at(index);
        },

        getFieldByName: function(name) {
            return this.outputFields.get(name);
        },

        removeField: function(cid) {
            var outputFields = this.outputFields,
                toRemove = outputFields.get(cid);

            return outputFields.remove(toRemove);
        },

        removeFieldByName: function(fieldName, options) {
            var outputFields = this.outputFields,
                toRemove = outputFields.get(fieldName);

            outputFields.remove(toRemove, options);
        },

        removeAllFields: function(options) {
            var outputFields = this.outputFields;
            outputFields.reset([], options);
        },

        addField: function(attributes, options) {
            attributes = attributes || {};
            $.extend(attributes, {
                owner: this.get('owner')
            });

            var beforeLength = this.outputFields.length;

            this.outputFields.add(attributes, options);

            return this.outputFields.at(beforeLength);
        },

        withEachField: function(callback, context) {
            context = context || null;
            this.outputFields.each(callback, context);
        },

        getFieldNames: function() {
            return this.outputFields.map(function(outputField) {
                return outputField.get("fieldName");
            }, this);
        },

        // ----- sync behavior ----- //


        initializeAssociated: function() {
            this.associated = this.associated || {};

            if (!this.outputFields) {
                this.outputFields = this.associated.outputFields = new this.outputFieldsClass();
                this.outputFields.on("change associatedChange add remove update reset",
                function(model, options) {
                    this.trigger("associatedChange", model, options);
                }, this);
            }
        },

        clone: function(options) {
            var clone = BaseModel.prototype.clone.apply(this, arguments);
            clone.outputFields.set(this.outputFields.toJSON(options));
            return clone;
        },

        parse: function(response, options) {
            response = $.extend(true, {}, response);
            return this.parseAssociated(response, options);
        },

        parseAssociated: function(response, options) {
            this.initializeAssociated();
            if(response.outputFields) {
                this.outputFields.set(response.outputFields, $.extend({ parse: true }, options));
                delete response.outputFields;
            }
            return response;
        },

        toJSON: function(options) {
            var json = BaseModel.prototype.toJSON.apply(this, arguments);
            json.outputFields = this.outputFields.toJSON(options);
            // TODO [sff] look into these comments from the original toJSON function
            // work-around for SPL-56828, the read endpoint response is different from what the update endpoint expects
            // removing customData from the json spec...fix for SPL-57405
            return json;
        },


        // ----- private methods ----- //


        getFieldList: function() {
            return this.outputFields.map(function(field) {
                return field.getBasicDescription();
            });
        },

        getExpandedType: function() {
            var type = this.get("calculationType");

            var returnType = type;

            switch(type) {
                case "Eval":
                    returnType = _("Eval Expression").t();
                    break;
                case "GeoIP":
                    returnType = _("Geo IP").t();
                    break;
                case "Rex":
                    returnType = _("Regular Expression").t();
                    break;
                case "Lookup":
                    returnType = _("Lookup").t();
                    break;
            }

            return returnType;
        },

        toString: function() {
            return "Calculation " + this.get("calculationType") + "[" + this.get("calculationID") + "]";
        }

    });

});

/**
 * @author jszeto
 * @date 12/7/12
 */
define('models/services/datamodel/private/EvalCalculation',['underscore', 'models/services/datamodel/private/Calculation'], function(_, Calculation) {

    /**
     * Represents an Eval Calculation.
     *
     */
    return Calculation.extend({

        defaults: {
            calculationType: "Eval",
            expression: "",
            editable: true
        },

        validation: {
            expression : {
                required : true,
                msg: _("Eval Expression is a required field.").t()
            },
            calculationType : {
                oneOf : ["Eval"]
            }
        },

        toString: function() {
            if (this.outputFields.length > 0)
                return "EvalCalc [" + this.outputFields.at(0).get("displayName") + "]";
            else
                return "Empty EvalCalc";
        }

    });
});
/**
 * A model representing a single data model object output field for a Lookup or GeoIP Calculation.
 *
 * To be used only as a model inside the "collections/services/datamodel/private/LookupOutputFields" collection
 *
 * For a description of possible attributes, see http://eswiki.splunk.com/Data_Model_JSON_Specification#Field
 */

define('models/services/datamodel/private/LookupOutputField',
    [
        'underscore',
        'models/services/datamodel/private/Field'
    ],
    function(_, Field) {

        return Field.extend({

            idAttribute: 'fieldName',

            defaults: {
                type: 'string',
                constraints: [],
                fieldName: '',
                lookupOutputFieldName: '',
                required: false,
                multivalue: false,
                hidden: false,
                editable: true
            },

            validation: {
                fieldName: [
                    {
                        required: true,
                        msg: _("Field Name is required.").t()
                    },
                    {
                        pattern: /^((?![{}"\s*']).)*$/g,
                        msg: _("Field Name can not contain whitespace, double quotes, single quotes, curly braces or asterisks.").t()
                    }
                ],
                displayName: [
                    {
                        required: false
                    },
                    {
                        pattern: /^((?!\*).)*$/,
                        msg: _("Display Name can not contain an asterisk.").t()
                    }
                ],
                lookupOutputFieldName: {
                    required: true,
                    msg: _("Field in Lookup is a required field.").t()
                }
            },

            getBasicDescription: function() {
                return ({
                    displayName: this.get('displayName'),
                    lookupOutputFieldName: this.get('lookupOutputFieldName'),
                    fieldName: this.get('fieldName'),
                    type: this.get('type'),
                    localizedType: this.getLocalizedType(),
                    hidden: this.get('hidden'),
                    required: this.get('required'),
                    owner: this.get('owner'),
                    editable: this.get('editable')
                });
            }
        });
    }
);
/**
 * @author jszeto
 *
 * A collection of LookupOutputFields contained in the Lookup or GeoIP Calculation
 *
 * To be used only as an internal members of the "models/services/datamodel/private/LookupCalculation" module
 * and the "models/services/datamodel/private/GeoIPCalculation" module
 */

define('collections/services/datamodel/private/LookupOutputFields',['collections/services/datamodel/private/Fields', 'models/services/datamodel/private/LookupOutputField'], function(Fields, LookupOutputField) {

    return Fields.extend({ model: LookupOutputField });

});
/**
 * @author jszeto
 * @date 12/7/12
 */
define('models/services/datamodel/private/GeoIPCalculation',['backbone',
        'underscore',
        'models/services/datamodel/private/Calculation',
        'collections/services/datamodel/private/LookupOutputFields'
       ],
    function(
        Backbone,
        _,
        Calculation,
        LookupOutputFields) {

    /**
     * Represents an GeoIP Calculation.
     *
     */
    return Calculation.extend({

        defaults: {
            calculationType: "GeoIP",
            inputField: "",
            editable: true
        },

        initialize: function(attrs, options) {
            Calculation.prototype.initialize.call(this, attrs, options);

            this.on("change:inputField", this.inputFieldChanged, this);
        },

        inputFieldChanged: function(model, value, options) {
            if (value !== "") {
                this.withEachField(function(field) {
                    field.set("fieldName", value + "_" + field.get("lookupOutputFieldName"));
                }, this);
            }
        },

        getVisibleOutputFieldsLength: function() {
            var visibleCount = 0;
            this.outputFields.each(function(field) {
                if (!field.get("hidden"))
                    visibleCount++;
            }, this);

            return visibleCount;
        },

        validation: {
            inputField : {
                required : true,
                msg : _("A Geo IP Calculation must contain an input field.").t()
            },
            calculationType : {
                oneOf : ["GeoIP"],
                fn : function(value, attr, computedState) {
                    var outputFields = this.outputFields;
                    var visibleCount = 0;
                    if (outputFields instanceof Backbone.Collection) {
                        var length = outputFields.length;

                        for (var i = 0; i < length; i++) {
                            var field = outputFields.at(i);
                            if (!field.get("hidden"))
                                visibleCount++;
                            if (!_.isUndefined(field.get("displayName")) && field.get("displayName").indexOf('"') != -1)
                                return _('A Geo IP Attribute Display Name cannot contain a quotation mark.').t();
                        }

                        if (visibleCount == 0) {
                            return _("Select at least one Geo IP Attribute.").t();
                        }
                    } else {
                        return _("Internal Error: The Geo IP outputFields are invalid.").t();
                    }
                }
            }
        },


        /**
         * Create the initial outputFields for a GeoIP Calculation
         *
         * @param options
         */
        addGeoIPFields: function(options) {
            this.addGeoIPField("lon", "number", options);
            this.addGeoIPField("lat", "number", options);
            this.addGeoIPField("City", "string", options);
            this.addGeoIPField("Region", "string", options);
            this.addGeoIPField("Country", "string", options);
        },

        addGeoIPField: function(fieldName, type, options) {
            var attributes = {required:true,
                hidden:false,
                type:type,
                lookupOutputFieldName: fieldName,
                fieldName: this.get("inputField") + "_" + fieldName};

            this.addField(attributes, options);
        },

        initializeAssociated: function() {
            this.associated = this.associated || {};
            this.outputFields = this.associated.outputFields = this.outputFields || new LookupOutputFields();
            this.outputFields.on("change associatedChange add remove update reset",
                function(model, options) {
                    this.trigger("associatedChange", model, options);
                }, this);
        }

    });
});
/**
 * @author jszeto
 * @date 1/14/14
 */

/**
 * A model representing a single data model object lookup input field for a Lookup Calculation.
 *
 * To be used only as a model inside the "collections/services/datamodel/private/LookupInputFields" collection
 */

define('models/services/datamodel/private/LookupInput',
    [
        'underscore',
        'models/Base'
    ],
    function(_, BaseModel) {

        return BaseModel.extend({

            idAttribute: 'lookupField',

            defaults: {
                lookupField: '',
                inputField: ''
            },

            validation: {
                lookupField: {
                    required: true,
                    msg: _("Field in Lookup is a required field.").t()
                },
                inputField: {
                    required: true,
                    msg: _("Input Attribute is required.").t()
                }
            }
        });
    }
);

/*
 * @author jszeto
 * @date 1/14/14
 *
 * A collection of LookupInputs contained in the Lookup Calculation
 *
 * To be used only as an internal members of the "models/services/datamodel/private/LookupInput" module
 */

define('collections/services/datamodel/private/LookupInputs',['collections/Base', 'models/services/datamodel/private/LookupInput'], function(BaseCollection, LookupInput) {

    return BaseCollection.extend({model: LookupInput});

});

/**
 * @author jszeto
 * @date 12/7/12
 */
define('models/services/datamodel/private/LookupCalculation',['jquery',
        'underscore',
        'backbone',
        'models/services/datamodel/private/Calculation',
        'collections/services/datamodel/private/LookupInputs',
        'collections/services/datamodel/private/LookupOutputFields'
       ],
    function(
        $,
        _,
        Backbone,
        Calculation,
        LookupInputs,
        LookupOutputFields
    ) {

    /**
     * Represents a Lookup Calculation.
     *
     */
    return Calculation.extend({

        outputFieldsClass: LookupOutputFields,

        defaults: {
            calculationType: "Lookup",
            lookupName: undefined,
            inputField: "",
            lookupField: "",
            editable: true
        },

        validation: {
            lookupName : {
                required : true,
                msg: _("Select a valid Lookup Table.").t()
            }/*,
            lookupField: {
                required : true,
                msg: _("Input Field in Lookup is a required field").t()
            },
            inputField : {
                required : true,
                msg: _("Select a valid Input Attribute.").t()
            }*/
        },

        initializeAssociated: function() {
            Calculation.prototype.initializeAssociated.apply(this, arguments);

            if (!this.lookupInputs) {
                this.lookupInputs = this.associated.lookupInputs = this.lookupInputs || new LookupInputs();
                this.lookupInputs.on("change associatedChange add remove update reset",
                    function(model, options) {
                        this.trigger("associatedChange", model, options);
                    }, this);
            }
        },

        parseAssociated: function(response, options) {
            Calculation.prototype.parseAssociated.call(this, response, options);
            if(response.lookupInputs) {
                this.lookupInputs.set(response.lookupInputs, $.extend({ parse: true }, options));
                delete response.lookupInputs;
            }
            return response;
        },

        toJSON: function(options) {
            var json = Calculation.prototype.toJSON.apply(this, arguments);
            json.lookupInputs = this.lookupInputs.toJSON(options);
            return json;
        },

        /**
         * Remove an output field by matching its lookupOutputFieldName
         * @param lookupOutputFieldName
         * @return {*}
         */
        removeFieldByLookup: function(lookupOutputFieldName) {
            var field = this.outputFields.findWhere({lookupOutputFieldName: lookupOutputFieldName});
            if (field)
                this.outputFields.remove(field);

            return field;
        },

        /**
         * Returns the output field with the given lookupOutputFieldName
         *
         * @param lookupOutputFieldName
         * @return {*}
         */
        getFieldByLookup: function(lookupOutputFieldName) {
            return this.outputFields.findWhere({lookupOutputFieldName: lookupOutputFieldName});
        },

        /**
         * Run a function on each LookupInput
         *
         * @param callback
         * @param context
         */
        withEachLookupInput: function(callback, context) {
            context = context || null;
            this.lookupInputs.each(callback, context);
        },

        /**
         * Add a new LookupInput to lookupInputs
         * @param attributes
         * @param options
         * @return {*}
         */
        addLookupInput: function(attributes, options) {
            var beforeLength = this.lookupInputs.length;
            this.lookupInputs.add(attributes, options);
            return this.lookupInputs.at(beforeLength);
        },

        /**
         * Remove a lookupInput
         * @param cid
         */
        removeLookupInput: function(cid) {
            var toRemove = this.lookupInputs.get(cid);
            this.lookupInputs.remove(toRemove);
        },

        /**
         * Remove all lookupInputs
         * @param options
         */
        removeAllLookupInputs: function(options) {
            this.lookupInputs.reset([], options);
        },

        /**
         * Return the lookup input associated with a given lookupField
         * @param lookupField
         * @return {*}
         */
        getLookupInput: function(lookupField) {
            return this.lookupInputs.find(function(lookupInput) {
                return lookupInput.get("lookupField") == lookupField;
            }, this);
        }

    });
});
/**
 * @author jszeto
 * @date 3/5/14
 *
 * A model representing a single data model object output field for a Rex Calculation.
 *
 * To be used only as a model inside the "collections/services/datamodel/private/RexOutputFields" collection
 *
 * For a description of possible attributes, see http://eswiki.splunk.com/Data_Model_JSON_Specification#Field
 */

define('models/services/datamodel/private/RexOutputField',
    [
        'underscore',
        'models/services/datamodel/private/Field'
    ],
    function(_, Field) {

        return Field.extend({

            toJSON: function(options) {
                var json = Field.prototype.toJSON.apply(this, arguments);
                // If options.data.provisional == true, then always return required = false
                if (options && options.data && options.data.provisional) {
                    json.required = false;
                }
                return json;
            }

        });
    }
);
/**
 * @author jszeto
 * @date 3/05/2014
 *
 * A collection of RexOutputFields contained in the Rex Calculation
 *
 * To be used only as an internal members of the "models/services/datamodel/private/RexCalculation" module
 */

define('models/services/datamodel/private/RexOutputFields',['collections/services/datamodel/private/Fields', 'models/services/datamodel/private/RexOutputField'], function(Fields, RexOutputField) {

    return Fields.extend({ model: RexOutputField });

});
/**
 * @author jszeto
 * @date 12/7/12
 */
define('models/services/datamodel/private/RexCalculation',['underscore',
        'backbone',
        'splunk.util',
        'models/services/datamodel/private/Calculation',
        'models/services/datamodel/private/RexOutputFields'],
    function(
        _,
        Backbone,
        splunkUtil,
        Calculation,
        RexOutputFields) {

    /**
     * Represents a Rex Calculation.
     *
     */
    return Calculation.extend({
        outputFieldsClass: RexOutputFields,

        defaults: {
            calculationType: "Rex",
            expression: "",
            inputField: "",
            outputFields: undefined,
            editable: true
        },

        validation: {
            expression : [
                {
                    required : true,
                    msg: _("Regular Expression is a required field.").t()
                }/*,
                {
                    fn : function(value, attr, computedState) {
                        var outputFields = computedState.outputFields;
                        if (outputFields instanceof Backbone.Collection) {
                            if (outputFields.length == 0) {
                                return "A Rex Calculation must contain at least one outputField";
                            }
                        } else {
                            return "Rex Calculation outputFields is invalid";
                        }
                    }
                }*/
            ],
            inputField : {
                required : true,
                msg : _("Select a field to Extract From.").t()
            },
            calculationType : {
                oneOf : ["Rex"]
            }

        },

        getPreviewSearch: function() {
            return splunkUtil.sprintf('rex field=%s "%s" max_match=1',
                                this.get("inputField"), this.get("expression"));
        },

        getPreviewAllSearch: function() {
            return splunkUtil.sprintf('eval _is_match = if(match(%s, "%s"), 1, 0)',
                                this.get("inputField"), this.get("expression"));
        },

        getPreviewMatchSearch: function() {
            return splunkUtil.sprintf('where match(%s, "%s")',
                                this.get("inputField"), this.get("expression"));
        },

        getPreviewNonMatchSearch: function() {
            return splunkUtil.sprintf('where NOT match(%s, "%s")',
                                this.get("inputField"), this.get("expression"));
        }

    });
});
/**
 * A collection of calculations contained in each data model object.
 *
 * To be used only as an internal member of the "models/services/datamodel/private/Object" module
 */

define('collections/services/datamodel/private/Calculations',[
            'jquery',
            'collections/Base',
            'models/services/datamodel/private/Calculation',
            'models/services/datamodel/private/EvalCalculation',
            'models/services/datamodel/private/GeoIPCalculation',
            'models/services/datamodel/private/LookupCalculation',
            'models/services/datamodel/private/RexCalculation'
       ],
       function(
            $,
            Base,
            Calculation,
            EvalCalculation,
            GeoIPCalculation,
            LookupCalculation,
            RexCalculation
           ) {

    // Create a specific Calculation class based on the calculationType
    var ModelFactory = function(attributes, options) {

        switch(attributes.calculationType) {
            case 'Eval':
                return new EvalCalculation(attributes, options);
            case 'GeoIP':
                return new GeoIPCalculation(attributes, options);
            case 'Lookup':
                return new LookupCalculation(attributes, options);
            case 'Rex':
                return new RexCalculation(attributes, options);
            default:
                return new Calculation(attributes, options);
        }
    };

    // make sure the model factory prototype has the correct idAttribute
    $.extend(ModelFactory.prototype, {
        idAttribute: Calculation.prototype.idAttribute
    });

    return Base.extend({

        model: ModelFactory,

        toString: function() {

            var children = "";
            this.each(function(calculation) {
                if (children != "")
                    children += ", ";
                children += calculation.toString();
            }, this);

            return "Calculations [" + children + "]";
        }
    });

});
define('collections/services/datamodel/private/FieldSampleValues',[
            'jquery',
            'collections/Base',
            'models/Base',
            'util/splunkd_utils'
        ],
        function(
            $,
            BaseCollection,
            BaseModel,
            splunkdUtils
        ) {

    var SampleValues = BaseModel.extend({

        idAttribute: 'fieldName',

        defaults: {
            limit: 10
        },

        sync: function(method, model, options) {
            if(method !== 'read') {
                throw new Error('sync method not supported: ' + method);
            }
            var baseUrl = 'search/jobs',
                ajaxData = $.extend(true, {}, options, {
                    data: {
                        exec_mode: 'oneshot',
                        output_mode: 'json_cols',
                        max_time: 30
                    },
                    type: 'POST',
                    dataType: 'json'
                });

            if(model.collection.tsidxNamespace) {
                ajaxData.data.search = '| tstats count from ' + model.collection.tsidxNamespace
                                                 + ' groupby ' + this.id + ' | sort limit=' + this.get('limit') + ' -count';
            }
            else {
                ajaxData.data.search = model.collection.baseSearch + ' | top ' + this.get('limit') + ' "' + this.id + '"';
            }

            return $.ajax(splunkdUtils.prepareSyncOptions(ajaxData, baseUrl));
        },

        parse: function(response) {
            var values = (response && response.columns && response.columns.length > 0 ) ? response.columns[0] : [];
            return { values: values };
        }

    });

    return BaseCollection.extend({

        model: SampleValues,

        initialize: function(models, options) {
            options = options || {};
            this.setBaseSearch(options.baseSearch);
            this.setTsidxNamespace(options.tsidxNamespace);
            BaseCollection.prototype.initialize.apply(this, arguments);
        },

        setBaseSearch: function(baseSearch) {
            this.baseSearch = baseSearch;
        },

        setTsidxNamespace: function(ns) {
            this.tsidxNamespace = ns;
        }

    });

});
/**
 * @author sfishel
 *
 * A util package for working with pivot report element forms.
 *
 * Provides some centralized functions for translating report element property values into corresponding display strings.
 * These functions are shared by the pivot report element views and models to avoid duplicate code.
 */

define('util/pivot/config_form_utils',[
            'underscore',
            'util/time',
            'splunk.util',
            'splunk.i18n'
        ],
        function(
            _,
            timeUtils,
            splunkUtils,
            i18n
        ) {

    var MATCH_FILTER_LABELS = {
        is: _('%(fieldName)s is %(matchValue)s').t(),
        contains: _('%(fieldName)s contains %(matchValue)s').t(),
        isNot: _('%(fieldName)s is not %(matchValue)s').t(),
        doesNotContain: _('%(fieldName)s does not contain %(matchValue)s').t(),
        startsWith: _('%(fieldName)s starts with %(matchValue)s').t(),
        endsWith: _('%(fieldName)s ends with %(matchValue)s').t(),
        isNull: _('%(fieldName)s is null').t(),
        isNotNull: _('%(fieldName)s is not null').t(),
        regex: _('%(fieldName)s matches %(matchValue)s').t(),
        '=': _('%(fieldName)s = %(matchValue)s').t(),
        '!=': _('%(fieldName)s != %(matchValue)s').t(),
        '<=': _('%(fieldName)s <= %(matchValue)s').t(),
        '<': _('%(fieldName)s < %(matchValue)s').t(),
        '>=': _('%(fieldName)s >= %(matchValue)s').t(),
        '>': _('%(fieldName)s > %(matchValue)s').t(),
        'true': _('%(fieldName)s is true').t(),
        'false': _('%(fieldName)s is false').t()
    };

    var FILTER_RULE_DISPLAY_NAMES = {
        is: _('is').t(),
        contains: _('contains').t(),
        isNot: _('is not').t(),
        doesNotContain: _('does not contain').t(),
        startsWith: _('starts with').t(),
        endsWith: _('ends with').t(),
        isNull: _('is null').t(),
        isNotNull: _('is not null').t(),
        regex: _('regex').t(),
        '=': _('=').t(),
        '!=': _('!=').t(),
        '<=': _('<=').t(),
        '<': _('<').t(),
        '>=': _('>=').t(),
        '>': _('>').t(),
        'true': _('is true').t(),
        'false': _('is false').t()
    };

    var LIMIT_FILTER_LABELS_LONG = {
        highest: _('Highest %(limitAmount)s %(fieldName)s by %(limitBy)s').t(),
        lowest: _('Lowest %(limitAmount)s %(fieldName)s by %(limitBy)s').t()
    };

    var LIMIT_FILTER_LABELS_SHORT = {
        highest: _('Highest %(limitAmount)s %(fieldName)s').t(),
        lowest: _('Lowest %(limitAmount)s %(fieldName)s').t()
    };

    var FILTER_LIMIT_TYPE_DISPLAY_NAMES = {
        highest: _('Highest').t(),
        lowest: _('Lowest').t()
    };

    var CELL_VALUE_LABELS = {
        'list': _('Values of %(fieldName)s').t(),
        'values': _('Distinct Values of %(fieldName)s').t(),
        'first': _('First Value of %(fieldName)s').t(),
        'last': _('Last Value of %(fieldName)s').t(),
        'count': _('Count of %(fieldName)s').t(),
        'dc': _('Distinct Count of %(fieldName)s').t(),
        'sum': _('Sum of %(fieldName)s').t(),
        'avg': _('Average of %(fieldName)s').t(),
        'max': _('Max of %(fieldName)s').t(),
        'min': _('Min of %(fieldName)s').t(),
        'stdev': _('Standard Deviation of %(fieldName)s').t(),
        'median': _('Median of %(fieldName)s').t(),
        'duration': _('Duration').t(),
        'listDistinct': _('Distinct Values of %(fieldName)s').t()
    };

    var CELL_VALUE_DISPLAY_NAMES = {
        'list': _('List Values').t(),
        'values': _('List Distinct Values').t(),
        'first': _('First Value').t(),
        'last': _('Last Value').t(),
        'count': _('Count').t(),
        'dc': _('Distinct Count').t(),
        'sum': _('Sum').t(),
        'avg': _('Average').t(),
        'max': _('Max').t(),
        'min': _('Min').t(),
        'stdev': _('Standard Deviation').t(),
        'median': _('Median').t(),
        'duration': _('Duration').t(),
        'earliest': _('Earliest').t(),
        'latest': _('Latest').t(),
        'listDistinct': _('List Distinct Values').t()
    };

    var CELL_VALUE_OUTPUT_TYPES = {
        'list': 'dimension',
        'values': 'dimension',
        'first': 'dimension',
        'last': 'dimension',
        'count': 'metric',
        'dc': 'metric',
        'sum': 'metric',
        'avg': 'metric',
        'max': 'metric',
        'min': 'metric',
        'stdev': 'metric',
        'median': 'metric',
        'duration': 'metric',
        'earliest': 'dimension',
        'latest': 'dimension',
        'listDistinct': 'dimension'
    };

    var SPLIT_MODE_DISPLAY_NAMES = {
        'all': _('All Values').t(),
        'ranges': _('Value Ranges').t()
    };

    var sampleDate = new Date(2011, 0, 31, 23, 1, 1),
        formatSampleDate = function(granularity) {
            return i18n.format_date(sampleDate, timeUtils.RESULTS_TIMESTAMP_FORMATS[granularity]);
        };

    var SPLIT_TIME_PERIOD_DISPLAY_NAMES = {
        'auto': _('Auto').t(),
        'year': splunkUtils.sprintf(_('Years (%(sampleDate)s)').t(), { sampleDate: formatSampleDate('year') }),
        'month': splunkUtils.sprintf(_('Months (%(sampleDate)s)').t(), { sampleDate: formatSampleDate('month') }),
        'day': splunkUtils.sprintf(_('Days (%(sampleDate)s)').t(), { sampleDate: formatSampleDate('day') }),
        'hour': splunkUtils.sprintf(_('Hours (%(sampleDate)s)').t(), { sampleDate: formatSampleDate('hour') }),
        'minute': splunkUtils.sprintf(_('Minutes (%(sampleDate)s)').t(), { sampleDate: formatSampleDate('minute') }),
        'second': splunkUtils.sprintf(_('Seconds (%(sampleDate)s)').t(), { sampleDate: formatSampleDate('second') })
    };

    var SPLIT_TIME_PERIOD_DISPLAY_NAMES_SHORT = {
        'auto': _('Auto').t(),
        'year': _('Years').t(),
        'month': _('Months').t(),
        'day': _('Days').t(),
        'hour': _('Hours').t(),
        'minute': _('Minutes').t(),
        'second': _('Seconds').t()
    };

    /**
     * @param dict
     * @param key
     * @return the corresponding value of the key in the dict, or the key itself if it is not in the dict
     */
    var dictValueOrKey = function(dict, key) {
        return dict.hasOwnProperty(key) ? dict[key] : key;
    };

    return ({

        getMatchFilterLabel: function(fieldName, ruleKey, matchValue) {
            return splunkUtils.sprintf(
                MATCH_FILTER_LABELS[ruleKey],
                { fieldName: fieldName, matchValue: matchValue }
            );
        },

        filterRuleToDisplay: function(rule) {
            return FILTER_RULE_DISPLAY_NAMES[rule];
        },

        getLimitFilterLabel: function(fieldName, limitType, limitAmount, limitBy) {
            if(limitBy) {
                return splunkUtils.sprintf(
                    LIMIT_FILTER_LABELS_LONG[limitType],
                    { fieldName: fieldName, limitAmount: limitAmount, limitBy: limitBy }
                );
            }
            return splunkUtils.sprintf(
                LIMIT_FILTER_LABELS_SHORT[limitType],
                { fieldName: fieldName, limitAmount: limitAmount }
            );
        },

        filterLimitTypeToDisplay: function(limitType) {
            return FILTER_LIMIT_TYPE_DISPLAY_NAMES[limitType];
        },

        cellValueToDisplay: function(valueType) {
            return CELL_VALUE_DISPLAY_NAMES[valueType];
        },

        getCellValueLabel: function(fieldName, valueKey) {
            return splunkUtils.sprintf(CELL_VALUE_LABELS[valueKey], { fieldName: fieldName });
        },

        cellValueToOutputType: function(valueType, dataType) {
            if(dataType === 'objectCount' || dataType === 'childCount') {
                return 'metric';
            }
            return CELL_VALUE_OUTPUT_TYPES[valueType];
        },

        splitModeToDisplay: function(mode) {
            return dictValueOrKey(SPLIT_MODE_DISPLAY_NAMES, mode);
        },

        splitTimePeriodToDisplay: function(period, showSamples) {
            if(showSamples) {
                return dictValueOrKey(SPLIT_TIME_PERIOD_DISPLAY_NAMES, period);
            }
            return dictValueOrKey(SPLIT_TIME_PERIOD_DISPLAY_NAMES_SHORT, period);
        },

        booleanFieldNameLabel: function(fieldName, isTrue) {
            return isTrue ?
                splunkUtils.sprintf(_('is %(fieldName)s').t(), { fieldName: fieldName }) :
                splunkUtils.sprintf(_('is not %(fieldName)s').t(), { fieldName: fieldName });
        }

    });

});
/**
 * A model representing a single data model object.
 *
 * To be used only as a model inside the "collections/services/datamodel/private/ObjectHierarchy" module.
 *
 * For a description of possible attributes, see http://eswiki.splunk.com/Data_Model_JSON_Specification#Object
 */

define('models/services/datamodel/private/Object',
    [
        'jquery',
        'underscore',
        'models/Base',
        'models/services/datamodel/private/Field',
        'collections/services/datamodel/private/Fields',
        'collections/services/datamodel/private/Calculations',
        'collections/services/datamodel/private/FieldSampleValues',
        'util/pivot/config_form_utils'
    ],
    function(
        $,
        _,
        BaseModel,
        Field,
        Fields,
        Calculations,
        FieldSampleValues,
        formElementUtils
    ) {

        return BaseModel.extend({

            ROOT_OBJECTS: ['BaseEvent', 'BaseTransaction', 'BaseSearch', 'BaseInterface', 'BaseImplements'],

            idAttribute: 'objectName',

            defaults: {
                constraints: [],
                objectsToGroup: []
            },

            validation: {
                displayName: [
                    {
                        required: true,
                        msg: _("Object Name is a required field.").t()
                    },
                    {
                        pattern: /^((?!\*).)*$/,
                        msg: _("Object Name can not contain an asterisk.").t()
                    }

                ],
                objectName: [
                    {
                        required: true,
                        msg: _("Object ID is a required field.").t()
                    },
                    {
                        pattern: /^[\w\-]+$/,
                        msg: _("Object ID can only contain alphanumeric characters, underscores or hyphens. Whitespace is not allowed.").t()
                    },
                    {
                        pattern: /^[^_].*/,
                        msg: _("Object ID can not start with an underscore character.").t()
                    }
                ],
                objectsToGroup: {
                    fn : function(value, attr, computedState) {
                        var rootParent = computedState.parentName;
                        if (rootParent == "BaseTransaction") {
                            if (value.length == 0) {
                                return _("Root transaction objects require at least one Group Objects value.").t();
                            }
                        }
                    }
                },
                baseSearch: {
                    fn: function(value, attr, computedState) {
                        if (computedState.parentName == "BaseSearch") {
                            if (_(value).isUndefined() || value == "") {
                                return _("Root search objects require a Search String.").t();
                            }
                        }
                    }
                }
            },

            initialize: function(attrs, options) {
                BaseModel.prototype.initialize.apply(this, arguments);
                this.initializeAssociated();
            },

            // TODO: this depends on the object being inside of an ObjectHierarchy, it should really be moved
            // (only used in DataModel.js line 80)
            getBasicAttributes: function() {
                return ({
                    objectName: this.get('objectName'),
                    displayName: this.get('displayName'),
                    rootParent: this.get('rootParent'),
                    lineage: this.get('lineage')
                });
            },

            /**
             * Returns the field object corresponding to the given field name and (optionally) owner,
             * or undefined if no field matches.
             *
             * Searches over primitive fields and fields from calculations
             *
             * @param {String} name - the name of the field to match
             * @param {String) owner (optional) - the owner of the field to match
             */

            getFieldByName: function(name, owner) {
                var fields = this.getFieldList(),
                    calculatedFields = _(this.getCalculationList()).chain().pluck('outputFields').flatten().value(),
                    allFields = _.union(fields, calculatedFields);

                return _(allFields).find(function(field) {
                    return (field.fieldName === name && (!owner || field.owner === owner));
                });
            },

            /**
             * Returns the field object corresponding to the index time field, if one exists,
             * otherwise returns undefined.
             *
             * Enforces that the field must have type 'timestamp' to differentiate from user-created fields.
             * (see SPL-82440)
             *
             * @param {String} name - the name of the field to match
             * @param {String) owner (optional) - the owner of the field to match
             */
            getIndexTimeField: function() {
                var candidate = this.getFieldByName('_time');
                if(candidate && candidate.type === 'timestamp') {
                    return candidate;
                }
                return undefined;
            },

            /**
             * Returns a list representing all fields that are available on the object in a reporting context.
             *
             * Includes primitive fields and fields from calculations.
             * Primary sort is by field data type (objectCount then childCount then all others), secondary sort is
             * lexical by field name.
             *
             * @return {Array<Object>}
             */

            getReportFields: function() {
                var fields = _(this.getFieldList()).filter(function(field) { return !field.hidden; }),
                    calculatedFields = _(this.getCalculationList())
                        .chain()
                        .pluck('outputFields').flatten().filter(function(field) { return field.hidden !== true; })
                        .value(),
                    reportFields = _.union(fields, calculatedFields),
                    sortedReportFields = _(reportFields).sortBy(function(field) {
                        // objectCount fields come before the others, followed by childCount,
                        // then sort is alphabetical by field display name (not case-sensitive)
                        var displayNameLower = field.displayName.toLowerCase();
                        if(field.type === 'objectCount') {
                            return 'a' + displayNameLower;
                        }
                        if(field.type === 'childCount') {
                            return 'b' + displayNameLower;
                        }
                        return 'c' + displayNameLower;
                    }),
                    objectCountField = _(sortedReportFields).find(function(field) {
                        return field.type === 'objectCount';
                    });

                // FIXME: this is a little weird
                if(objectCountField) {
                    objectCountField.displayName = formElementUtils.getCellValueLabel(this.get('displayName'), 'count');
                }
                return sortedReportFields;
            },

            /**
             * In order to be opened in pivot, the object must have some report attributes in addition to its
             * "objectCount" and "childCount" fields
             */

            isPivotable: function() {
                return _(this.getReportFields()).any(function(field) {
                    return (field.type !== 'objectCount' && field.type !== 'childCount');
                });
            },

            /**
             * Returns the reportFields (see getReportFields above) and divides it by data type.
             *
             * Data type categories are "timestamp", "objectCount" (also includes childCount) and "other".
             * Return value is a dictionary of category names mapping to lists of field objects.
             *
             * @return {Object}
             */

            getGroupedReportFields: function() {
                var groups = _(this.getReportFields()).groupBy(function(field) {
                    if(field.type === 'timestamp') {
                        return 'timestamp';
                    }
                    if(field.type in { objectCount: true, childCount: true }) {
                        return 'objectCount';
                    }
                    return 'other';
                });

                groups.objectCount = groups.objectCount || [];
                groups.timestamp = groups.timestamp || [];
                groups.other = groups.other || [];
                return groups;
            },

            /**
             * Returns true if the Object's parentName is not BaseTransaction, BaseEvent or BaseSearch
             *
             * @return {Boolean}
             */
            isChildObject: function() {
                return _(this.ROOT_OBJECTS).indexOf(this.get('parentName')) == -1;
            },

            /**
             * Returns a list of field objects representing the fields inherited from the object's parents.
             *
             * Includes primitive fields and fields from calculations.
             *
             * @return {Array<Object>}
             */

            getInheritedFields: function() {
                var ownName = this.get('lineage'),
                    inheritedFields = _(this.getFieldList())
                        .chain()
                        .filter(function(field) { return (field.owner !== ownName && field.type !== 'childCount'); })
                        .sortBy(function(field) {
                            return field.displayName.toLowerCase();
                        })
                        .value(),
                    inheritedCalculatedFields = _(this.getCalculationList())
                    .chain()
                    .filter(function(calc) { return calc.owner !== ownName;})
                    .map(function(calc) {
                        return _(calc.outputFields).chain()
                                                   .map(function(outputField) {
                                                        return $.extend(outputField, {calculationID: calc.calculationID});})
                                                   .value();})
                    .flatten()
                    .value();

                return _.union(inheritedFields, inheritedCalculatedFields);
            },

            /**
             * Returns a list of field objects representing the fields defined by the object itself.
             *
             * Does not include fields from calculations.
             *
             * @return {Array<Object>}
             */

            getOwnFields: function() {
                var ownName = this.get('lineage');
                return _(this.getFieldList())
                    .chain()
                    .filter(function(field) {
                        return (field.owner === ownName && field.type !== 'childCount' && field.type !== 'objectCount'); })
                    .sortBy(function(field) {
                        return field.displayName.toLowerCase();
                    })
                    .value();
            },

            /**
             * Returns a list of own and inherited field objects of type ipv4
             *
             * Does not include fields from calculations.
             *
             * @return {Array<Object>}
             */
            getIPV4Fields: function() {
                return _(this.getAllowedInputFields()).filter(function(field) { return field.type === "ipv4"; });
            },

            /**
             * Returns a list of own and inherited field objects of type ipv4 that are not currently used
             * for a GeoIP Calculation of this Object or its ancestors
             *
             * Does not include fields from calculations.
             *
             * @return {Array<Object>}
             */
            getAvailableIPV4Fields: function() {
                var geoIPCalculations = this.calculations.filter(
                    function(calculation) { return calculation.get("calculationType") === "GeoIP";});

                return _(this.getAllowedInputFields()).filter(
                    function(field) { return field.type === "ipv4" && !_(geoIPCalculations).find(
                         function(calculation) {return field.fieldName === calculation.get("inputField"); }, this);},
                        this);
            },

            /**
             * Returns a list of calculation objects representing the calculations defined by the object itself.
             *
             * @return {Array<Object>}
             */

            getOwnCalculations: function() {
                return _(this.getCalculationList()).filter(function(calc) {
                    return this.isOwnCalculation(calc);
                }, this);
            },

            isOwnCalculation: function(calculation) {
                var outputFieldType = "";
                var ownName = this.get('lineage');

                if (calculation.calculationType == "Eval" && calculation.outputFields.length > 0) {
                    outputFieldType = calculation.outputFields[0].type;
                }

                // TODO [JCS] Don't show StatsField calculations until we decide how to add/edit them.
                return (calculation.owner === ownName && outputFieldType != "childCount"
                        && outputFieldType != "objectCount" && calculation.calculationType != "StatsField");
            },

            /**
             * Filters the collapsed constraints (see getCollapsedConstraints below) to the ones that are inherited
             * from a parent.
             *
             * @return {Array<Object>}
             */

            getInheritedConstraints: function() {
                return _(this.getCollapsedConstraints()).filter(function(constraint) {
                    return constraint.owner !== this.get('lineage');
                }, this);
            },

            /**
             * Filters the collapsed constraints (see getCollapsedConstraints below) to the one that is owned
             * by the object.
             *
             * @return {Array<Object>}
             */

            getOwnConstraint: function() {
                return _(this.getCollapsedConstraints()).find(function(constraint) {
                    return constraint.owner === this.get('lineage');
                }, this);
            },

            /**
             * Returns a list of field objects containing only those field names that can be referenced
             * in the search language.
             *
             * Includes primitive fields and those that come from calculations.
             * Removes all objectCount and childCount fields.
             *
             * @return {Array<String>}
             */

            getAllSearchFields: function() {
                var ownFieldNames = _(this.getOwnFields())
                        .chain()
                        .filter(function(field) { return !(field.type in { objectCount: true, childCount: true }); })
                        .value(),
                    inheritedFieldNames = _(this.getInheritedFields())
                        .chain()
                        .filter(function(field) { return !(field.type in { objectCount: true, childCount: true }); })
                        .value(),
                    ownCalculatedFieldNames = _(this.getOwnCalculations())
                        .chain()
                        .pluck('outputFields').flatten()
                        .value();

                return _.union(inheritedFieldNames, ownFieldNames, ownCalculatedFieldNames);
            },

            /**
             * Returns the results of getAllSearchFields plus the _raw field
             *
             * @return {Array}
             */
            getAllowedInputFields: function() {
                var rawField = [Field.createRawField().getBasicDescription()];
                var allFields = this.getAllSearchFields();

                return _.union(rawField, allFields);
            },

            /**
             * Return true if the field is owned by this Object
             *
             * @param fieldName
             * @return {Boolean}
             */
            isOwnField: function(fieldName) {
                var field = this.getField(fieldName);
                if (field && field.get("owner") == this.get("lineage"))
                    return true;
                return false;
            },


            /**
             * Returns a search string that will generate a table with only the object's search language fields.
             *
             * TODO: we may be able to remove this now that the back end appends it
             *
             * @return {String}
             */

            getPreviewSearch: function() {
                var allFieldNames = _(this.getAllSearchFields()).pluck('fieldName');
                return (this.get('objectSearch') + ' | fields ' + allFieldNames.join(','));
            },

            getCalculationPreviewSearch: function(calculationFieldNames, includeAllFields, includeTime) {
                var previewSearch = this.get("previewSearch") + " | fields ";

                var fieldsString = "";
                var useComma = false;

                if (includeTime)
                    calculationFieldNames.unshift("_time");

                _(calculationFieldNames).each(function(fieldName) {
                    if (useComma)
                        fieldsString += ",";
                    fieldsString += '"' + fieldName + '"';
                    useComma = true;
                }, this);

                if (includeAllFields) {
                    _(this.getAllSearchFields()).each(function(field) {
                        if (!_(calculationFieldNames).contains(field.fieldName)) {
                            if (useComma)
                                fieldsString += ",";
                            fieldsString += '"' + field.displayName + '"';
                            useComma = true;
                        }
                    }, this);

                    if (useComma)
                        fieldsString += ",";
                    fieldsString += "*";
                }

                return previewSearch + fieldsString;
            },

            /**
             * Add a new Field to the Object
             *
             * @param attributes
             * @param options
             * @return The new Field
             */
            addField: function(attributes, options) {
                attributes = $.extend({ owner: this.get('lineage') }, attributes);
                return this.fields.add(attributes, options);
            },
            /**
             * Removes a field from the object
             *
             * Will not remove the field if it is inherited.
             *
             * @param attributes {Object} - the attributes needed to find the field to remove,
             * will be matched by field name
             */

            removeField: function(attributes) {
                var toRemove = this.fields.get(attributes.fieldName);

                if(!toRemove || toRemove.get('owner') !== this.get('lineage')) {
                    // fail silently if the field doesn't exist or it is inherited
                    // FIXME: should we throw or log an error?
                    return;
                }
                this.fields.remove(toRemove);
            },

            getField: function(fieldName) {
                return this.fields.get(fieldName);
            },

            getCalculation: function(calculationID) {
                return this.calculations.get(calculationID);
            },

            getAnyField: function(fieldName, calculationID) {
                if (calculationID) {
                    var calc = this.getCalculation(calculationID);
                    if (calc)
                        return calc.getFieldByName(fieldName);
                }

                return this.getField(fieldName);
            },

            /**
             * Create a new calculation in the object and return a reference to it.
             *
             * @param attributes {Object} an object literal with the attributes to construct the new calculation
             * @param options {Object} - options to pass to the collection add method ("at" will be ignored)
             * @return {Model} - the newly created calculation model
             */

            createCalculation: function(attributes, options) {
                var calcs = this.calculations,
                    beforeLength = calcs.length;

                attributes = attributes || {};
                $.extend(attributes, {
                    owner: this.get('lineage'),
                    calculationID: Math.random().toString(36).slice(2)
                });

                // not supporting adding a calculation at a specific index, so delete the 'at' option
                options = options || {};
                delete options.at;

                calcs.add(attributes, options);
                // the new calculation is at the end of the collection,
                // so look it up based on the original length and return it
                var newCalc = calcs.at(beforeLength);

                // Prepopulate the outputFields for a GeoIP
                if (attributes.calculationType == "GeoIP")
                    newCalc.addGeoIPFields(options);

                return newCalc;
            },

            /**
             * Removes a calculation from the object
             *
             * @param calculationID - The calculationID attribute of the calculation to remove
             */

            removeCalculation: function(calculationID) {
                var toRemove = this.calculations.get(calculationID);
                this.calculations.remove(toRemove);
            },

            /**
             * Re-orders the objects calculations to match the given list of ids
             *
             * @param order {Array<String>} a list of calculation cid's
             */
            reOrderCalculations: function(order) {

                var ownCalculationIndices = [];

                // Populate ownCalculationIndices array with the indices of our own calculations
                // which might be sparsely located within the calculations array
                this.calculations.each(function(calculation, index) {
                    var calculationBasic = calculation.getBasicDescription();

                    if (this.isOwnCalculation(calculationBasic)) {
                        ownCalculationIndices.push(index);
                    }
                }, this);

                // We only want to reorder our own calculations. So non-own calculations stay at the
                // same index. Own calculations map from the new order array to the sparse indices.
                var newCollection = this.calculations.sortBy(function(calculation, index) {
                    var returnIndex = index;
                    var calculationBasic = calculation.getBasicDescription();

                    if (this.isOwnCalculation(calculationBasic))
                        returnIndex = ownCalculationIndices[_(order).indexOf(calculationBasic.calculationID+'')];

                    return returnIndex;
                }, this);

                this.calculations.reset(newCollection);

            },

            // apply the specified callback to each descendant of the specified parent object
            // TODO: this depends on the object being inside of an ObjectHierarchy, it should really be moved
            withEachDescendant: function(callback, context) {
                if(!this.children) {
                    return;
                }
                context = context || null;

                var recApplyFn = function(child) {
                    callback.call(context, child);
                    _(child.children).each(recApplyFn);
                };

                _(this.children).each(recApplyFn);
            },

            getSampleValuesModel: function(fieldName, owner, fetchOptions) {
                var safeFieldName = this.addLineagePrefix(fieldName, owner),
                    existingModel = this.fieldSampleValues.get(safeFieldName);

                if(existingModel) {
                    return existingModel;
                }
                this.fieldSampleValues.add({ fieldName: safeFieldName });
                var newModel = this.fieldSampleValues.get(safeFieldName);
                newModel.fetch(fetchOptions);

                return newModel;
            },

            addLineagePrefix: function(fieldName, owner) {
                var baseObjectNames = ['BaseEvent', 'BaseTransaction', 'BaseSearch', 'BaseInterface', 'BaseImplements'];
                if(!_(baseObjectNames).contains(owner)) {
                    return owner + '.' + fieldName;
                }
                return fieldName;
            },

            // ----- sync behavior ----- //

            initializeAssociated: function() {
                this.fieldSampleValues = this.fieldSampleValues || new FieldSampleValues();

                this.associated = this.associated || {};
                if (!this.fields) {
                    this.fields = this.associated.fields = new Fields();
                    this.fields.on({
                        "change": function(model, options) {this.triggerAssociatedChange("change", model, options);},
                        "associatedChange": function(model, options) {this.triggerAssociatedChange("associatedChange", model, options);},
                        "add":function(model, options) {this.triggerAssociatedChange("add", model, options);},
                        "remove":function(model, options) {this.triggerAssociatedChange("remove", model, options);},
                        "update":function(model, options) {this.triggerAssociatedChange("update", model, options);},
                        "reset":function(model, options) {this.triggerAssociatedChange("reset", model, options);}
                    }, this);
                }

                if (!this.calculations) {
                    this.calculations = this.associated.calculations = new Calculations();
                    this.calculations.on({
                        "change": function(model, options) {this.triggerAssociatedChange("change", model, options);},
                        "associatedChange": function(model, options) {this.triggerAssociatedChange("associatedChange", model, options);},
                        "add":function(model, options) {this.triggerAssociatedChange("add", model, options);},
                        "remove":function(model, options) {this.triggerAssociatedChange("remove", model, options);},
                        "update":function(model, options) {this.triggerAssociatedChange("update", model, options);},
                        "reset":function(model, options) {this.triggerAssociatedChange("reset", model, options);}
                    }, this);
                }
            },

            triggerAssociatedChange: function(eventName, model, options) {
                //console.log("Object [",this.cid,"] [",this.get("displayName"),"] event [",eventName, "] model [",model.id, "]");
                this.trigger("associatedChange", model, options);
            },

            clone: function(options) {
                var clone = BaseModel.prototype.clone.call(this);
                clone.fields.set(this.fields.toJSON(options));
                clone.calculations.set(this.calculations.toJSON(options));
                return clone;
            },

            parse: function(response, options) {
                response = $.extend(true, {}, response);
                // set the display name to the object name if none is specified
                if(!response.displayName) {
                    response.displayName = response.objectName;
                }
                return this.parseAssociated(response, options);
            },

            parseAssociated: function(response, options) {
                this.initializeAssociated();

                // Clear the fieldSampleValues cache and reapply the baseSearch string
                this.fieldSampleValues.reset();
                this.fieldSampleValues.setBaseSearch(response.objectSearch);
                this.fieldSampleValues.setTsidxNamespace(response.tsidxNamespace);

                if(response.fields) {
                    this.fields.set(response.fields, $.extend({ parse: true }, options));
                    delete response.fields;
                }
                if(response.calculations) {
                    this.calculations.set(response.calculations, $.extend({ parse: true }, options));
                    delete response.calculations;
                }
                return response;
            },

            toJSON: function(options) {
                var json = BaseModel.prototype.toJSON.apply(this, arguments);
                json.fields = this.fields.toJSON(options);
                json.calculations = this.calculations.toJSON(options);
                return json;
            },


            // ----- private methods ----- //


            /**
             * Returns a list of object literals representing a simple description of the object's fields.
             *
             * @return {Array<Object>}
             */

            getFieldList: function() {
                return this.fields.map(function(field) {
                    return field.getBasicDescription();
                });
            },

            /**
             * Returns a list of object literals representing a simple description of the object's calculations.
             *
             * @return {Array<Object>}
             */

            getCalculationList: function() {
                return this.calculations.map(function(calc) {
                    return calc.getBasicDescription();
                });
            },

            /**
             * Returns a list of constraint objects where any constraints with the same owner have been combined.
             *
             * Constraints are combined by joining their "search" attribute on a space character
             *
             * For example if the object's constraints have this structure:
             *
             * [
             *   {
             *     owner: "Object1",
             *     search: "field1=value1"
             *   },
             *   {
             *     owner: "Object2",
             *     search: "field2=value2"
             *   },
             *   {
             *     owner: "Object2",
             *     search: "field3=value3"
             *   }
             * ]
             *
             * The method will return this structure:
             *
             * [
             *   {
             *     owner: "Object1",
             *     search: "field1=value1"
             *   },
             *   {
             *     owner: "Object2",
             *     search: "field2=value2 field3=value3"
             *   }
             * ]
             *
             * @return {Array<Object>}
             */

            getCollapsedConstraints: function() {
                var constraints = this.get('constraints'),
                    groupedList = _(constraints).groupBy('owner'),
                    ownerList = _(constraints).chain().pluck('owner').uniq().value();

                return _(ownerList).map(function(owner) {
                    return {
                        owner: owner,
                        search: _(groupedList[owner]).pluck('search').join(' ')
                    };
                });
            },

            toString: function() {
                return "Object ["+this.cid+"] displayName [" + this.get("displayName") + "] " + this.calculations.toString();
            }

	    });
	}
);

/**
 * A collection representing the object hierarchy of a data model
 *
 * To be used only as an internal member of the "models/services/datamodel/DataModel" module
 */

define('collections/services/datamodel/private/ObjectHierarchy',[
            'underscore',
            'collections/Base',
            'models/services/datamodel/private/Object'
        ],
        function(
            _,
            Base,
            DMObject
        ) {

    return Base.extend({

        /**
         *  A list of reserved root object names representing the abstract base classes for data model objects.
         *  Their order in this list will also dictate the order of root objects in each hierarchy instance,
         *  e.g. all root objects that inherit from BaseEvent will come first.
         */

        ROOT_OBJECT_ORDER: ['BaseEvent', 'BaseTransaction', 'BaseSearch', 'BaseInterface', 'BaseImplements'],

        model: DMObject,

        initialize: function(models, options) {
            Base.prototype.initialize.call(this, models, options);

            // a private instance member containing the hierarchy's root objects
            // used as an entry point for walking the tree
            this._rootObjects = [];

            this.on('reset change:parentName add remove', this.buildHierarchy, this);
        },

        /**
         * Triggered on any reset, add, or remove event.  Re-builds the object hierarchy by reading each object's
         * "parentName" attribute and using it to make sure that parent object has the correct list of children.
         *
         * TODO: should this method throw or trigger an error if the models are not in a valid state?
         */

        buildHierarchy: function() {
            var childrenMap,
                that = this,
                hasNoParent = function(model) {
                    return _(that.ROOT_OBJECT_ORDER).indexOf(model.get('parentName')) > -1;
                };

            // build record of root objects and parent->children relationships
            this._rootObjects = this.filter(hasNoParent);
            childrenMap = this.chain().reject(hasNoParent).groupBy(function(model) {
                return model.get('parentName');
            }).value();

            // clear out any existing child lists
            this.each(function(object) {
                delete(object.children);
            });
            // assign each child list as a member of the model, assembling the tree
            // TODO [JCS] Do we need to do this now that the backend provides a children property?
            _(childrenMap).each(function(childList, parentName) {
                childrenMap[parentName] = _(childList).sortBy(function(child) { return child.get('objectName'); });
                var parentModel = this.find(function(model) { return model.get('objectName') === parentName; });
                parentModel.children = childList;
            }, this);

            // sort the root level objects based on the "root object order" property
            this._rootObjects = _(this._rootObjects).sortBy(function(obj) {
                return _(this.ROOT_OBJECT_ORDER).indexOf(obj.get('parentName'));
            }, this);

            // populate the the rootParent field for each object
            _(this._rootObjects).each(function(root) {
                var rootParentName = root.get('parentName');
                root.set({
                    rootParent: rootParentName
                }, {silent: true});
                root.withEachDescendant(function(child) {
                    child.set({
                        rootParent: rootParentName
                    }, {silent: true});
                }, this);
            }, this);
        },

        /**
         * @param fn - the function to call with each object as its argument, expected to return an object literal
         * @param context - (optional) the scope in which to call the function
         * @return {Array}
         *
         * A tree-structure-flattening version of map
         *
         * Returns a list generated by applying the given callback to each object and then recursively to its children,
         * and also appends a 'depth' field to each item in the returned list, indicating that object's depth in the tree.
         *
         * For example with the following hierarchy structure:
         *
         * Parent
         *   --> ChildOne
         *         --> GrandChildOne
         *         --> GrandChildTwo
         *   --> ChildTwo
         *         --> GrandChildThree
         * Sibling
         *   --> ChildThree
         *
         * Calling "depthFirstMap(function(obj) { return { name: obj.get('objectName') }; });" would return:
         *
         * [
         *   {
         *     name: "Parent",
         *     depth: 0
         *   },
         *   {
         *     name: "ChildOne",
         *     depth: 1
         *   },
         *   {
         *     name: "GrandChildOne",
         *     depth: 2
         *   },
         *   {
         *     name: "GrandChildTwo",
         *     depth: 2
         *   },
         *   {
         *     name: "ChildTwo",
         *     depth: 1
         *   },
         *   {
         *     name: "GrandChildThree",
         *     depth: 2
         *   },
         *   {
         *     name: "Sibling",
         *     depth: 0
         *   },
         *   {
         *     name: "ChildThree",
         *     depth: 1
         *   }
         * ]
         */

        depthFirstMap: function(fn, context) {
            context = context || null;
            var list = [],

                recApplyFn = function(obj, depth) {
                    var mappedObj = fn.call(context, obj);
                    mappedObj.depth = depth;
                    list.push(mappedObj);
                    depth++;
                    _(obj.children).each(function(obj) {
                        recApplyFn(obj, depth);
                    });
                };

            _(this._rootObjects).each(function(obj) {
                recApplyFn(obj, 0);
            });
            return list;
        },
        /**
         * Returns an array of the root objects, sorted by ROOT_OBJECT_ORDER
         *
         * @return {Array}
         */
        getRootObjects: function() {
            return this._rootObjects;
        },

        getAncestorsForObject: function(objectName) {
            var object = this.get(objectName);
            var ancestors = [];
            var parentName = "";

            while (object && !_.contains(this.ROOT_OBJECT_ORDER, parentName)) {
                parentName = object.get("parentName");
                object = this.get(parentName);
                if (object) {
                    ancestors.push(object);
                }
            }

            return ancestors;

        }

    });

});
/**
 * A model representing an individual data model.
 *
 * For a description of the backing endpoint, see: http://eswiki.splunk.com/Data_Model_JSON_Specification
 */

define('models/services/datamodel/DataModel',[
            'jquery',
            'underscore',
            'backbone',
            'models/Base',
            'models/SplunkDBase',
            'models/services/datamodel/private/Acceleration',
            'models/services/datamodel/private/DataModelWhiteList',
            'collections/services/datamodel/private/ObjectHierarchy',
            'util/console',
            'util/splunkd_utils'
        ],
        function(
            $,
            _,
            Backbone,
            BaseModel,
            SplunkDBase,
            Acceleration,
            DataModelWhiteList,
            ObjectHierarchy,
            console,
            splunkDUtils
        ) {

    var CONSTS = {
        BASE_EVENT : "BaseEvent",
        BASE_TRANSACTION : "BaseTransaction",
        BASE_SEARCH : "BaseSearch"
    };

    var DataModel = SplunkDBase.extend({

        initialize: function(attributes, options) {
            var dataModelWhiteList = new DataModelWhiteList();
            options = $.extend({ splunkDWhiteList: dataModelWhiteList }, options);
            return SplunkDBase.prototype.initialize.call(this, attributes, options);
        },

        /**
         *  Returns the data model's object hierarchy as a flattened list of object literals with basic attributes.
         *
         *  For a full description of the structure returned, see the depthFirstMap method in the
         *  "collections/services/datamodel/private/ObjectHierarchy" module
         *
         *  @return {Array}
         */

        getFlattenedHierarchy: function() {
            return (this.entry.content.objects.depthFirstMap(function(obj) {
                return obj.getBasicAttributes();
            }));
        },

        /**
         * Returns a processed version fo the result of getFlattenedHierarchy.
         * Add an "isPivotable" boolean attribute to each object.
         */

        getPivotableHierarchy: function() {
            return _(this.getFlattenedHierarchy()).map(function(obj) {
                obj.isPivotable = this.objectByName(obj.objectName).isPivotable();
                return obj;
            }, this);
        },

        /**
         * Returns the flattened object hierarchy (see getFlattenedHierarchy above) and divides it into sub-hieararchies,
         * one for each of the abstract base object types.
         *
         * The data structure returned is a dictionary of base object names mapping to sub-hierarchies.
         *
         * @return {Object}
         */

        getGroupedFlattenedHierarchy: function() {
            var groupedObjects = _(this.getFlattenedHierarchy()).groupBy(function(obj) {
                return obj.rootParent;
            });

            var returnObject = {};
            returnObject[CONSTS.BASE_EVENT] = groupedObjects[CONSTS.BASE_EVENT] || [];
            returnObject[CONSTS.BASE_TRANSACTION] = groupedObjects[CONSTS.BASE_TRANSACTION] || [];
            returnObject[CONSTS.BASE_SEARCH] = groupedObjects[CONSTS.BASE_SEARCH] || [];

            return returnObject;
        },

        getObjectCount: function() {
            return this.entry.content.objects.length;
        },

        // since the model can be fetched in "concise" mode without the collection of objects,
        // this method provides a way to get the count of objects from the "objectSummary"
        // NOTE: dynamically added/removed objects will not be reflected in this count
        getSummarizedObjectCount: function() {
            // the groups are mutually exclusive, so we can just add up all of the counts
            return _(this.entry.content.objectSummary.toJSON()).reduce(function(runningTotal, groupCount) {
                return runningTotal + groupCount;
            }, 0);
        },

        isEmpty: function() {
            return this.getSummarizedObjectCount() === 0;
        },

        /**
         * Returns true if the data model is privately shared
         * @return {Boolean}
         */
        isPrivate: function() {
            return this.entry.acl.get("sharing") == splunkDUtils.USER;
        },
        /**
         * Returns true if the data model was generated from an sid and has not been saved to the back end.
         * @returns {boolean}
         */
        isTemporary: function() {
            return this.has('sid');
        },
        /**
         * Returns true if the model can be accelerated. Private models can not be accelerated.
         * @return {Boolean}
         */
        canAccelerate: function() {
            var hasEventObject = this.entry.content.objectSummary.get("Event-Based") > 0;
            return hasEventObject && !this.isPrivate();
        },

        /**
         * Returns true if the user can change the model's permissions
         * @return {Boolean}
         */
        canChangePermissions: function() {
            return this.entry.acl.get('can_change_perms');
        },

        /**
         * Returns true if the model can be deleted.
         *
         * @return {Boolean}
         */
        canDelete: function() {
            return this.entry.links.get("remove") ? true : false;
        },

        /**
         * Returns true if the model can be edited.
         * @return {Boolean}
         */
        canWrite: function() {
            return this.entry.acl.get('can_write') ? true : false;
        },

        isAccelerated: function() {
            return this.entry.content.acceleration ? (this.entry.content.acceleration.get("enabled") ? true : false) : false;
        },

        getAncestorsForObject: function(objectName) {
            return this.entry.content.objects.getAncestorsForObject(objectName);
        },

        /**
         * @param objName {String} - the objectName of an object to look up in the hierarchy
         * @return {Model} - a reference to the object, or undefined if it's not there
         */

        objectByName: function(objName) {
            return this.entry.content.objects.get(objName);
        },

        objectByLineage: function(lineage) {
            var objects = lineage.split(".");

            if (objects.length > 0) {
                return this.objectByName(objects[objects.length-1]);
            }

            return undefined;
        },

        /**
         * Adds a new object with the given attributes to the data model and returns a reference to it.
         *
         * @param attributes {Object} - an object literal with the attributes to construct the new object model
         * @param options {Object} - options to pass to the collection add method ("at" will be ignored)
         * @return {Model} - the newly created object model
         */

        addObject: function(attributes, options) {
            // TODO: maybe throw an error if objectName or parentName are not defined
            // TODO [JCS] Allow adding to a transaction, event or search
            if(!attributes.parentName) {
                console.warn('DataModel: addObject called with no parent name specified, using BaseEvent as a default');
                attributes.parentName = CONSTS.BASE_EVENT;
            }
            var objects = this.entry.content.objects,
                beforeLength = objects.length;

            // not supporting adding objects at a particular index, so delete the 'at' option
            options = options || {};
            delete options.at;
            objects.add(attributes, options);
            // the new object is at the end of the collection, so look it up based on the original length and return it
            return objects.at(beforeLength);
        },

        /**
         * Removes an object and its children from the data model.
         *
         * A no-op if the model is currently in the data model.
         *
         * @param object {Model} - the object model instance to be removed
         */

        removeObjectAndChildren: function(object) {
            object.withEachDescendant(function(child) {
                this.entry.content.objects.remove(child, { silent: true });
            }, this);
            this.entry.content.objects.remove(object);
        },

        // ------ sync behavior ---- //

        url: 'datamodel/model',
        generateFromSidUrl: 'datamodel/generate',

        sync: function(method, model, options) {
            // If an sid is included in the params for a fetch, populate the data model using the generate-from-sid endpoint.
            if(method === 'read' && options && options.data && options.data.sid) {
                options = $.extend(true, { output_mode: 'json' }, options);
                options = splunkDUtils.prepareSyncOptions(options, model.generateFromSidUrl);
                var optionsData = options.data;
                // The fields and field_coverage options are mutually exclusive, let fields trump field_coverage.
                if(optionsData.fields) {
                    delete optionsData.field_coverage;
                }
                return Backbone.Model.prototype.sync.call(this, method, model, options);
            }
            return SplunkDBase.prototype.sync.apply(this, arguments);
        },

        initializeAssociated: function() {
            SplunkDBase.prototype.initializeAssociated.call(this);
            var content = this.entry.content;

            if (!content.objects) {
                content.objects = content.associated.objects = new ObjectHierarchy();
                content.objects.on("change associatedChange add remove update reset",
                                function(model, options) {this.trigger("associatedChange", model, options);}, this);
            }

            content.objectSummary = content.associated.objectSummary = content.objectSummary || new BaseModel();
            content.acceleration = content.associated.acceleration = content.acceleration || new Acceleration();
        },

        clone: function() {
            // TODO [sff] this is horrible...
            // have to set a temporary flag or if the model is accelerated it will not clone itself correctly
            this.entry.content.isCloning = true;
            var clone = new this.constructor();
            clone.setFromSplunkD(this.toSplunkD());
            // TODO [sff] do we have to call this?
            clone.entry.content.objects.buildHierarchy();
            this.entry.content.isCloning = false;
            return clone;
        },

        parse: function(response, options) {
            response = $.extend(true, {}, response);
            this.initializeAssociated();
            response = this.parseSplunkDPayload(response);
            // If the data model was generated from an sid, add that sid to the root attributes.
            if(options && options.data && options.data.sid) {
                response.sid = options.data.sid;
            }
            return SplunkDBase.prototype.parse.call(this, response);
        },
        parseFile: function(response) {
            response = $.extend(true, {}, response);
            this.initializeAssociated();
            response = this.parseSplunkDPayload(response);
            var response_entry = response.entry[0];
            this.entry.content.set(response_entry.content);
            delete response_entry.content;
            delete response.entry;
            return response;    
        },
        setFromSplunkD: function(payload, options) {
            payload = $.extend(true, {}, payload);
            //console.log("DataModel.setFromSplunkD before parse",this.toString());
            payload = this.parseSplunkDPayload(payload, options);
            //console.log("DataModel.setFromSplunkD after parse",this.toString());
            return SplunkDBase.prototype.setFromSplunkD.call(this, payload, options);
        },

        parseSplunkDPayload: function(payload, options) {
            var entry = payload.entry;
            var acceleration;

            if(entry && entry.length > 0 && entry[0].content) {
                //console.log("DM.parseSplunkDPayload",this.cid,"objects[0].calculations");

                // Save the acceleration info and apply later since content gets clobbered
                if (entry[0].content.acceleration)
                    acceleration = JSON.parse(entry[0].content.acceleration); // String representation of the acceleration JSON
                // what we want to treat as content from now on is actually stringified into the "description" attribute
                var content;

                if (_(entry[0].content).has("description")) {
                    content = entry[0].content = JSON.parse(entry[0].content.description);
                } else {
                    content = entry[0].content;
                }

                // set the display name equal to the model name if no display name is given
                if(!content.displayName) {
                    content.displayName = content.modelName;
                }

                if(_(content.objects).isArray()) {
                    this.entry.content.objects.set(content.objects, $.extend({ parse: true }, options));
                    delete content.objects;
                }
                if (_(content.objectSummary).isObject()) {
                    this.entry.content.objectSummary.set(content.objectSummary, $.extend({ parse: true }, options));
                    delete content.objectSummary;
                }
                if (_(acceleration).isObject()) {
                    this.entry.content.acceleration.set(acceleration, $.extend({ parse: true }, options));
                }
            }
            return payload;
        },

        toString: function() {
            var children = "";
            this.entry.content.objects.each(function(object) {
                if (children != "")
                    children += ", ";
                children += object.toString();
            }, this);

            return "DataModel [" + this.cid + "] objects cid [" + this.entry.content.objects.cid + "] Objects: " + children;
        }

    }, CONSTS);

    // break the shared reference to Entry
    DataModel.Entry = SplunkDBase.Entry.extend({});
    // now we can safely extend Entry.Content
    DataModel.Entry.Content = SplunkDBase.Entry.Content.extend({

        toJSON: function(options) {
            var json = SplunkDBase.Entry.Content.prototype.toJSON.apply(this, arguments);
            var returnValue = {};

            if(this.objects.length > 0) {
                json.objects = this.objects.toJSON(options);
            }

            if (this.objectSummary) {
                json.objectSummary = this.objectSummary.toJSON(options);
            }

            if (this.acceleration) {
                returnValue.acceleration = JSON.stringify(this.acceleration.toJSON(options));
            }

            //console.log("=========== DataModelV2.toJSON =============");
            //console.log(JSON.stringify(json));
            if (json.name) {
                json.modelName = json.name;
                returnValue.name = json.name;
                delete json.name;
            }

            var accelerationEnabled = this.acceleration ? this.acceleration.get("enabled") : false;
            if (this.isCloning || _.isUndefined(accelerationEnabled) || !accelerationEnabled || this.isCreating)
                returnValue.description = JSON.stringify(json);

            return returnValue;
        }

    });

    return DataModel;

});

/**
 * A collection of data models
 */

define('collections/services/datamodel/DataModels',[
            'jquery',
            'underscore',
            'collections/SplunkDsBase',
            'models/services/datamodel/DataModel'
        ],
        function(
            $,
            _,
            SplunkDsBase,
            DataModel
        ) {

    return SplunkDsBase.extend({

        model: DataModel,
        url: 'datamodel/model'

    });

});
define('views/shared/splunkbar/find/Master',[
    'jquery',
    'underscore',
    'module',
    'models/Base',
    'views/shared/splunkbar/find/results/Master',
    'views/shared/splunkbar/find/FindProgress',
    'views/shared/tablecaption/Input',
    'collections/shared/Dashboards',
    'collections/search/Reports',
    'collections/services/datamodel/DataModels',
    'views/Base',
    'util/splunkd_utils'
],
function(
    $,
    _,
    module,
    BaseModel,
    FindBarResults,
    FindProgress,
    InputView,
    DashboardsCollection,
    ReportsCollection,
    DataModelsCollection,
    BaseView,
    splunkdUtils
) {
    return BaseView.extend({
        moduleId: module.id,
        tagName: 'li',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            //models
            this.stateModel = new BaseModel();
            this.rawSearch = new BaseModel();
            //collections
            this.collection.dashboards = new DashboardsCollection();
            this.collection.reports = new ReportsCollection();
            this.collection.alerts = new ReportsCollection();
            this.collection.datamodels = new DataModelsCollection();
            //deferreds
            this.deferreds = {};
            this.deferreds.dashboardDeferred = $.Deferred();
            this.deferreds.reportDeferred = $.Deferred();
            this.deferreds.alertDeferred = $.Deferred();
            this.deferreds.datamodelDeferred = $.Deferred();
            
            this.children.findProgress = new FindProgress({
                model: {
                    application: this.model.application,
                    state: this.stateModel
                },
                mode: 'menu',
                onHiddenRemove: true
            });

            this.stateModel.on('change:search',  
                _.debounce(function() {
                    var rawSearch = this.rawSearch.get('rawSearch');
                    if (!rawSearch || rawSearch === '') {
                        if(this.children.findbarResults) {
                            this.children.findbarResults.hide();   
                        }
                        this.collection.dashboards = new DashboardsCollection();
                        this.collection.reports = new ReportsCollection();
                        this.collection.alerts = new ReportsCollection();
                        this.collection.datamodels = new DataModelsCollection();
                       return;
                    }
                    var $target =  $('.findbar-container'),
                        $focus = $('.findbar-container .search-query');
                    
                    // Show find progress while waiting for results to return.
                    if(this.children.findbarResults) {
                        this.children.findbarResults.hide();   
                    }
                    $($target).append(this.children.findProgress.render().el);
                    this.children.findProgress.show($target, {$onOpenFocus: $focus});

                    this.deferreds.dashboardDeferred = $.Deferred();
                    this.deferreds.reportDeferred = $.Deferred();
                    this.deferreds.alertDeferred = $.Deferred();
                    this.deferreds.datamodelDeferred = $.Deferred();
                    this.fetchDashboardCollection();
                    this.fetchReportCollection();
                    this.fetchAlertCollection();
                    this.fetchDataModelCollection();
                    
                    this.collection.dashboards.on('sync', function() {
                            this.deferreds.dashboardDeferred.resolve();
                    }.bind(this));
                    
                    this.collection.reports.on('sync', function() {
                        this.deferreds.reportDeferred.resolve();
                    }.bind(this));
            
                    this.collection.alerts.on('sync', function() {
                        this.deferreds.alertDeferred.resolve();
                    }.bind(this));
            
                    this.collection.datamodels.on('sync', function() {
                        this.deferreds.datamodelDeferred.resolve();
                    }.bind(this));
                    
                    $.when(
                        this.deferreds.dashboardDeferred,
                        this.deferreds.reportDeferred,
                        this.deferreds.alertDeferred,
                        this.deferreds.datamodelDeferred
                    ).then(function() {
                        this.showFindBarResults($target);
                    }.bind(this));
                }.bind(this), 250),
                this
            );
        },
        events: {
            'click .findbar-container': function(e){
                var rawSearch = this.rawSearch.get('rawSearch');
                if (rawSearch && rawSearch !== '') {
                    var $target = $(e.currentTarget);
                    this.showFindBarResults($target);
                }
            }
        },
        showFindBarResults: function($target) {
            var $focus = $('.findbar-container .search-query');
            this.children.findProgress.hide();
            if (this.children.findbarResults && this.children.findbarResults.shown) {
                this.children.findbarResults.render();
                return;
            }
            this.children.findbarResults = new FindBarResults({
                collection: {
                    dashboards: this.collection.dashboards,
                    reports: this.collection.reports,
                    alerts: this.collection.alerts,
                    datamodels: this.collection.datamodels,
                    apps: this.collection.apps
                },
                model: {
                    application: this.model.application,
                    state: this.stateModel,
                    rawSearch: this.rawSearch
                },
                mode: 'menu',
                onHiddenRemove: true
            });
            $($target).append(this.children.findbarResults.render().el);
            this.children.findbarResults.show($target, {$onOpenFocus: $focus});
        },
        fetchDashboardCollection: function() { 
            var dashboards = this.collection.dashboards,
                search = '';
            if (this.rawSearch.get('rawSearch')) {
                search = splunkdUtils.createSearchFilterString(this.rawSearch.get('rawSearch'), ['label','eai:data']);
                
            }
            if (search) {
                search += ' AND ';
            }
            search += DashboardsCollection.availableWithUserWildCardSearchString(this.model.application.get('owner')); 

            dashboards.safeFetch({ 
                data : { 
                    app: '-', 
                    owner: '-', 
                    search: search, 
                    count: 3,
                    offset: 0
                }, 
                success: function(response) {
                }.bind(this) 
            }); 
        },
        fetchReportCollection: function() {
            var reports = this.collection.reports,
                search = this.stateModel.get('search') || '';
            if (search) {
                search += ' AND ';
            }
            search += ReportsCollection.availableWithUserWildCardSearchString(this.model.application.get('owner')) + ' AND is_visible=1 AND NOT ' + ReportsCollection.ALERT_SEARCH_STRING;

            reports.safeFetch({
                data : {
                    app: '-',
                    owner: '-',
                    search: search,
                    count: 3
                },
                success: function() {
                }.bind(this)
            });
        },
        fetchAlertCollection: function() {
            if (!this.model.serverInfo.entry.content.get("isFree")) {
                var alerts = this.collection.alerts,
                    search = this.stateModel.get('search') || '';
                if (search) {
                    search += ' AND ';
                }
                search += ReportsCollection.availableWithUserWildCardSearchString(this.model.application.get('owner')) + ' AND is_visible=1 AND ' + ReportsCollection.ALERT_SEARCH_STRING;

                alerts.safeFetch({
                    data:{
                        app: '-',
                        owner: '-',
                        search: search,
                        count: 3
                    },
                    success: function() {
                    }.bind(this)
                });
            } else {
                this.deferreds.alertDeferred.resolve();
            }
        },
        fetchDataModelCollection: function() { 
            if (!this.model.serverInfo.isLite()) {
                var datamodels = this.collection.datamodels, 
                    search = this.rawSearch.get('rawSearch') || ''; 
                if (search) {
                    search += ' AND ';
                }
                search += '(eai:acl.owner="*")';

                datamodels.safeFetch({
                    data : {
                        app: '-',
                        owner: '-',
                        sort_mode: ['auto', 'auto'],
                        search: search,
                        count: 3,
                        offset: 0,
                        concise: true
                    }, 
                    success: function(response) {
                    }.bind(this) 
                }); 
            } else {
                this.deferreds.datamodelDeferred.resolve();
            }
        },
        render: function() {
            var html = this.compiledTemplate();
            this.$el.append(html);
            this.children.findbar = new InputView({
                model: {
                    state: this.stateModel,
                    rawSearch: this.rawSearch
                },
                findBar: true
            });
            this.$('.findbar-container').append(this.children.findbar.render().el);
        },
        template: '\
        <div class="findbar-container"></div>\
        '
    });
});

define('contrib/text!views/shared/splunkbar/messages/NoConnectionOverlay.html',[],function () { return '<div class="modal-backdrop fade in"></div>\n<div class="modal disconnection-warning-modal">\n\t<h3><%= _("Reconnecting to Splunk server").t() %></h3>\n\t<p><%= _("Your network connection may have been lost or Splunk server may be down.").t() %></p>\n</div>\n';});

define('views/shared/splunkbar/messages/NoConnectionOverlay',[
    'underscore',
    'module',
    'views/Base',
    'views/shared/WaitSpinner',
    'contrib/text!views/shared/splunkbar/messages/NoConnectionOverlay.html',
    'splunk.util'
],
    function(
        _,
        module,
        BaseView,
        WaitSpinnerView,
        Template,
        splunkUtil
        ){
        
        var image = new Image();
        image.src = splunkUtil.make_url("/static/img/skins/default/loading_medium_green.png");
        var image2x = new Image();
        image2x.src = splunkUtil.make_url("/static/img/skins/default/loading_medium_green_2x.png");
        
        
        return BaseView.extend({
            moduleId: module.id,
            template: Template,
            className: 'splunk-components',
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
                
                var spinnerOptions = {
                    color: 'green',
                    size: 'medium',
                    frameWidth: 19
                };
                
                this.children.spinner = new WaitSpinnerView(spinnerOptions);
                this.visible = false;
                this.$el.hide();
            },
            show: function() {
                if (this.visible) {
                    return;
                }
                
                this.visible = true;
                this.$el.show();
                this.children.spinner.start();
            },
            hide: function() {
                if (!this.visible) {
                    return;
                }
                
                this.visible = false;
                this.$el.hide();
                this.children.spinner.stop();
            },
            render: function() {
                this.$el.html(this.compiledTemplate);
                this.$(".modal").append(this.children.spinner.render().el);
                return this;
            }
        });
    });

define('contrib/text!views/shared/splunkbar/Master.html',[],function () { return '\n<div class="navbar-inner">\n    <div class="no_connection-overlay"></div>\n    <a href="<%-homeLink%>" class="brand" title="splunk &gt; <%- _(\'listen to your data\').t() %>">splunk<strong>&gt;</strong></a>\n    <ul class="navbar-global-nav nav">\n        <li class="dropdown apps">\n            <a href="#" class="dropdown-toggle"><%- _("Apps").t() %><b class="caret"></b></a>\n        </li>\n    </ul>\n\n    <ul class="navbar-global-nav nav pull-right">\n        <li class="dropdown user"></li>\n        <li class="dropdown messages"><a href="#" class="dropdown-toggle"><%- _("Messages").t() %><b class="caret"></b></a></li>\n        <li class="dropdown system<%- options.section==\'system\' ? \' active \' : \'\'%>">\n            <a href="#" class="dropdown-toggle"><%- _("System").t() %><b class="caret"></b></a>\n        </li>\n        <li class="dropdown activity"><a href="#"><%- _("Activity").t() %></a></li>\n        <li class="dropdown help"><a href="#" class="dropdown-toggle"><%- _("Help").t() %><b class="caret"></b></a></li>\n        <li class="dropdown findbar"></li>\n    </ul><!-- /.user-nav -->\n</div><!-- /.navbar-inner -->\n';});

define('util/csrf_protection',
    [
        'jquery',
        'splunk.util'
    ],
    function($, splunkUtils) {
        var HEADER_NAME = 'X-Splunk-Form-Key';
        var FORM_KEY = splunkUtils.getFormKey();

        // If the form key is not present, return without 
        // setting up the prefilter. Return instead of throwing
        // because there are some scenarios (Independent Mode)
        // where this is the expected behavior.
        if (!FORM_KEY) {
            return;
        }

        if ($) {
            $.ajaxPrefilter(function(options, originalOptions, jqXHR) {
                if (options['type'] && options['type'].toUpperCase() == 'GET') return;
                jqXHR.setRequestHeader(HEADER_NAME, FORM_KEY);
            });

            $(document).ready(function() {
                $(document).bind('ajaxError', function(event, xhr, opts, err) {
                    // because we'll get a 401 when logout is clicked, prevent 
                    // /en-US/account/login?return_to=/en-US/account/logout from happening
                    var pathname = window.location.pathname;
                    if (xhr.status === 401 && pathname.indexOf('/account/logout') === -1) {
                        document.location = splunkUtils.make_url('account/login?return_to=' + encodeURIComponent(pathname + document.location.search));
                        return;
                    }
                });
            });
        } else {
            throw "Splunk's jQuery.ajax extension requires jQuery.";   
        }
    }
);

/* Insert a jQuery ajax prefilter that sets options.cache=false for all GET requests
 * This is a preventative measure to avoid an intermittent bug in Chrome 28 (see SPL-71743)
 */ 

define('util/ajax_no_cache',
    [
        'jquery'
    ],
    function($) {
        if ($) {
            $.ajaxPrefilter(function(options, originalOptions, jqXHR) {
                if (options.type && options.type.toUpperCase() == 'GET' && options.cache === undefined) {
                    options.cache = false;
                }
            });

        } else {
            throw "ajax_no_cache requires jQuery.";   
        }
    }
);

// splunk bar
define('views/shared/splunkbar/Master',[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'splunk.util',
    'helpers/Session',
    'views/Base',
    'views/shared/delegates/Popdown',
    'views/shared/splunkbar/AppMenu',
    'views/shared/splunkbar/SystemMenu',
    'views/shared/splunkbar/UserMenu',
    'views/shared/splunkbar/messages/Master',
    'views/shared/splunkbar/ActivityMenu',
    'views/shared/splunkbar/HelpMenu',
    'views/shared/splunkbar/find/Master',
    'views/shared/splunkbar/messages/NoConnectionOverlay',
    'models/services/data/UserPref',
    'models/services/AppLocal',
    'models/shared/User',
    'models/services/server/ServerInfo',
    'models/services/configs/Web',
    'models/shared/Application',
    'collections/services/authentication/CurrentContexts',
    'collections/services/AppLocals',
    'collections/services/Messages',
    'collections/services/data/ui/Managers',
    'collections/shared/splunkbar/SystemMenuSections',
    'contrib/text!views/shared/splunkbar/Master.html',
    'uri/route',
    'splunk.util',
    'util/splunkd_utils',
    'util/csrf_protection',
    'util/ajax_no_cache'
],
function(
    $,
     _,
     Backbone,
     module,
     splunk_util,
     Session,
     BaseView,
     Popdown,
     AppMenuView,
     SystemMenu,
     UserMenu,
     MessagesView,
     ActivityMenu,
     HelpMenu,
     FindBar,
     NoConnectionOverlay,
     UserPrefModel,
     AppLocalModel,
     UserModel,
     ServerInfoModel,
     WebConfModel,
     ApplicationModel,
     CurrentContextsCollection,
     AppsCollection,
     MessagesCollection,
     ManagersCollection,
     SystemMenuSectionsCollection,
     globalTemplate,
     route,
     splunkUtil,
     splunkDUtils
){
    var View = BaseView.extend({
        moduleId: module.id,
        template: globalTemplate,
        className: 'navbar',
        defaults: {
            showAppsList: true
        }, 
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.options = _.extend({},this.defaults, this.options);
            this.MAX_RETRIES_BEFORE_FAIL = 3;
            this.MESSAGES_POLLING_DELAY_STANDARD = 60000;
            this.MESSAGES_POLLING_DELAY_HI_FREQ = 1000;
            this.isFreeDfd = $.Deferred();
            this.userDfd = $.Deferred();
            this.appsDfd =  $.Deferred();
            this.cntRetries = 0;
            if (this.model && this.model.user && this.model.user.entry.content.has('realname')){
                this.userDfd.resolve();
            } else {
                this.model.user.on('sync', function() {
                    this.userDfd.resolve();
                }, this);
            }
            if (this.collection && this.collection.apps && this.collection.apps.length){
                this.appsDfd.resolve();
            } else {
                this.collection.apps.on('sync', function() {
                    this.appsDfd.resolve();
                }, this);
            }
            if (this.model && this.model.serverInfo && this.model.serverInfo.entry.content.has('isFree')){
                if (splunkUtil.normalizeBoolean(this.model.serverInfo.entry.content.get('isFree'))) {
                    this.isFreeDfd.resolve();
                } else {
                    this.isFreeDfd.reject();
                }
            }else if(this.model && this.model.serverInfo) {
                this.model.serverInfo.on('change reset', function() {
                    if (splunkUtil.normalizeBoolean(this.model.serverInfo.entry.content.get('isFree'))) {
                        this.isFreeDfd.resolve();
                    } else {
                        this.isFreeDfd.reject();
                    }
                }.bind(this));
            }
            this.collection.sections.on('reset', this.sectionsMunger, this);
            Session.on('restart timeout', function() {
                this.collection.messages.stopPolling();
            }, this);
            Session.on('start', function() {
                this.collection.messages.startPolling();
            }, this);
        },
        remove: function() {
            BaseView.prototype.remove.apply(this, arguments);
            Session.off('restart timeout start', null, this);
            return this;
        },
        render: function() {
            var homeLink = route.home(
                this.model.application.get('root'),
                this.model.application.get('locale'));
            
            var html = this.compiledTemplate({
                makeUrl: splunk_util.make_url,
                options: this.options,
                homeLink: homeLink
            });
            this.$el.html(html);

            var activeMenu = this.getActiveMenu();
            
            $.when(this.userDfd, this.appsDfd).then(function() {
                if (this.model.user.canUseApps() && this.options.showAppsList){
                    this.children.apps = new AppMenuView({
                        collection: this.collection,
                        model: this.model,
                        activeMenu: activeMenu
                    });
                    this.$('.apps.dropdown').replaceWith(this.children.apps.el);
                } else {
                    this.$el.find('.apps').remove();
                }
                this.children.systemMenu = new SystemMenu({
                    collection: {
                        sections: this.collection.sections,
                        managers: this.collection.managers,
                        apps: this.collection.apps
                    },
                    model: {
                        application: this.model.application,
                        user: this.model.user
                    }
                });
                this.$('.system.dropdown').replaceWith(this.children.systemMenu.el);
            
                this.children.findbar = new FindBar({
                    model: {
                        user: this.model.user, 
                        application: this.model.application,
                        serverInfo: this.model.serverInfo
                    },
                    collection: {
                        apps: this.collection.apps
                    }
                });
                //TODO [uks]: Do we need to call render()
                this.$('.findbar').replaceWith(this.children.findbar.render().el);

                this.isFreeDfd.fail(function() {
                    this.children.userMenu = new UserMenu({
                        collection: {
                            currentContext: this.model.currentContext //this represents the current logged in user
                        },
                        model: {
                            user: this.model.user,
                            application: this.model.application,
                            webConf: this.model.webConf,
                            config: this.model.config
                        }
                    });
                    this.$('.user.dropdown').replaceWith(this.children.userMenu.el);
                }.bind(this));
            
            }.bind(this));
            
            this.children.messages = new MessagesView({
                collection: {
                    messages: this.collection.messages,
                    legacyMessages: this.collection.legacyMessages
                },

                model: {
                    serverInfo: this.model.serverInfo
                }
            });

            this.children.noConnectionOverlay = new NoConnectionOverlay();
            $('body').append(this.children.noConnectionOverlay.render().el);

            this.collection.messages.on('serverValidated', function(success, context, messages) {
                if (success && this.cntRetries > 0) {
                    this.restartMessagePolling(this.MESSAGES_POLLING_DELAY_STANDARD);
                    this.children.noConnectionOverlay.hide();
                    this.cntRetries = 0;
                    return;
                }
                var netErrorMsg = _.find(messages, function(msg) {
                    return msg.type == splunkDUtils.NETWORK_ERROR || 'network_error';
                });
                if (netErrorMsg) {
                    if (this.cntRetries == 0) {
                        this.restartMessagePolling(this.MESSAGES_POLLING_DELAY_HI_FREQ);
                    }
                    if (this.cntRetries >= this.MAX_RETRIES_BEFORE_FAIL) {
                        this.children.noConnectionOverlay.show();
                    }
                    this.cntRetries += 1;
                }
            }, this);
            this.$('.messages.dropdown').replaceWith(this.children.messages.render().el);
            this.restartMessagePolling(this.MESSAGES_POLLING_DELAY_STANDARD);
            
            $.when(this.userDfd, this.appsDfd).then(function() {
                this.children.activityMenu = new ActivityMenu({
                    model: {
                        user: this.model.user,
                        application: this.model.application
                    }
                });
                this.$('.activity').replaceWith(this.children.activityMenu.el);
    
                this.children.helpMenu = new HelpMenu({
                    model: this.model, 
                    collection: {
                        apps: this.collection.apps
                    }
                });
                this.$('.help').replaceWith(this.children.helpMenu.el);
    
                // highlight the active menu
                if (activeMenu){
                    this.$(activeMenu.selector).addClass("active");
                }
            }.bind(this));
            return this;
        },
        restartMessagePolling: function(interval) {
            this.collection.messages.stopPolling();
            this.collection.messages.startPolling({delay: interval, uiInactivity: true, stopOnError: false, data: {count: 1000}});
        },
        getActiveMenu: function() {
            // the active menu is based on the current page
            // get path
            var path = Backbone.history.location.pathname;
            var pathComponents = path.split("/"),
                pathComponentsLen = pathComponents.length;
            var appAndPageComponents = [pathComponents[pathComponentsLen-2], pathComponents[pathComponentsLen-1]];
            var appAndPage = appAndPageComponents.join("/");
            var locale = this.model.application.get('locale');
            var app = this.model.application.get('app');

            var activityPages = ["search/status_index",
                                 "search/search_status", "search/search_detail_activity", "search/search_activity_by_user",
                                 "search/splunkweb_status", "search/internal_messages",
                                 "search/scheduler_status", "search/scheduler_user_app", "search/scheduler_savedsearch", "search/scheduler_status_errors", "search/pdf_activity"];
            var changePasswordPage = "authentication/changepassword";
            var jobManagerPage = app + '/job_management';
            var triggeredAlertsPage = locale + '/alerts';
            var homePage = "launcher/home";
            var managerPage = locale + "/manager";

            var activeMenuSelector = null;
            var activeMenuName = '';
            if (activityPages.indexOf(appAndPage) > -1 ||
                path.indexOf(jobManagerPage) > -1 ||
                path.indexOf(triggeredAlertsPage) > -1) {
                activeMenuSelector = '.activity';
                activeMenuName = "activity";
            } else if (path.indexOf(changePasswordPage) > -1) {
                activeMenuSelector = '.user';
                activeMenuName = "user";
            } else if (path.indexOf(managerPage) > -1) {
                activeMenuSelector = 'menu-system';
                activeMenuName = "manager";
            } else if (path.indexOf(homePage) > -1) {
                activeMenuSelector = '.brand';
                activeMenuName = "home";
            } else {
                activeMenuSelector = '.menu-apps';
                activeMenuName = "app";
            }

            return {
                selector: activeMenuSelector,
                name: activeMenuName
            };
        },
        sectionsMunger: function() {
            this.collection.sections.add({
                id: 'knowledge_configurations',
                label: _('Knowledge').t(),
                icon: 'bookmark',
                order: 1
            });
            this.collection.sections.add({
                id: 'auth_configurations',
                label: _('Users and authentication').t(),
                icon: 'user',
                order: 6
            });
            this.collection.sections.add({
                id: 'deployment_configurations',
                label: _('Distributed environment').t(),
                icon: 'distributed-environment',
                order: 5
            });
            this.collection.sections.add({
                id: 'system_configurations',
                label: _('System').t(),
                icon: 'settings',
                order: 2
            });
            this.collection.sections.add({
                id: 'data_configurations',
                label: _('Data').t(),
                icon: 'data',
                order: 4
            });
            
            this.collection.managers.each(function(manager){
                var menuUrl = manager.entry.content.get('menu.url') || '',
                    sectionName = manager.entry.content.get('menu.name'),
                    disabledByLicense = splunkUtil.normalizeBoolean(manager.entry.content.get('disabled_by_license') || false),
                    order = manager.entry.content.get('menu.order') || 1000,
                    pageStart = route.encodeRoot(this.model.application.get('root'), this.model.application.get('locale')),
                    url = pageStart + splunk_util.sprintf(menuUrl, {namespace: this.model.application.get('app') || 'NOTHING'});

                if(!disabledByLicense && sectionName){
                    var section = this.collection.sections.get(sectionName);
                    if(section){
                        var sectionItems = section.get('items');
                        if(sectionItems){
                            sectionItems.push(manager);
                        }
                    }
                }

                manager.set({
                    url: url,
                    order: order
                });
            }.bind(this));
 
            this.collection.sections.trigger('ready');
        }
    },
    {
        create: function(options){
            options = options || {};
            options.collection = options.collection || {};
            options.model = options.model || {};

            //the APPLICATION model is REQUIRED argument from the consumer. If its not passed, make up an empty one, to keep things rendering, and assure continuance
            //TODO should log this
            var applicationDfd = $.Deferred();
            if(!options.model.application){
                options.model.application = new ApplicationModel();
            }
            // handle both when the application model is already filled and when it has yet to complete fetching
            if (options.model.application.get('app')) {
                applicationDfd.resolve();
            } else {
                options.model.application.on('change', applicationDfd.resolve);
            }

            if(!options.model.appLocal) {
                options.model.appLocal = new AppLocalModel();
                applicationDfd.done(function() {
                    if (options.model.application.get("app") !== 'system') {
                        options.model.appLocal.fetch({
                            url: splunkDUtils.fullpath(options.model.appLocal.url + "/" + encodeURIComponent(options.model.application.get("app"))),
                            data: {
                                app: options.model.application.get("app"),
                                owner: options.model.application.get("owner")
                            }
                        });
                    }
                });
            }

            var currentUserIdDfd = $.Deferred();
            currentUserIdDfd.resolve(options.model.application.get('owner'));

            var appsDfd = $.Deferred();

            var appsCollection;
            if(!options.collection.apps){
                appsCollection = options.collection.apps = new AppsCollection();
                $.when(currentUserIdDfd).done(function(){
                    appsCollection.fetch({
                        data: {
                            sort_key: 'name',
                            sort_dir: 'asc',
                            app: '-' ,
                            owner: options.model.application.get('owner'),
                            search: 'visible=true AND disabled=0 AND name!=launcher',
                            count: -1
                        }
                    });
                    appsCollection.on('reset sort', appsDfd.resolve);
                });
            } else {
                appsDfd.resolve();
            }

            if (!options.model.userPref){
                options.model.userPref = new UserPrefModel();
                options.model.userPref.fetch({data: {app:'user-prefs', owner: options.model.application.get('owner'), count:-1}});
                appsCollection = options.collection.apps;
                options.model.userPref.on('change', function(){
                    appsDfd.done(function(){
                        appsCollection.sortWithString(options.model.userPref.entry.content.get('appOrder'));
                        appsCollection.trigger('ready');
                    });
                });
            }

            var serverInfoDfd = $.Deferred();
            if (!options.model.serverInfo) {
                options.model.serverInfo = new ServerInfoModel();
                options.model.serverInfo.fetch({
                    success: function() {
                        serverInfoDfd.resolve();
                    }
                });
            } else {
                serverInfoDfd.resolve();
            }
            
            
            if(!options.model.user){
                options.model.user = new UserModel({}, {serverInfoModel: options.model.serverInfo});
                $.when(currentUserIdDfd, serverInfoDfd).done(function(currentUserId){
                    options.model.user.set('id', encodeURIComponent(currentUserId));
                    options.model.user.fetch();
                });
            }

            if (!options.collection.messages) {
                options.collection.messages = new MessagesCollection();
                //SPL-48272 - fetch messages by time created in descending order
                options.collection.messages.fetchData.set({
                    "sort_key" : "timeCreated_epochSecs",
                    "sort_dir" : "desc"
                });
            }
            
            var managersDfd = $.Deferred();
            if (!options.collection.managers){
                options.collection.managers = new ManagersCollection();
                $.when(currentUserIdDfd).done(function(currentUsername){
                    options.collection.managers.fetch({
                        data: {
                            app: '-',
                            owner: currentUsername,
                            count: 0,
                            digest: 1
                        },
                        success: function() {
                            managersDfd.resolve();
                        }
                    });
                });
            } else {
                managersDfd.resolve();
            }

            options.collection.sections = new SystemMenuSectionsCollection();
            options.model.webConf = new WebConfModel({id: 'settings'});
            options.model.webConf.fetch();
            
            var view = new View(options);

            $.when(managersDfd).done(function() {
                view.sectionsMunger();
            });
            
            return view;
        }
    });
    return View;
});

define('contrib/text!views/shared/appbar/NavItem.html',[],function () { return '<% var hasSubmenu = item.submenu && item.submenu.length && item.submenu.length > 0; %>\n<a href="<%-item.uri%>" title="<%- _(item.label).t() %>" class="<%=hasSubmenu ? \'dropdown-toggle\' : \'\'%>" <%=hasSubmenu ? \'data-toggle="popdown"\' : \'\'%>>\n    <%- _(item.label).t() %>\n    <%if(hasSubmenu){%>\n       <b class="caret"></b>\n    <%}%>\n</a>\n<%if(hasSubmenu){%>\n    <div class="dropdown-menu">\n    \t<div class="arrow"></div>\n    \t<div class="slideNavPlaceHolder"></div>\n    </div>\n<%}%>\n';});

define('contrib/text!views/shared/AppNav-SlideNavTemplate.html',[],function () { return '<%if(!submenu){return "";}%>\n<ul class="slidenavList scroll-group">\n    <% _.each(submenu, function(i, index) { %>\n    <li data-index="<%=index%>" class="<%=i.divider ? \'divider\':\'\'%>">\n        <% if(!i.divider){ %>\n            <% if(i.submenu && i.submenu.length>0){ %>\n                <a href="#">\n                    <%- _.unescape(_(i.label).t()) %>\n                </a>\n                <i class="icon-triangle-right-small"></i>\n            <%}else if (i.hasOwnProperty(\'reportUri\')) { %>\n                <a href="<%=i.reportUri%>" class="primary-link">\n                    <%- _.unescape(_(i.label).t()) %>\n                </a>\n                <a href="<%=i.uri%>" class="secondary-link">\n                    <i class="icon-<%= i.hasOwnProperty(\'dispatchView\') && i.dispatchView === \'pivot\' ? \'pivot\' : \'search\' %>"></i>\n                </a>\n            <%} else { %>\n                <a href="<%=i.uri%>">\n                    <%- _.unescape(_(i.label).t()) %>\n                </a>\n            <%}%>\n        <%}%>\n    </li>\n    <% }); %>\n</ul>\n';});

define('splunk.widget.slidenav',['jquery', 'jquery.ui.widget', 'jquery.ui.position'], function($){
    return $.widget( "splunk.slidenav", {
        options: {
            levelTemplate: '',
            navData: {},
            childPropertyName: 'children',
            backText: 'Back'
        },
        _create: function(){
            var self = this;
            this.isAnimating = false;
            this.$el = $(this.element);
            this.$wrap = $('<div class="auto"></div>');
            this.$el.append(this.$wrap);
            this._chain = [this.addLevel(this.options.navData)];
            this.$backButton = $(self.templateBack());
            this.$el.prepend(this.$backButton);
            this.$backButton.on('click', function(event){
                self.back();
                event.preventDefault();
            });
            this.$el.on('click', 'LI', function(event){
                var li = $(event.target).closest('LI');
                self.select(li, event);
            });
        },
        addLevel: function(navData){
            var newLevel = $(this.options.levelTemplate(navData));
            this.$wrap.append(newLevel);
            if(this._chain){
                newLevel.position({
                    of: this._chain[this._chain.length-1],
                    my: 'left top',
                    at: 'right top',
                    collision: 'none',
                    offset: "0 0"
                });
            }
            newLevel.data('slidenav', navData);
            return newLevel;
        },
        select: function(selected, event){
            if(this.isAnimating){
                return false;
            }
            var ul = selected.closest('ul'),
                navData = ul.data('slidenav'),
                selectedIndex = selected.data("index");
            selected.find('a').addClass('slideNavActiveParent');
            selected = navData[this.options.childPropertyName][selectedIndex];
            if(selected[this.options.childPropertyName] && selected[this.options.childPropertyName].length > 0){
                if(event){
                    event.preventDefault();
                }
                this.next(selected);
            }else{
                this._trigger('select', event, selected);
            }
        },
        next: function(selected){
            var current = this._chain[this._chain.length-1] || null;
            selected.domReference = selected.domReference || this.addLevel(selected);
            this._chain.push(this.slide(selected.domReference.show(), function(){
                current.find('a').prop('tabindex', '-1');
                selected.domReference.find('a').first().focus();
            }));
            this.$backButton.show();
        },
        back: function(){
            if(this._chain.length <= 1 || this.isAnimating){
                return false;
            }
            if(this._chain.length === 2){
                this.$backButton.hide();
            }
            var $hide = this._chain.pop(),
                to = this._chain[this._chain.length-1];
            to.find('.slideNavActiveParent').removeClass('slideNavActiveParent').focus();
            this.slide(to, function(){
                $hide.scrollTop(0).hide();
                to.find('a').prop('tabindex', '0');
            });
        },
        slide: function(to, callback){
            var self = this;
            this.$wrap.outerHeight(to.outerHeight());
            this.isAnimating = true;
            this.$wrap.animate({
                left: -to.position().left
            }, {
                duration: 200,
                complete: function(){
                    self.isAnimating = false;
                    if(callback){
                        callback.apply(self, arguments);
                    }
                }
            });
            return to;
        },
        templateBack: function(){
            return this.options.templateBack || '<div class="backbutton" style="display: none;"><a href="#" class="slidenavback "><i class="icon-chevron-left"></i>'+this.options.backText+'</a></div>';
        }
    });
});

define('views/shared/appbar/NavItem',[
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'views/shared/delegates/Popdown',
    'contrib/text!views/shared/appbar/NavItem.html',
    'contrib/text!views/shared/AppNav-SlideNavTemplate.html',
    'views/shared/delegates/StopScrollPropagation',
    'splunk.widget.slidenav'//no import
],
function(
    $,
    _,
    module,
    BaseView,
    Popdown,
    templateNavItem,
    templateSlideNav,
    StopScrollPropagation
){
    var templateSlideNavCompiled = _.template(templateSlideNav);
    var View = BaseView.extend({
            moduleId: module.id,
            className: 'nav-item',
            tagName: 'li',
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
            },
            render: function() {
                var html,
                    label = this.options.navItemObj.label,
                    isLite = this.model.serverInfo.isLite();
                    
                if (this.options.navItemObj.divider) {
                    html = _.template(this.dividerTemplate, {});
                } else {
                    html = _.template(templateNavItem, {
                        item: this.options.navItemObj,
                        isActive: this.options.isActive
                    });
                }

                // Nav Restrictors for Lite
                if (label === _('Pivot').t() && !this.model.user.canPivot()) {
                    return;
                } 
                
                this.$el.append(html);
                this.$el.addClass('nav-item-'+this.options.navItemObj.viewName);
                if(this.options.navItemObj.submenu && this.options.navItemObj.submenu.length > 0){
                    this.$el.addClass('dropdown');
                    this.slideNav = this.$el.find('.slideNavPlaceHolder').slidenav({
                        navData: this.options.navItemObj,
                        levelTemplate: templateSlideNavCompiled,
                        childPropertyName: 'submenu',
                        backText: _('Back').t()
                    });

                    this.popdown = new Popdown({
                        el: this.$el,
                        dialog: this.slidenav,
                        mode: 'dialog'
                    });

                    this.children.stopScrollPropagation = new StopScrollPropagation({el:this.slideNav.find('.slidenavList')});
                }

                return this;
            },
            dividerTemplate: '<span class="divider" style="display: block;float: left;height: 10px;margin: 0 15px;opacity: 0.2;"></span>'
        }
    );
    return View;
});

define('views/shared/appbar/AppNav',[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'views/Base',
    'views/shared/appbar/NavItem'
],
function(
    $,
    _,
    Backbone,
    module,
    BaseView,
    NavItem
){
    return BaseView.extend({
        moduleId: module.id,
        tagName: 'ul',
        className: 'nav nav-pills',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.listenTo(this.model.appNav, 'change:nav', this.debouncedRender);
            this.listenTo(this.model.application, 'change:page', this.setActiveItem);
        },
        render: function() {
            var self = this;
            var navData = this.model.appNav.get('nav');
            if(!navData){return this;}

            this.$el.html('');
            $.each(navData, function(index, navItemObj){
                var navItemView = new NavItem({
                    navItemObj: navItemObj,
                    model: {
                        serverInfo: self.model.serverInfo,
                        user: self.model.user    
                    }                    
                });
                self.$el.append(navItemView.render().$el);
            });

            this.setActiveItem.call(this);

            return this;
        },
        setActiveItem: function(){
            var self = this;
            if(this.model.application.get('page')){
                var activePage = this.model.application.get('page');
                var activeItem = self.$el.find('.nav-item-'+activePage);
                activeItem.addClass('active');
            }
        }
    });
});

define('contrib/text!views/shared/appbar/AppLabel.html',[],function () { return '<a class="app-link" href="<%=appLink%>">\n    <div class="app-logo"></div>\n\n    <div class="app-name">\n        <span class="app-label">\n            <%-_(appLabel).t()%>\n        </span>\n    </div>\n</a>\n';});

define('views/shared/appbar/AppLabel',[
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/shared/appbar/AppLabel.html'
],
function(
    _,
    module,
    BaseView,
    templateAppLabel
){
    return BaseView.extend({
        moduleId: module.id,
        className: 'app-bar-label-wrapper',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.appNav.on('change', this.render, this);
        },
        showLogo: function(){
            this.$el.find('.app-logo').show();
            this.$el.find('.app-name').hide();
        },
        showName: function(){
            this.$el.find('.app-name').show();
            this.$el.find('.app-logo').hide();
        },
        render: function(){
            var label = this.model.appNav.get('label') || '';

            var html = _.template(templateAppLabel, {
                appLink: this.model.appNav.get('link'),
                appLabel: label,
                appLogo: this.model.appNav.get('logo')
            });
            this.$el.html(html);

            this.setAppLabelDisplay();

            return this;
        },
        setAppLabelDisplay: function(){
            if (this.model.appNav.get('logo')) {
                var img = new Image();
                img.onload = function(){
                    if(parseInt(img.width, 10) < 2){
                        this.showName();
                    }else{
                        this.$el.find('.app-logo').empty().append(img);
                        this.showLogo();
                    }
                }.bind(this);

                img.onerror = function(){
                    this.showName();
                }.bind(this);

                img.src = this.model.appNav.get('logo');
            }
        }
    });
});

define('contrib/text!views/shared/appbar/Master.html',[],function () { return '<h2 class="app-name pull-right"></h2>\n<div class="nav"></div>\n';});

/**
 * @author Leo
 *
 * Produces a JSON object containing necessary data to construct an app's navigation menu.
 *
 */
define('helpers/AppNav',[
    'jquery',
    'underscore',
    'backbone',
    'splunk.util',
    'util/xml'
],
function (
    $,
    _,
    Backbone,
    splunk_util,
    XML
){
    var app,
        views,
        rootEndpoint,
        searches,
        nav,
        seenViews = [],
        seenSearches = [];

    /**
     * Filters the collection to models belonging to the current app, optionally with name matching a string and
     * optionally among those that haven't been processed yet.
     *
     * @param collection Input collection
     * @param match {String} optional String to match
     * @param seen {Array} optional list of already processed objects that should be skipped
     * @return {Array} filtered array of models
     */
    function getMatchingItems(collection, match, seen) {
        return collection.filter(function(it) {
            var itApp =  it.entry.acl.get('app'),
                itName = it.entry.get('name'),
                isGlobal = it.entry.acl.get('sharing') === 'global';
            if (!isGlobal && itApp !== app) {
                return false;
            }
            if (match) {
                return (itName.toLowerCase().indexOf(match.toLowerCase())>-1 && !(seen && seen.indexOf(app+'/'+itName)>-1));
            } else {
                return !(seen && seen.indexOf(app+'/'+itName)>-1);
            }
        });
    }

    /**
     * Searches views collection for a view name to get its label
     *
     * @param name {String} view name
     * @return {Object} containing view label
     */
    function getViewProps(viewName) {
        var obj, view, i, v;
        views = views || [];
        for (i=0; i<views.length; i++) {
            v = views.at(i);
            if (v.entry.get('name').toLowerCase() === viewName.toLowerCase()) {
                // allow either a view local to the current app
                if (v.entry.acl.get('app') == app) {
                    view = v;
                    break; // local views have priority over global ones

                // or a globally shared view from another app
                } else if (v.entry.acl.get('sharing') == 'global') {
                    view = v;
                }
            }
        }

        if (view) {
            if (!view.entry.content.get('isVisible')) {
                return false;
            }
            obj = {
                label: view.entry.content.get('label') || viewName,
                uri: splunk_util.make_url('app', app, viewName),
                viewName: viewName,
                app: app
            };
        } else {
            return false;
        }
        return obj;
    }

    /**
     * Searches saved searches collection for a search name to get its properties
     * @param name {String} search name
     * @return {Object} containing search properties
     */
    function getSavedProps(name) {
        var obj,
            saved = searches.find(function(s) {
                return (s.entry.get('name').toLowerCase() === name.toLowerCase());
            });
        if (saved) {
            obj = {
                uri: splunk_util.make_full_url('app/'+encodeURIComponent(app)+'/@go', {'s': saved.id}),
                sharing: saved.get('sharing'),
                label: name,
                reportUri: splunk_util.make_full_url('app/'+encodeURIComponent(app)+'/report', {'s': saved.id})
            };
            if (saved.entry.content.get('request.ui_dispatch_view')) {
                obj.dispatchView = saved.entry.content.get('request.ui_dispatch_view');
            }
        } else {
            return false;
        }
        return obj;
    }

    function sanatizeHref(href){
        if(typeof href !== 'string'){
            return false;
        }
        var decodedhref = $("<div></div>").html(href).text();
        decodedhref = window.decodeURI(decodedhref);
        decodedhref = decodedhref.replace(/(\r\n|\n|\r|\s)/gm,'').toLowerCase();
        if(decodedhref.indexOf(':') > -1 &&
            decodedhref.indexOf('javascript:') > -1 ||
            decodedhref.indexOf('vbscript:') > -1 ||
            decodedhref.indexOf('data:') > -1 ||
            decodedhref.indexOf('livescript:') > -1){
            href = false;
        }
        return href;
    }

    /**
     * Recursively go through nav xml, building a json object
     *
     * @param nav {xml}
     * @return {Object} JSON object
     */
    function parseNavXml(nav) {
        var output = [],
            c;
        for (c=0; c<nav.length; c++) {
            var node = nav[c],
                $node = $(node),
                nodeName = splunk_util.lowerTrimStr(node.nodeName),
                obj;

            if (nodeName === 'collection') {
                obj = {
                    label: $node.attr('label'),
                    uri: '#'
                };
                // recursion warning!
                var children = parseNavXml($node.children());
                if (!children.submenu.length ||
                    !_.find(children.submenu, function(obj) { return !obj.divider; })) {
                    // skip empty collections and ones containing only dividers
                    continue;
                }
                _.extend(obj, children);
            /*
            Views
             */
            } else if (nodeName === 'view') {
                var viewName = $node.attr('name'),
                    isDefault = splunk_util.normalizeBoolean($node.attr('default')||"false"),
                    source = splunk_util.lowerTrimStr($node.attr('source')),
                    match = $node.attr('match');

                if (viewName) {
                    obj = getViewProps(viewName);
                    if (!obj) {
                        continue;
                    }
                    if (isDefault) {
                        obj.isDefault = isDefault;
                    }
                    // mark as seen
                    seenViews.push(app+'/'+viewName);

                } else if (source) {
                    var matchedViews = [],
                        i;
                    if (source == 'all') {
                        matchedViews = getMatchingItems(views, match);
                    } else if (source == 'unclassified') {
                        matchedViews = getMatchingItems(views, match, seenViews);
                    }
                    for (i=0; i<matchedViews.length; i++) {
                        viewName = matchedViews[i].entry.get('name');
                        obj = getViewProps(viewName);
                        if (!obj) {
                            continue;
                        }
                        if (!matchedViews[i].entry.content.get('isDashboard')) {
                            continue;
                        }
                        // mark as seen
                        seenViews.push(app+'/'+viewName);
                        output.push(obj);
                    }
                    obj = false;
                }

            /*
             Saved searches
             */
            } else if (nodeName === 'saved') {
                var savedName = $node.attr('name');
                source = splunk_util.lowerTrimStr($node.attr('source'));
                match = $node.attr('match');

                if (savedName) {
                    obj = getSavedProps(savedName);
                    if (!obj) {
                        continue;
                    }
                    seenSearches.push(app+'/'+savedName);
                } else if (source) {
                    var matchedSearches = [];
                    if (source == 'all') {
                        matchedSearches = getMatchingItems(searches, match);
                    } else if (source == 'unclassified') {
                        matchedSearches = getMatchingItems(searches, match, seenSearches);
                    }
                    for (i=0; i<matchedSearches.length; i++) {
                        savedName = matchedSearches[i].entry.get('name');
                        obj = getSavedProps(savedName);
                        if (!obj) {
                            continue;
                        }
                        // mark as seen
                        seenSearches.push(app+'/'+savedName);
                        output.push(obj);
                    }
                    obj = false;
                }
            } else if (nodeName === 'a') {
                var href = sanatizeHref($node.attr('href'));
                if(href===false){
                    obj=false;
                }else{
                    if (href.indexOf('/') === 0 && href[1] !== '/'){
                        href = splunk_util.make_url(href);
                    }
                    obj = {
                        label: $node.text(),
                        uri: href,
                        viewName: $node.attr('name') || ''
                    };
                }
            } else if (nodeName === 'divider') {
                obj = {
                    label: '',
                    divider: true
                };
            } else {
                obj = {
                    label: 'unknown node in nav'
                };
            }

            if (obj) {
                output.push(obj);
            }

        }
        return {submenu: output};
    }

    function parseNavModel(nav, viewsCollection, savedSearchCollection, rootPath){
        var xmlNavString = nav.entry.content.get('eai:data');
        var navXmlObj;
        try {
            navXmlObj = XML.parse(xmlNavString);
        } catch (e) {
            // Fall back to legacy behavior where slightly invalid XML was corrected
            // SPL-84474
            navXmlObj = XML.parse(xmlNavString.replace(/\&/g, "&amp;"));
        }
        var root = navXmlObj.find('nav');
        var searchView = root.attr('search_view');
        var appColor = root.attr('color');

        seenViews = seenSearches = [];
        app = nav.entry.content.get('eai:appName');
        views = viewsCollection;
        rootEndpoint = rootPath || '';
        searches = new Backbone.Collection(savedSearchCollection.filter(function(model) {
            var appMatch = model.entry.acl.get('app') == app,
                isGlobal = model.entry.acl.get('sharing') == 'global';
            return appMatch || isGlobal;
        }));
        return {
            nav: parseNavXml(root.children()).submenu,
            searchView: searchView,
            color: appColor
        };
    }

    /**
     * Entry point, kicking off the parsing.
     *
     * @param navsCollection {Collection} output of /data/ui/nav endpoint
     * @param viewsCollection {Collection} output of /data/ui/views endpoint
     * @param savedSearchCollection {Collection} output of /saved/searches endpoint
     *
     * @return {Array} of JSON objects or null if appname is undefined or nav coll is empty
     */
    function parseNavCollection(navsCollection, viewsCollection, savedSearchCollection, rootPath) {
        var result = [];
        rootEndpoint = rootPath || '';
        seenViews = seenSearches = [];
        if (!navsCollection || navsCollection.length == 0) {
            return null;
        }
        navsCollection.each(function(nav){
            result.push(
                parseNavModel(nav,viewsCollection, savedSearchCollection)
            );
        });
        return result;
    }

    return {
        parseNavModel: parseNavModel,
        parseNavCollection: parseNavCollection
    };
});
/**
 * Util package for working with colors.
 */
define('util/color_utils',['underscore'], function(_) {

    var hslColorFromRgbColor = function(rgbColor) {
        /**
         * convert from [r,g,b] to [h,s,l]
         *  r,g,b: [0,255]
         *  h: [0,360)
         *  s: [0,100]
         *  l: [0,100]
         *  Uses algorithm as specified on Wikipedia http://en.wikipedia.org/wiki/HSL_and_HSV
         */

        var r = rgbColor[0];
        var g = rgbColor[1];
        var b = rgbColor[2];
        var computedH = 0;
        var computedS = 0;
        var computedL = 0;

        if (r === null || g === null || b === null ||
            isNaN(r) || isNaN(g)|| isNaN(b) ) {
            return null;
        }

        if (r < 0 || g < 0 || b < 0 ||
            r > 255 || g > 255 || b > 255) {
            return null;
        }

        r = r / 255;
        g = g / 255;
        b = b / 255;
        var minRGB = Math.min(r, Math.min(g, b));
        var maxRGB = Math.max(r, Math.max(g, b));
        var chroma = maxRGB - minRGB;

        var h_prime = 0;
        if (chroma == 0) {
            h_prime = 0;
        }
        else if (maxRGB == r) {
            h_prime = ((g - b) / chroma) % 6;
        } else if (maxRGB == g) {
            h_prime = ((b - r) / chroma) + 2;
        } else if (maxRGB == b) {
            h_prime = ((r - g) / chroma) + 4;
        }

        var h = h_prime * 60;
        while (h < 0)
        {
            h += 360;
        }
        while (h > 360)
        {
            h -= 360;
        }

        var l = 0.5 * (maxRGB + minRGB);

        var s = 0;
        if (chroma == 0) {
            s = 0;
        } else {
            s = chroma / (1 - Math.abs(2 * l - 1));
        }

        if (s < 0) { s = 0; }
        if (s > 1) { s = 1; }
        if (l < 0) { l = 0; }
        if (l > 1) { l = 1; }

        return [h, s * 100, l * 100];
    };

    var rgbColorFromHslColor = function(hslColor) {
        /**
         * convert from [h,s,l] to [r,g,b]
         *  r,g,b: [0,255]
         *  h: [0,360)
         *  s: [0,100]
         *  l: [0,100]
         *  Uses algorithm as specified on Wikipedia http://en.wikipedia.org/wiki/HSL_and_HSV
         */
        if (hslColor.length != 3) {
            return null;
        }

        var h = hslColor[0],
            s = hslColor[1],
            l = hslColor[2];

        s = s / 100;
        l = l / 100;

        while (h < 0)
        {
            h += 360;
        }
        while (h > 360)
        {
            h -= 360;
        }

        if (h < 0 || h > 360 ||
            s < 0 || s > 1 ||
            l < 0 || l > 1)
        {
            return null;
        }

        // chroma
        var c = (1 - Math.abs(2 * l - 1)) * s;

        // determine color components (sans lightness)
        var h1 = h / 60;
        var x = c * (1 - Math.abs((h1 % 2) - 1));
        var r1 = 0,
            g1 = 0,
            b1 = 0;

        if (h1 < 1) {
            r1 = c;
            g1 = x;
        } else if (h1 < 2) {
            r1 = x;
            g1 = c;
        } else if (h1 < 3) {
            g1 = c;
            b1 = x;
        } else if (h1 < 4) {
            g1 = x;
            b1 = c;
        } else if (h1 < 5) {
            r1 = x;
            b1 = c;
        } else {
            r1 = c;
            b1 = x;
        }

        // add lightness component to get r,g,b
        var m = l - 0.5 * c;
        var r = r1 + m,
            g = g1 + m,
            b = b1 + m;

        // return in [0,255] range
        r *= 255;
        g *= 255;
        b *= 255;

        return [r, g, b];
    };

    var rgbColorFromRgbString = function(rgbColorString) {
        /**
         * given "rgb(r,g,b)" converts to [r,g,b]
         */

        var rgbValueStrings = rgbColorString.match(/^rgb\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)$/);
        if (rgbValueStrings === null) {
            return null;
        }

        var rgbColor = [parseInt(rgbValueStrings[1], 10),
                        parseInt(rgbValueStrings[2], 10),
                        parseInt(rgbValueStrings[3], 10)];

        return rgbColor;
    };

    var rgbStringFromRgbColor = function(rgbColor) {
        /**
         * given [r,g,b] returns "rgb(r,g,b)"
         *  r, g, b are all rounded to nearest integers
         */
        if (rgbColor.length != 3) {
            return null;
        }

        var roundedRgbColor = _.map(rgbColor, Math.round);
        var rgbString = "rgb(" + roundedRgbColor[0] + ", " + roundedRgbColor[1] + ", " + roundedRgbColor[2] + ")";
        return rgbString;
    };

    var hslStringFromHslColor = function(hslColor) {
        /**
         * given [h,s,l] returns "hsl(h,s%,l%)"
         *  h, s, l are all rounded to nearest integers
         */
        if (hslColor.length != 3) {
            return null;
        }
        var roundedHslColor = _.map(hslColor, Math.round);
        var hslString = "hsl(" + roundedHslColor[0] + ", " + roundedHslColor[1] + "%, " + roundedHslColor[2] + "%)";
        return hslString;
    };

    var hslColorFromHslString = function(hslColorString) {
        /**
         * given "hsl(h,s%,l%)" returns [h,s,l]
         */
        var hslValueStrings = hslColorString.match(/^hsl\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\)$/);
        if (hslValueStrings === null) {
            return null;
        }

        var hslColor = [parseInt(hslValueStrings[1], 10),
                        parseInt(hslValueStrings[2], 10),
                        parseInt(hslValueStrings[3], 10)];

        return hslColor;
    };

    var rgbColorFromHexString = function(hexColorString) {
        /**
         * given "#RRGGBB" returns [r,g,b]
         */
        var normHexColorString = normalizeHexString(hexColorString);
        var hexValueStrings = normHexColorString.match(/^#?([\dA-Fa-f]{2})([\dA-Fa-f]{2})([\dA-Fa-f]{2})$/);
        if (hexValueStrings === null) {
            return null;
        }

        var rgbColor = [parseInt(hexValueStrings[1], 16),
                        parseInt(hexValueStrings[2], 16),
                        parseInt(hexValueStrings[3], 16)];

        return rgbColor;
    };

    var hexStringFromRgbColor = function(rgbColor) {
        /**
         * given [r,g,b] returns "#RRGGBB"
         *  r,g,b rounded to nearest integers
         */
        if (rgbColor.length != 3) {
            return null;
        }

        var roundedRgbColor = _.map(rgbColor, Math.round);
        var hexComponents = _.map(roundedRgbColor, function(num) {
            var hex = num.toString(16);
            if (hex.length < 2) {
                hex = "0" + hex;
            }
            return hex.toUpperCase();
        });
        var hexString = "#" + hexComponents[0] + hexComponents[1] + hexComponents[2];
        return hexString;
    };

    var normalizeHexString = function(hexString) {
        /**
         * given "rrggbb", "RRGGBB", "#rrggbb", "#RRGGBB" returns "#RRGGBB"
         */
        var normString = '#' + hexString.replace('#','');
        normString = normString.toUpperCase();
        // check for #RGB, to convert to #RRGGBB
        var hexValueStrings = normString.match(/^#?([\dA-F])([\dA-F])([\dA-F])$/);
        if (hexValueStrings !== null) {
            normString = '#' + hexValueStrings[1] + hexValueStrings[1] +
                               hexValueStrings[2] + hexValueStrings[2] +
                               hexValueStrings[3] + hexValueStrings[3];
        }
        return normString;
    };

    var modifyLuminosityOfHslColor = function(hslColor, luminosityMultiplier){
        /**
         * adjusts the luminosity of the specified hsl color by multiplying by luminosityMultiplier
         *  l is clamped to within [0,100]
         */
        var modHslColor = hslColor.slice(0);

        modHslColor[2] *= luminosityMultiplier;
        if (modHslColor[2] > 100) {
            modHslColor[2] = 100;
        } else if (modHslColor[2] < 0) {
            modHslColor[2] = 100;
        }

        return modHslColor;
    };

    var modifyLuminosityOfRgbColor = function(rgbColor, luminosityMultiplier){
        /**
         * adjusts the luminosity of the specified rgb color by luminosityMultiplier
         *   1 - convert to hsl
         *   2 - l *= luminosityMultiplier AND clamp(0,100)
         *   3 - convert back to rgb
         */
        var hslColor = hslColorFromRgbColor(rgbColor);
        var modHslColor = modifyLuminosityOfHslColor(hslColor, luminosityMultiplier);
        var modRgbColor = rgbColorFromHslColor(modHslColor);
        return modRgbColor;
    };

    var modifyLuminosityOfHexString = function(hexString, luminosityMultiplier){
        /**
         * adjusts the luminosity of the specified rgb color by luminosityMultiplier
         *   1 - convert to rgb, then to hsl
         *   2 - l *= luminosityMultiplier AND clamp(0,100)
         *   3 - convert back to rgb, then to hex
         */
        var rgbColor = rgbColorFromHexString(hexString);
        var modRgbColor = modifyLuminosityOfRgbColor(rgbColor, luminosityMultiplier);
        var modHexString = hexStringFromRgbColor(modRgbColor);
        return modHexString;
    };

    var generateGradientStylesWithMidColor = function(startColor, midColor, colorStop, endColor){
        /**
         * returns array of gradient style directives that cover set of browsers
         * builds gradient from three colors, places the midColor at colorStop percent
         *  startColor, midColor, endColor are css interpretable colors
         *  colorStop is "stop%", e.g. "50%", "80%"
         */
        var gradients =
            [
                ' -webkit-gradient(linear, 0 0, 0 100%, from(@startColor), color-stop(@colorStop, @midColor), to(@endColor)) ',
                ' -webkit-linear-gradient(@startColor, @midColor @colorStop, @endColor) ',
                ' -moz-linear-gradient(top, @startColor, @midColor @colorStop, @endColor) ',
                ' -o-linear-gradient(@startColor, @midColor @colorStop, @endColor) ',
                ' linear-gradient(@startColor, @midColor @colorStop, @endColor) ',
                // note: this uses filter instead of bg-image
                " progid:DXImageTransform.Microsoft.gradient(startColorstr='@startColor', endColorstr='@endColor', GradientType=0) "  // IE9 and down, gets no color-stop at all for proper fallback
            ];
        for (var i=0;i<gradients.length;i++){
            gradients[i] = gradients[i].replace(/@startColor/g, startColor);
            gradients[i] = gradients[i].replace(/@midColor/g, midColor);
            gradients[i] = gradients[i].replace(/@colorStop/g, colorStop);
            gradients[i] = gradients[i].replace(/@endColor/g, endColor);
        }
        return gradients;
    };

    var generateGradientStyles = function(startColor, endColor){
        /**
         * returns array of gradient style directives that cover set of browsers
         * builds gradient from two colors
         *  startColor, endColor are css interpretable colors
         */
        var gradients =
            [
                ' -moz-linear-gradient(top, @startColor, @endColor) ', // FF 3.6+
                ' -webkit-gradient(linear, 0 0, 0 100%, from(@startColor), to(@endColor))', // Safari 4+, Chrome 2+
                ' -webkit-linear-gradient(top, @startColor, @endColor) ', // Safari 5.1+, Chrome 10+
                ' -o-linear-gradient(top, @startColor, @endColor) ', // Opera 11.10
                ' linear-gradient(to bottom, @startColor, @endColor) ', // Standard, IE10
                // note: this uses filter instead of bg-image
                " progid:DXImageTransform.Microsoft.gradient(startColorstr='@startColor', endColorstr='@endColor', GradientType=0)  " // IE9 and down
            ];
        for (var i=0;i<gradients.length;i++){
            gradients[i] = gradients[i].replace(/@startColor/g, startColor);
            gradients[i] = gradients[i].replace(/@endColor/g, endColor);
        }
        return gradients;
    };

    return {
        hslColorFromRgbColor: hslColorFromRgbColor,
        rgbColorFromHslColor: rgbColorFromHslColor,
        hslColorFromHslString: hslColorFromHslString,
        rgbColorFromRgbString: rgbColorFromRgbString,
        hslStringFromHslColor: hslStringFromHslColor,
        rgbStringFromRgbColor: rgbStringFromRgbColor,
        rgbColorFromHexString: rgbColorFromHexString,
        hexStringFromRgbColor: hexStringFromRgbColor,
        normalizeHexString: normalizeHexString,
        modifyLuminosityOfHslColor: modifyLuminosityOfHslColor,
        modifyLuminosityOfRgbColor: modifyLuminosityOfRgbColor,
        modifyLuminosityOfHexString: modifyLuminosityOfHexString,
        generateGradientStylesWithMidColor: generateGradientStylesWithMidColor,
        generateGradientStyles: generateGradientStyles
    };
});

define('views/shared/appbar/Master',[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'views/Base',
    'views/shared/appbar/AppNav',
    'views/shared/appbar/AppLabel',
    'models/shared/Application',
    'models/services/data/ui/Nav',
    'models/services/AppLocal',
    'collections/services/data/ui/Views',
    'collections/services/saved/Searches',
    'contrib/text!views/shared/appbar/Master.html',
    'helpers/AppNav',
    'uri/route',
    'util/color_utils',
    'util/console'
],
function(
    $,
    _,
    Backbone,
    module,
    BaseView,
    AppNavView,
    AppLabelView,
    ApplicationModel,
    NavModel,
    AppModel,
    ViewsCollection,
    SavedSearchesCollection,
    templateMaster,
    appNavParser,
    route,
    color_utils,
    console
) {
    var View = BaseView.extend({
        moduleId: module.id,
        className: 'app-bar',
        initialize: function(options) {
            BaseView.prototype.initialize.apply(this, arguments);

            this.children.appNav = new AppNavView({
                model: {
                    user: this.model.user,
                    serverInfo: this.model.serverInfo,
                    appNav: this.model.appNav,
                    application: this.model.application
                },
                collection: this.collection
            });

            this.children.appLabel = new AppLabelView({
                model: this.model,
                collection: this.collection
            });

            this.setBannerColor();
            this.model.appNav.on('change:color', this.setBannerColor, this);

            if(options.autoRender !== false) {
                this.debouncedRender();
            }
        },
        render: function() {
            var html = _.template(templateMaster);
            this.$el.html(html);
            this.$el.find('.nav').html(this.children.appNav.render().el);
            this.$el.find('.app-name').html(this.children.appLabel.render().el);

            return this;
        },
        setBannerColor: function(){
            if(!this.model.appNav){return false;}

            var navColor = color_utils.normalizeHexString(this.model.appNav.get('color')||'');
            var isHexColor = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(navColor);
            if (!isHexColor ){
                return false;
            }
            this.$el.css('background-color', navColor);
        }
    },
    {
        END_GRADIENT_LUMINOSITY: 0.90,
        createWithAppNavUrl: function(options){
            var self = this;
            var app = options.model.application.get('app');
            var owner = options.model.application.get('owner');
            var applicationDfd = new $.Deferred();

            if (app && owner) {
                applicationDfd.resolve(app, owner);
            } else {
                options.model.application.once('change', function() {
                    var app = options.model.application.get('app');
                    var owner = options.model.application.get('owner');
                    if (app && owner) {
                        applicationDfd.resolve(app, owner);
                    }
                });
            }

            applicationDfd.done(function(){
                var url = route.appNavUrl(options.model.application.get('root'), options.model.application.get('locale'), options.model.application.get('app'));
                $.ajax({
                    url: url,
                    dataType:'json'
                }).done(function(data){
                        self._applyAppNavData(data, options.model.appNav, options, false);
                    }).fail(function() {
                        self.createWithBackbone(options);
                    });
            });
        },
        createWithAppNavModel: function(options) {
            var appNav = options.model.appNav;
            this._applyAppNavData(appNav.entry.content.toJSON(), appNav, options, false);
        },
        createWithBackbone: function(options){
            var self = this;
            var applicationDfd = $.Deferred();
            var appNavDfd = $.Deferred();
            var viewsDfd = $.Deferred();
            var savedSearchesDfd = $.Deferred();
            var appDfd = $.Deferred();
            function updateNavData() {
                var data = appNavParser.parseNavModel(
                    options.model.splunkDappNav,
                    options.collection.views,
                    options.collection.savedSearches,
                    options.model.application.get('root')
                );
                var appLabel;
                if (data.appLabel) {
                    appLabel = data.appLabel;
                } else if (options.model.app && options.model.app.entry && options.model.app.entry.content && options.model.app.entry.content.get('label')) {
                    appLabel = options.model.app.entry.content.get('label') || '';
                }
                self._applyAppNavData({
                    nav: data.nav,
                    color: data.color,
                    label: appLabel,
                    defaultView: data.defaultView,
                    searchView: data.searchView
                }, options.model.appNav, options, false);
            }

            var app = options.model.application.get('app');
            var owner = options.model.application.get('owner');
            if (app && owner) {
                applicationDfd.resolve(app, owner);
            } else {
                options.model.application.once('change', function() {
                    var app = options.model.application.get('app');
                    var owner = options.model.application.get('owner');
                    if (app && owner) {
                        applicationDfd.resolve(app, owner);
                    }
                });
            }

            if (!options.model.app) {
                options.model.app = new AppModel();
                applicationDfd.done(function(app, owner) {
                    options.model.app.set({id: 'apps/local/' + app});
                    options.model.app.fetch({data: {app: app, owner: owner}});
                });
            }

            if (!options.collection.views) {
                options.collection.views = new ViewsCollection();
                applicationDfd.done(function(app, owner) {
                    options.collection.views.fetch({data: {app: app, owner: owner, count: -1, digest: 1}});
                });
            }

            if (!options.collection.savedSearches) {
                options.collection.savedSearches = new SavedSearchesCollection();
                applicationDfd.done(function(app, owner) {
                    options.collection.savedSearches.fetch({data: {app: app, owner: '-', search: 'is_visible=1 AND disabled=0', count: -1}}); //TODO: _with_new=1?
                });
            }

            if (!options.model.splunkDappNav) {
                options.model.splunkDappNav = new NavModel();
                applicationDfd.done(function(app, owner) {
                    options.model.splunkDappNav.fetch({data: {app: app, owner: owner}});
                });
            }

            options.collection.views.once('reset', viewsDfd.resolve);
            options.collection.savedSearches.once('reset', savedSearchesDfd.resolve);
            options.model.splunkDappNav.once('sync', appNavDfd.resolve);
            options.model.app.once('sync', appDfd.resolve);

            $.when(viewsDfd, savedSearchesDfd, appNavDfd).then(updateNavData);
        },
        _applyAppNavData: function(data, appNav, options, fromCache) {
            var app = options.model.application;
            var appLink = route.page(app.get('root'), app.get('locale') || '', app.get('app'));
            var appIcon = route.appIcon(app.get('root'), app.get('locale') || '', app.get('owner'), app.get('app'));
            var appLogo = route.appLogo(app.get('root'), app.get('locale') || '', app.get('owner'), app.get('app'));

            if (console.DEBUG_ENABLED) {
                if (this._lastApply) {
                    console.debug('Applying app nav data %o after %o ms', data, new Date().getTime() - this._lastApply);
                } else {
                    this._lastApply = new Date().getTime();
                    console.debug('Applying app nav data: %o', data);
                }
            }
            appNav.set({
                nav: data.nav,
                color: data.color,
                label: data.label,
                icon: appIcon,
                logo: appLogo,
                link: appLink,
                defaultView: data.defaultView,
                searchView: data.searchView
            });

            if (!fromCache) {
                this._cacheValue(data, options);
            }
        },
        _supportsSessionStorage: function() {
            return 'sessionStorage' in window && window.sessionStorage;
        },
        _cachePrefix: 'splunk-appnav',
        _cacheKey: function(app) {
            return [this._cachePrefix, app.get('app'), app.get('owner'), app.get('locale')].join(':');
        },
        _cacheValue: function(data, options) {
            if (this._supportsSessionStorage()) {
                data = _(data).pick('nav', 'color', 'label', 'defaultView', 'searchView');
                console.debug('Caching app nav data: %o', data);
                try {
                    window.sessionStorage.setItem(this._cacheKey(options.model.application), JSON.stringify(data));
                } catch (e) {
                    console.warn('Update to store app nav data in sessionStorage: ', e);
                }
            }
        },
        _createFromCache: function(options) {
            if (this._supportsSessionStorage()) {
                try {
                    var cacheKey = this._cacheKey(options.model.application);
                    var cachedData = JSON.parse(window.sessionStorage.getItem(cacheKey));
                    if (cachedData) {
                        console.debug('Applying cached app nav data: %o', cachedData);
                        var appNav = new Backbone.Model();
                        this._applyAppNavData(cachedData, appNav, options, true);
                        options.model.appNav = appNav;
                        _.delay(_.bind(this._loadDefault, this, options), 1000);
                        return;
                    }
                } catch (e) {
                    console.warn('Unable load cached app nav data: ', e);
                }
            }
            this._createDefault(options);
        },
        _loadDefault: function(options){
            if (options.appServerUrl) {
                this.createWithAppNavUrl(options);
            } else {
                this.createWithBackbone(options);
            }
        },
        _createDefault: function(options) {
            if (options.model.appNav) {
                this.createWithAppNavModel(options);
            } else {
                options.model.appNav = new Backbone.Model();
                this._loadDefault(options);
            }
        },
        create: function(options) {
            options = options || {};
            options.collection = options.collection || {};
            options.model = options.model || {};
            if (options.useSessionStorageCache === true) {
                this._createFromCache(options);
            } else {
                this._createDefault(options);
            }
            return new View(options);
        }
    });
    return View;
});

define('contrib/text!views/shared/litebar/Master.html',[],function () { return '<i class="pull-right icon icon-menu"></i>\n<a href="#" class="help"></a>\n<a href="#" class="messages"></a>\n<span class="brand" title="splunk &gt; <%- _(\'listen to your data\').t() %>"><a href="<%- homeLink %>">splunk<strong>&gt;</strong> <span class="sub-brand">&#xF003;</span></a></span>\n<div class="nav"></div>';});

define('contrib/text!views/shared/splunkbar/messages/MasterLite.html',[],function () { return '<a href="#" class="dropdown-toggle">\n    <i class="icon icon-mail"></i> \n    <span class="message_count_wrapper">\n        (<span class="label-warning"><%- collection.length %></span>)\n    </span>\n</a>\n<div class="dropdown-menu" id="global-messages-menu">\n    <div class="arrow"></div>\n    <ul class="message-list" style="display: none;">\n    </ul>\n    <div class="no-messages">\n        <%- _("You have no messages.").t() %>\n    </div>\n    <div class="popdown-dialog-footer" style="display: none;">\n        <a href="#" class="delete-all-messages btn pull-right"><%- _("Delete All").t() %></a>\n    </div>\n</div>\n';});

define('views/shared/splunkbar/messages/LiteMessages',
[
    'views/shared/splunkbar/messages/Master',
    'contrib/text!views/shared/splunkbar/messages/MasterLite.html'
],
function(
    Messages,
    LiteTemplate
){
    return Messages.extend({
        template: LiteTemplate,
        tagName: 'span',
        className: 'pull-right nav-icon'
    });
});

define('contrib/text!views/shared/litebar/SystemSection.html',[],function () { return '<div class="collapsible-heading">\n  <a class="collapsible-toggle" href="#">\n    <i class="icon-collapsible-toggle icon-chevron-right"></i>\n    <%- groupTitle %>\n  </a>\n</div>\n<div class="collapsible-body" style="display: none">\n    <% var addedItems = []; %>\n    <% _.each(this.model.get(\'items\'), function(item, i){ %>\n        <% if(_.indexOf(addedItems, item.entry.content.get(\'menu.label\')) === -1) { %>    \n            <a href="<%-item.get(\'url\')%>" id="<%- item.entry.get("name") %>"><%- _(item.entry.content.get(\'menu.label\')).t() || _(item.entry.get(\'name\')).t() || \'\' %></a>\n            <% addedItems.push(item.entry.content.get(\'menu.label\')); %>\n        <% } %>\n    <% }); %>\n</div>\n';});

define('views/shared/litebar/SystemSection',[
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/shared/litebar/SystemSection.html'
],
function(
    $,
    _,
    module,
    BaseView,
    systemMenuSectionTemplate
){
    return BaseView.extend({
        moduleId: module.id,
        template: systemMenuSectionTemplate,
        className: 'collapsible-group',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            var itemsArray = this.model.get('items');
            itemsArray.sort(function(a,b){
                return parseInt(a.get('order'), 10) - parseInt(b.get('order'), 10);
            });
        },
        render: function() {
            var html = this.compiledTemplate({
                model: this.model,
                groupTitle: this.model.get('label')
            });
            this.$el.html(html);
            this.$el.attr('id', this.model.get('label').toLowerCase().replace(/ /g,''));
            return this;
        }
    });
});
define('contrib/text!views/shared/litebar/Activity.html',[],function () { return '<div class="collapsible-heading">\n  <a class="collapsible-toggle" href="#">\n    <i class="icon-collapsible-toggle icon-chevron-right"></i>\n    <%- _("Activity").t() %>\n  </a>\n</div>\n<div class="collapsible-body" style="display: none">\n    <a href="<%= jobLink %>"><%- _("Jobs").t() %></a>\n    <% if (typeof alertsLink !== "undefined" && alertsLink !== null) { %>\n    \t<a href="<%= alertsLink %>"><%- _("Triggered Alerts").t() %></a>\n    <% } %>\n    <% if (typeof statusLink !== "undefined" && statusLink !== null) { %>\n        <a href="<%= statusLink %>"><%- _("System Activity").t() %></a>\n    <% } %>\n</div>\n';});

define('views/shared/litebar/Activity',
[
    'module',
    'views/shared/splunkbar/ActivityMenu',
    'contrib/text!views/shared/litebar/Activity.html'
],
function(
    module,
    ActivityMenu,
    activityMenuTemplate
){
    return ActivityMenu.extend({
        moduleId: module.id,
        template: activityMenuTemplate,
        tagName: 'div',
        className: 'collapsible-group activity',
        id: 'activity'
    });
});

define('contrib/text!views/shared/litebar/HelpMenu.html',[],function () { return '<div class="collapsible-heading">\n  <a class="collapsible-toggle" href="#">\n    <i class="icon-collapsible-toggle icon-chevron-right"></i>\n    <%- _("Help").t() %>\n  </a>\n</div>\n<div class="collapsible-body" style="display: none">\n    <a class="external" href="http://splunk-base.splunk.com/" target="_blank"><%- _("Splunk Answers").t() %></a>\n    <a class="external" href="http://www.splunk.com/support" target="_blank"><%- _("Contact Support").t() %></a>\n    <a class="external" href="<%- docLink %>" target="_blank"><%- _("Documentation").t() %></a>\n    <a class="splunk-tour" href="#"><%- _("Product Tour").t() %></a>\n    <a class="about-splunk" href="#"><%- _("About").t() %></a>\n</div>\n';});

define('views/shared/litebar/HelpMenu',
[
    'views/shared/splunkbar/HelpMenu',
    'contrib/text!views/shared/litebar/HelpMenu.html'
],
function(
   HelpMenu,
   helpMenuTemplate
){
    return HelpMenu.extend({
        template: helpMenuTemplate,
        tagName: 'div',
        className: 'collapsible-group helpmenu',
        id: 'helpmenu'
    });
});

define('contrib/text!views/shared/onboarding/Master.html',[],function () { return '<a class="close-tour"><img src="<%- imgUrl %>/close.png" /></a>\n\n<% if (welcomeSlide) { %>\n  <div class="welcome-slide">\n    <img src="<%- imgUrlLocalized %>/tour0.png" />\n    <div class="tour-btn start-tour">Yes, start tour now</div>\n    <div class="tour-btn exit-tour">Exit tour</div>\n  </div>\n<% } %>\n\n<div id="onboardingCarousel" class="carousel slide">\n  <ol class="carousel-indicators">\n    <% for (var i = 0; i < panels; i++) { %>\n      <li data-target="#onboardingCarousel" data-slide-to="<%- i %>" <%- (i === 0) ? \'class=active\' : \'\' %>></li>\n    <% } %>\n  </ol>\n\n  <div class="carousel-inner">\n    <% for (var i = 1; i < panels + 1; i++) { %>\n      <div class="item <%- (i === 1) ? "active" : "" %>"><img src="<%- imgUrlLocalized %>/tour<%- i %>.png" />\n        <% if (i === panels) { %>\n          <div class="last-slide">\n            <a id="documentation" class="help-link" href="<%- docLink %>" target="_blank"></a>\n            <a id="splunk-answers" class="help-link" href="<%- answersLink %>" target="_blank"></a>\n            <div class="tour-btn exit-tour">Exit Tour</div>\n          </div>\n        <% } %>\n      </div>\n    <% } %>\n  </div>\n  \n  <a class="carousel-control left" href="#onboardingCarousel" data-slide="prev" style="display:none"><img src="<%- imgUrl %>/arrow_left.png" /></a>\n  <a class="carousel-control right" href="#onboardingCarousel" data-slide="next"><img src="<%- imgUrl %>/arrow_right.png" /></a>\n</div>';});

/* ==========================================================
 * bootstrap-carousel.js v2.3.1
 * http://twitter.github.com/bootstrap/javascript.html#carousel
 * ==========================================================
 * Copyright 2012 Twitter, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ========================================================== */


!function ($) {

   // jshint ;_;


 /* CAROUSEL CLASS DEFINITION
  * ========================= */

  var Carousel = function (element, options) {
    this.$element = $(element)
    this.$indicators = this.$element.find('.carousel-indicators')
    this.options = options
    this.options.pause == 'hover' && this.$element
      .on('mouseenter', $.proxy(this.pause, this))
      .on('mouseleave', $.proxy(this.cycle, this))
  }

  Carousel.prototype = {

    cycle: function (e) {
      if (!e) this.paused = false
      if (this.interval) clearInterval(this.interval);
      this.options.interval
        && !this.paused
        && (this.interval = setInterval($.proxy(this.next, this), this.options.interval))
      return this
    }

  , getActiveIndex: function () {
      this.$active = this.$element.find('.item.active')
      this.$items = this.$active.parent().children()
      return this.$items.index(this.$active)
    }

  , to: function (pos) {
      var activeIndex = this.getActiveIndex()
        , that = this

      if (pos > (this.$items.length - 1) || pos < 0) return

      if (this.sliding) {
        return this.$element.one('slid', function () {
          that.to(pos)
        })
      }

      if (activeIndex == pos) {
        return this.pause().cycle()
      }

      return this.slide(pos > activeIndex ? 'next' : 'prev', $(this.$items[pos]))
    }

  , pause: function (e) {
      if (!e) this.paused = true
      if (this.$element.find('.next, .prev').length && $.support.transition.end) {
        this.$element.trigger($.support.transition.end)
        this.cycle(true)
      }
      clearInterval(this.interval)
      this.interval = null
      return this
    }

  , next: function () {
      if (this.sliding) return
      return this.slide('next')
    }

  , prev: function () {
      if (this.sliding) return
      return this.slide('prev')
    }

  , slide: function (type, next) {
      var $active = this.$element.find('.item.active')
        , $next = next || $active[type]()
        , isCycling = this.interval
        , direction = type == 'next' ? 'left' : 'right'
        , fallback  = type == 'next' ? 'first' : 'last'
        , that = this
        , e

      this.sliding = true

      isCycling && this.pause()

      $next = $next.length ? $next : this.$element.find('.item')[fallback]()

      e = $.Event('slide', {
        relatedTarget: $next[0]
      , direction: direction
      })

      if ($next.hasClass('active')) return

      if (this.$indicators.length) {
        this.$indicators.find('.active').removeClass('active')
        this.$element.one('slid', function () {
          var $nextIndicator = $(that.$indicators.children()[that.getActiveIndex()])
          $nextIndicator && $nextIndicator.addClass('active')
        })
      }

      if ($.support.transition && this.$element.hasClass('slide')) {
        this.$element.trigger(e)
        if (e.isDefaultPrevented()) return
        $next.addClass(type)
        $next[0].offsetWidth // force reflow
        $active.addClass(direction)
        $next.addClass(direction)
        this.$element.one($.support.transition.end, function () {
          $next.removeClass([type, direction].join(' ')).addClass('active')
          $active.removeClass(['active', direction].join(' '))
          that.sliding = false
          setTimeout(function () { that.$element.trigger('slid') }, 0)
        })
      } else {
        this.$element.trigger(e)
        if (e.isDefaultPrevented()) return
        $active.removeClass('active')
        $next.addClass('active')
        this.sliding = false
        this.$element.trigger('slid')
      }

      isCycling && this.cycle()

      return this
    }

  }


 /* CAROUSEL PLUGIN DEFINITION
  * ========================== */

  var old = $.fn.carousel

  $.fn.carousel = function (option) {
    return this.each(function () {
      var $this = $(this)
        , data = $this.data('carousel')
        , options = $.extend({}, $.fn.carousel.defaults, typeof option == 'object' && option)
        , action = typeof option == 'string' ? option : options.slide
      if (!data) $this.data('carousel', (data = new Carousel(this, options)))
      if (typeof option == 'number') data.to(option)
      else if (action) data[action]()
      else if (options.interval) data.pause().cycle()
    })
  }

  $.fn.carousel.defaults = {
    interval: 5000
  , pause: 'hover'
  }

  $.fn.carousel.Constructor = Carousel


 /* CAROUSEL NO CONFLICT
  * ==================== */

  $.fn.carousel.noConflict = function () {
    $.fn.carousel = old
    return this
  }

 /* CAROUSEL DATA-API
  * ================= */

  $(document).on('click.carousel.data-api', '[data-slide], [data-slide-to]', function (e) {
    var $this = $(this), href
      , $target = $($this.attr('data-target') || (href = $this.attr('href')) && href.replace(/.*(?=#[^\s]+$)/, '')) //strip for ie7
      , options = $.extend({}, $target.data(), $this.data())
      , slideIndex

    $target.carousel(options)

    if (slideIndex = $this.attr('data-slide-to')) {
      $target.data('carousel').pause().to(slideIndex).cycle()
    }

    e.preventDefault()
  })

}(window.jQuery);
define("bootstrap.carousel", ["jquery"], function(){});

define('views/shared/onboarding/Master',
    [
        'jquery',
        'underscore',
        'backbone',
        'module',
        'views/shared/Modal',
        'contrib/text!views/shared/onboarding/Master.html',
        'splunk.util',
        'uri/route',
        'bootstrap.carousel'
    ],
    function(
        $, 
        _, 
        backbone, 
        module, 
        Modal,
        TourTemplate,
        splunkUtil,
        route,
        undefined
    ){
        return Modal.extend({
            moduleId: module.id,
            className: Modal.prototype.className + ' super-modal onboarding',
            template: TourTemplate,
            initialize: function() {
                Modal.prototype.initialize.apply(this, arguments);

                this.imgCheck = $.Deferred();
                this.root = this.model.application.get('root');
                this.locale = this.model.application.get('locale');
                this.imgUrl = splunkUtil.make_url('/static/img/skins/default/onboarding');
                this.imgUrlLocalized = this.imgUrl + '/' + this.locale;
                this.testImg = this.imgUrlLocalized + '/tour0.png';
                this.panels = 7;
                this.welcomeSlide = this.options.welcomeSlide || false;

                // Check for localized version of Onboarding experience.
                // Defaults to en-US if not.
                $('<img src="' + this.testImg + '" />')
                .load(function() {
                    this.imgCheck.resolve();
                }.bind(this))
                .error(function() {
                    this.imgUrlLocalized = this.imgUrl + '/en-US';
                    this.imgCheck.resolve();
                }.bind(this));
            },

            events: {
                'click .close-tour': function(e) {
                    this.hide();
                },
                'click .exit-tour': function(e) {
                    this.hide();
                },
                'click .start-tour': function(e) {
                    $('.welcome-slide').hide();
                },
                'mouseout .carousel': function(e) {
                    $('carousel').carousel('pause');
                }
            },

            hide: function() {
                this.$el.modal('hide');
                this.closeTour();
            },

            setFirstTimePref: function() {
                if (this.model.userPrefs) {
                    this.model.userPrefs.entry.content.set('first.time.lite', 1);
                    this.model.userPrefs.save();
                }
            },

            closeTour: function() {
                this.setFirstTimePref();
                this.remove();
                $('.super-backdrop').fadeOut();
            },

            render: function() {
                var docLink = route.docHelp(this.root, this.locale, 'splunkcore.homepage.docs'),
                    salesLink = 'http://www.splunk.com/view/contact-us/SP-CAAAAH7',
                    supportLink = 'http://www.splunk.com/r/support',
                    educationLink = 'http://www.splunk.com/view/education/SP-CAAAAH9',
                    answersLink = 'http://answers.splunk.com/';

                // The 'splunk-components' wrapper is necessary  
                // for modal to render correctly in manager.
                $('body').append('<div class="splunk-components"><div class="super-backdrop modal-backdrop in"></div></div>');
                
                $.when(this.imgCheck).then(function() {
                    this.$el.html(this.compiledTemplate({
                        _: _,
                        panels: this.panels,
                        imgUrl: this.imgUrl,
                        imgUrlLocalized: this.imgUrlLocalized,
                        docLink: docLink,
                        salesLink: salesLink,
                        supportLink: supportLink,
                        educationLink: educationLink,
                        answersLink: answersLink,
                        welcomeSlide: this.welcomeSlide
                    }));

                    this.$('.carousel').carousel({
                        interval: false,
                        pause: true
                    }).on('slid', '', function() {
                        $('.carousel-control').show();
                        if($('.item:first').hasClass('active')) {
                            $('.left.carousel-control').hide();
                        } else if ($('.item:last').hasClass('active')) {
                            $('.right.carousel-control').hide();
                        }
                    });
                }.bind(this));
            }
        });
    }
);

define('models/services/data/ui/Pref',
    [
        'jquery',
        'models/SplunkDBase',
        'util/splunkd_utils'
    ],
    function(
        $,
        BaseModel,
        splunkd_utils
    ) {
        var Pref = BaseModel.extend({
            url: 'data/ui/prefs',
            initialize: function() {
                BaseModel.prototype.initialize.apply(this, arguments);
            },
            bootstrap: function(uiPrefsDeferred, page, app, owner) {
                var uiPrefsUrl = splunkd_utils.fullpath(
                        this.url + "/" + encodeURIComponent(page),
                        {
                            app: app,
                            owner: owner
                        }
                     ),
                     proxyUIPrefModel = new Pref();

                proxyUIPrefModel.fetch({
                    url: uiPrefsUrl,
                    success: function(model, response) {
                         if ((owner||'').toLowerCase() !== proxyUIPrefModel.entry.acl.get('owner')) {
                             //we got a shared UIPref entity so we need to make a new local entity
                             this.fetch({
                                 success: function(model, response) {
                                     var data = $.extend(true, {name: page}, proxyUIPrefModel.entry.content.toJSON());
                                     this.entry.content.set(data);
                                     uiPrefsDeferred.resolve();
                                 }.bind(this),
                                 error: function(model, response) {
                                     uiPrefsDeferred.resolve();
                                 }.bind(this)
                             });
                         } else {
                             this.setFromSplunkD(proxyUIPrefModel.toSplunkD());
                             uiPrefsDeferred.resolve();
                         }
                     }.bind(this),
                     error: function(model, response) {
                         this.fetch({
                             success: function(model, response) {
                                 this.entry.content.set({
                                     name: page
                                 });
                                 uiPrefsDeferred.resolve();
                             }.bind(this),
                             error: function(model, response) {
                                 uiPrefsDeferred.resolve();
                             }.bind(this)
                         });
                     }.bind(this)
                });
            }
        });
        
        return Pref;
    }
);
define('contrib/text!views/shared/litebar/SideNav.html',[],function () { return '<div class="sidenav-head">\n    <%- user %>\n</div>\n\n<div class="sidenav-user">\n    <span class="user-name"></span>\n    <div>\n        <a href="<%- accountLink %>"><%- _(\'Edit account\').t() %></a>\n        <a href="<%- logoutLink %>" class="pull-right"><%- _(\'Logout\').t() %></a>\n    </div>\n</div>\n\n<div class="sidenav-body">\n</div>';});

// splunk bar
define('views/shared/litebar/SideNav',[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'views/Base',
    'views/shared/litebar/SystemSection',
    'views/shared/litebar/Activity',
    'views/shared/litebar/HelpMenu',
    'views/shared/litebar/RestartDialog',
    'views/shared/onboarding/Master',
    'models/services/data/UserPref',
    'models/services/AppLocal',
    'models/services/authentication/User',
    'models/services/data/ui/Pref',
    'models/shared/Application',
    'collections/services/data/ui/Managers',
    'collections/shared/splunkbar/SystemMenuSections',
    'contrib/text!views/shared/litebar/SideNav.html',
    'views/shared/delegates/Accordion',
    'uri/route',
    'splunk.util',
    'splunk.messenger',
    'splunk.logger',
    'util/splunkd_utils'
],
function(
    $,
     _,
     Backbone,
     module,
     BaseView,
     SystemSection,
     ActivityMenu,
     HelpMenu,
     RestartDialog,
     OnboardingModal,
     UserPrefModel,
     AppLocalModel,
     UserModel,
     uiPref,
     ApplicationModel,
     ManagersCollection,
     SystemMenuSectionsCollection,
     sideTemplate,
     Accordion,
     route,
     splunkUtil,
     splunkMessenger,
     splunkLogger,
     splunkDUtils
){
    var View = BaseView.extend({
        moduleId: module.id,
        template: sideTemplate,
        className: 'sidenav',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            
            this.children.accordion = new Accordion({
                el: this.el,
                group: ".collapsible-group",
                toggle: ".collapsible-toggle",
                body: ".collapsible-body",
                icon: ".icon-collapsible-toggle",
                inactiveIconClass: "icon-chevron-right",
                activeIconClass: "icon-chevron-down",
                collapsible: true
            });
            this.children.activityMenu = new ActivityMenu({
                model: {
                    user: this.model.user,
                    application: this.model.application
                }
            });
            this.children.helpMenu = new HelpMenu({
                model: this.model,
                collection: {
                    apps: this.collection.apps
                }
            });

            this.collection.sections.on('ready', function() {
                this.debouncedRender();
            }, this);

            this.model.userPref.entry.content.on('ready', function() {
                this.debouncedRender();
            }, this);

            this.children.accordion.on('toggled', function() {
                this.setPrefs();
            }, this);

            //listen for restart events
            $(document).on('restart_failed', function() {
                this.hideRestartModal();
            }.bind(this));
        },
        events: {
            'click #control' : function(e) {    
                e.preventDefault();
                if (confirm(_("Are you sure you want to restart Splunk?").t())) {
                    this.showRestartModal();
                    splunkUtil.restart_server();
                }
            },
            'click .splunk-tour' : function(e) {    
                e.preventDefault();
                this.children.onboardingModal = new OnboardingModal({
                    model: {
                        application: this.model.application                        
                    },
                    backdrop: false,
                    keyboard: false
                });
                
                // Necessary for modal to render correctly in manager.
                $('body').append('<div class="splunk-components onboarding-modal"></div>');
                $('.onboarding-modal').append(this.children.onboardingModal.render().el);
                this.children.onboardingModal.show();
            }
        },
        showRestartModal: function() {
                this.children.restartDialog = new RestartDialog({backdrop: 'static'});
                // Necessary for modal to render correctly in manager.
                $("body").append('<div class="splunk-components restartModal"></div>');
                $(".restartModal").append(this.children.restartDialog.render().el);
                this.children.restartDialog.show();
        },
        hideRestartModal: function() {
            if (this.children.restartDialog) {
                this.children.restartDialog.hide();
            }
        },
        _setInitials: function() {
            var name = this.model.user.entry.content.get("realname") || this.model.user.entry.get("name") || "",
                names = name.split(/\s/),
                first = (names.length > 0) ? names[0].charAt(0) : "",
                last = (names.length > 1) ? names[names.length - 1].charAt(0) : "";
            
            this.$('.user-name').html(first + last);
        },
        setPrefs: function(e) {
            var activeNavs = '|',
                elements = this.$('.collapsible-group');
            for (var i = 0; i < elements.length; i++) {
                if ($(elements[i]).hasClass('active')) {
                    activeNavs = activeNavs.concat($(elements[i]).attr('id')).concat('|');
                }
            }
            this.model.userPref.entry.content.set({
                'display.prefs.activeSideNav': activeNavs
            });
            this.model.userPref.save({});
        },
        render: function() {
            var rootUrl = this.model.application.get('root'),
                locale = this.model.application.get('locale'),
                userName = this.model.user.entry.get('name'),
                logoutLink = this.SSOModeOn ? null : route.logout(rootUrl, locale),
                accountLink = route.manager(
                    rootUrl,
                    locale,
                    this.model.application.get('app'),
                    [
                        'authentication',
                        'users'
                    ]
                ),
                that = this;
            
            var html = this.compiledTemplate({
                makeUrl: splunkUtil.make_url,
                options: this.options,
                user: this.model.user.entry.content.get('realname'),
                logoutLink: logoutLink,
                accountLink : accountLink,
                splunkUtil: splunkUtil
            });

            this.$el.html(html);
            
            this._setInitials();

            this.collection.sections.each(function(section){
                if (section.get('items') && section.get('items').length === 0) {
                    return;
                }
                var sectionView = new SystemSection({
                    model: section
                });
                
                that.$('.sidenav-body').append(sectionView.render().el);
            });

            this.$('.sidenav-body').prepend(this.children.activityMenu.render().el);
            this.$('.sidenav-body').append(this.children.helpMenu.render().el);

            var activeSideNavs = this.model.userPref.entry.content.get('display.prefs.activeSideNav') || [];
            _.each(this.$('.collapsible-group'), function(node) {
                if (activeSideNavs.indexOf(node.id) > -1) {
                    this.children.accordion.initialToggleOn($(node));
                }
            }.bind(this));

            return this;
        }
    },
    {
        create: function(options){
            options = options || {};
            options.collection = options.collection || {};
            options.model = options.model || {};

            //the APPLICATION model is REQUIRED argument from the consumer. If its not passed, make up an empty one, to keep things rendering, and assure continuance
            //TODO should log this
            var applicationDfd = $.Deferred();
            if (!options.model.application){
                options.model.application = new ApplicationModel();
            }
            // handle both when the application model is already filled and when it has yet to complete fetching
            if (options.model.application.get('app')) {
                applicationDfd.resolve();
            } else {
                options.model.application.on('change', applicationDfd.resolve);
            }

            var currentUserIdDfd = $.Deferred();
            currentUserIdDfd.resolve(options.model.application.get('owner'));

            if (!options.model.user) {
                options.model.user = new UserModel();
                $.when(currentUserIdDfd).done(function(currentUserId) {
                    options.model.user.set('id', encodeURIComponent(currentUserId));
                    options.model.user.fetch();
                });
            }

            var managersDfd = $.Deferred();
            if (!options.collection.managers) {
                options.collection.managers = new ManagersCollection();
                $.when(currentUserIdDfd).done(function(currentUsername) {
                    options.collection.managers.fetch({
                        data: {
                            app: '-',
                            owner: currentUsername,
                            count: 0,
                            digest: 1
                        },
                        success: function() {
                            managersDfd.resolve();
                        }
                    });
                });
            } else {
                managersDfd.resolve();
            }

            var sections = options.collection.sections = new SystemMenuSectionsCollection();

            sections.add({
                id: 'knowledge_configurations',
                label: _('Knowledge').t(),
                icon: 'bookmark',
                order: 2
            });

            if (options.model.user.hasRole("admin")) {
                sections.add({
                    id: 'data_configurations',
                    label: _('Data').t(),
                    icon: 'data',
                    order: 1
                });
                sections.add({
                    id: 'system_configurations',
                    label: _('System').t(),
                    icon: 'settings',
                    order: 3
                });
            }

            $.when(managersDfd).done(function() {
                options.collection.managers.each(function(manager) {
                    var menuUrl = manager.entry.content.get('menu.url') || '',
                        sectionName = manager.entry.content.get('menu.name'),
                        disabledByLicense = splunkUtil.normalizeBoolean(manager.entry.content.get('disabled_by_license') || false),
                        order = manager.entry.content.get('menu.order') || 1000,
                        pageStart = route.encodeRoot(options.model.application.get('root'), options.model.application.get('locale')),
                        url = pageStart + splunkUtil.sprintf(menuUrl, {namespace: options.model.application.get('app') || 'NOTHING'});

                    if (!disabledByLicense && sectionName) {
                        var section = sections.get(sectionName);
                        if (section) {
                            var sectionItems = section.get('items');
                            if (sectionItems) {
                                sectionItems.push(manager);
                            }
                        }
                    }
                    manager.set({
                        url: url,
                        order: order
                    });
                });
                sections.trigger('ready');
            });

            return new View(options);
        }
    });
    return View;
});

define('views/shared/litebar/Master',[
    'jquery',
    'underscore',
    'backbone',
    'module',
    'views/Base',
    'views/shared/appbar/AppNav',
    'views/shared/appbar/AppLabel',
    'models/services/data/ui/Nav',
    'models/services/AppLocal',
    'collections/services/AppLocals',
    'collections/services/data/ui/Views',
    'collections/services/saved/Searches',
    'contrib/text!views/shared/litebar/Master.html',
    'helpers/AppNav',
    'helpers/Session',
    'views/shared/splunkbar/messages/LiteMessages',
    'views/shared/splunkbar/messages/NoConnectionOverlay',
    'collections/services/authentication/CurrentContexts',
    'collections/services/Messages',
    'views/shared/litebar/SideNav',
    'models/services/data/UserPref',
    'util/splunkd_utils',
    'uri/route',
    'util/color_utils',
    'util/console',
    'util/csrf_protection',
    'util/ajax_no_cache'
],
function(
    $,
    _,
    Backbone,
    module,
    BaseView,
    AppNavView,
    AppLabelView,
    NavModel,
    AppModel,
    AppsCollection,
    ViewsCollection,
    SavedSearchesCollection,
    templateMaster,
    appNavParser,
    Session,
    MessagesView,
    NoConnectionOverlay,
    CurrentContexts,
    MessagesCollection,
    SideNav,
    UserPref,
    splunkDUtils,
    route,
    color_utils,
    console
) {
    var View = BaseView.extend({
        moduleId: module.id,
        className: 'lite-bar',
        template: templateMaster,
        initialize: function(options) {
            BaseView.prototype.initialize.apply(this, arguments);

            this.children.sideNav = new SideNav.create({
                model: {
                    user: this.model.user,
                    serverInfo: this.model.serverInfo,
                    appNav: this.model.appNav,
                    application: this.model.application,
                    userPref: this.options.model.userPref,
                    appLocal: this.model.appLocal
                },
                collection: this.collection
            });

            this.children.appNav = new AppNavView({
                model: {
                    user: this.model.user,
                    serverInfo: this.model.serverInfo,
                    appNav: this.model.appNav,
                    application: this.model.application
                },
                collection: this.collection
            });

            this.children.appLabel = new AppLabelView({
                model: this.model,
                collection: this.collection
            });

            if(options.autoRender !== false) {
                this.debouncedRender();
            }
            this.collection.sections.on('ready', function() {
                this.debouncedRender();
            }, this);

            this.MAX_RETRIES_BEFORE_FAIL = 3;
            this.MESSAGES_POLLING_DELAY_STANDARD = 60000;
            this.MESSAGES_POLLING_DELAY_HI_FREQ = 1000;

            options.collection.messages = new MessagesCollection();
            options.collection.messages.fetchData.set({
                "sort_key" : "timeCreated_epochSecs",
                "sort_dir" : "desc"
            });

            Session.on('restart timeout', function() {
                this.collection.messages.stopPolling();
            }, this);
            Session.on('start', function() {
                this.collection.messages.startPolling();
            }, this);
        },
        events: {
            'click .icon-menu': function(e) {
                this.moveNav();
                $('.sidenav-screen').fadeIn(500);
            },
            'click .sidenav-screen': function(e) {
                this.moveNav();
                $('.sidenav-screen').fadeOut(500);
            },
            'click .icon-menu.active': function(e) {
                $('.sidenav-screen').fadeOut(500);
            }
        },
        moveNav: function() {
            $('.sidenav').toggleClass('open');
            $('body').toggleClass('open');
            $('.lite-bar .icon-menu').toggleClass('active');
        },
        render: function() {
            var app = this.model.application,
                html = this.compiledTemplate({
                    homeLink: route.page('', app.get('locale'), 'search')
                });

            this.$el.html(html);
            this.$el.find('.nav').html(this.children.appNav.render().el);
            this.liteMessages();
            this.$el.before(this.children.sideNav.el);
            this.$el.prepend('<div class="sidenav-screen"></div>');

            return this;
        },
        liteMessages: function() {
            this.children.messages = new MessagesView({
                collection: {
                    messages: this.collection.messages,
                    legacyMessages: this.collection.legacyMessages
                },

                model: {
                    serverInfo: this.model.serverInfo
                }
            });

            this.children.noConnectionOverlay = new NoConnectionOverlay();
            $('body').append(this.children.noConnectionOverlay.render().el);

            this.collection.messages.on('serverValidated', function(success, context, messages) {
                if (success && this.cntRetries > 0) {
                    this.restartMessagePolling(this.MESSAGES_POLLING_DELAY_STANDARD);
                    this.children.noConnectionOverlay.hide();
                    this.cntRetries = 0;
                    return;
                }
                var netErrorMsg = _.find(messages, function(msg) {
                    return msg.type == splunkDUtils.NETWORK_ERROR || 'network_error';
                });
                if (netErrorMsg) {
                    if (this.cntRetries == 0) {
                        this.restartMessagePolling(this.MESSAGES_POLLING_DELAY_HI_FREQ);
                    }
                    if (this.cntRetries >= this.MAX_RETRIES_BEFORE_FAIL) {
                        this.children.noConnectionOverlay.show();
                    }
                    this.cntRetries += 1;
                }
            }, this);
            this.$('.messages').replaceWith(this.children.messages.render().el);
            this.restartMessagePolling(this.MESSAGES_POLLING_DELAY_STANDARD);
        },
        restartMessagePolling: function(interval) {
            this.collection.messages.stopPolling();
            this.collection.messages.startPolling({delay: interval, uiInactivity: true, stopOnError: false, data: {count: 1000}});
        }
    },
    {
        createWithAppNavUrl: function(options) {
            var self = this;
            var app = 'search';
            var owner = options.model.application.get('owner');
            var applicationDfd = new $.Deferred();

            if (app && owner) {
                applicationDfd.resolve(app, owner);
            } else {
                options.model.application.once('change', function() {
                    var app = 'search';
                    var owner = options.model.application.get('owner');
                    if (app && owner) {
                        applicationDfd.resolve(app, owner);
                    }
                });
            }

            applicationDfd.done(function() {
                var url = route.appNavUrl(options.model.application.get('root'), options.model.application.get('locale'), 'search');
                $.ajax({
                    url: url,
                    dataType:'json'
                }).done(function(data) {
                        self._applyAppNavData(data, options.model.appNav, options, false);
                    }).fail(function() {
                        self.createWithBackbone(options);
                    });
            });
        },
        createWithAppNavModel: function(options) {
            var appNav = options.model.appNav;
            this._applyAppNavData(appNav.entry.content.toJSON(), appNav, options, false);
        },
        createWithBackbone: function(options) {
            var self = this;
            var applicationDfd = $.Deferred();
            var appNavDfd = $.Deferred();
            var viewsDfd = $.Deferred();
            var savedSearchesDfd = $.Deferred();
            function updateNavData() {
                var data = appNavParser.parseNavModel(
                    options.model.splunkDappNav,
                    options.collection.views,
                    options.collection.savedSearches,
                    options.model.application.get('root')
                );
                var appLabel;
                if (data.appLabel) {
                    appLabel = data.appLabel;
                } else if (options.model.app && options.model.app.entry && options.model.app.entry.content && options.model.app.entry.content.get('label')) {
                    appLabel = options.model.app.entry.content.get('label') || '';
                }
                self._applyAppNavData({
                    nav: data.nav,
                    color: data.color,
                    label: appLabel,
                    defaultView: data.defaultView,
                    searchView: data.searchView
                }, options.model.appNav, options, false);
            }

            var app = 'search';
            var owner = options.model.application.get('owner');
            if (app && owner) {
                applicationDfd.resolve(app, owner);
            } else {
                options.model.application.once('change', function() {
                    var app = options.model.application.get('app');
                    var owner = options.model.application.get('owner');
                    if (app && owner) {
                        applicationDfd.resolve(app, owner);
                    }
                });
            }

            if (!options.model.app) {
                options.model.app = new AppModel();
                applicationDfd.done(function(app, owner) {
                    options.model.app.set({id: 'apps/local/' + app});
                    options.model.app.fetch({data: {app: app, owner: owner}});
                });
            }

            if (!options.collection.views) {
                options.collection.views = new ViewsCollection();
                applicationDfd.done(function(app, owner) {
                    options.collection.views.fetch({data: {app: app, owner: owner, count: -1, digest: 1}});
                });
            }

            if (!options.collection.savedSearches) {
                options.collection.savedSearches = new SavedSearchesCollection();
                applicationDfd.done(function(app, owner) {
                    options.collection.savedSearches.fetch({data: {app: app, owner: '-', search: 'is_visible=1 AND disabled=0', count: -1}}); //TODO: _with_new=1?
                });
            }

            if (!options.model.splunkDappNav) {
                options.model.splunkDappNav = new NavModel();
                applicationDfd.done(function(app, owner) {
                    options.model.splunkDappNav.fetch({data: {app: app, owner: owner}});
                });
            }

            options.collection.views.once('reset', viewsDfd.resolve);
            options.collection.savedSearches.once('reset', savedSearchesDfd.resolve);
            options.model.splunkDappNav.once('sync', appNavDfd.resolve);

            $.when(viewsDfd, savedSearchesDfd, appNavDfd).then(updateNavData);
        },
        _applyAppNavData: function(data, appNav, options, fromCache) {
            var app = options.model.application;
            var appLink = route.page(app.get('root'), app.get('locale') || '', 'search');
            var appLogo = route.appLogo(app.get('root'), app.get('locale') || '', app.get('owner'), 'search');

            if (console.DEBUG_ENABLED) {
                if (this._lastApply) {
                    console.debug('Applying app nav data %o after %o ms', data, new Date().getTime() - this._lastApply);
                } else {
                    this._lastApply = new Date().getTime();
                    console.debug('Applying app nav data: %o', data);
                }
            }
            appNav.set({
                nav: data.nav,
                color: data.color,
                label: data.label,
                logo: appLogo,
                link: appLink,
                defaultView: data.defaultView,
                searchView: data.searchView
            });

            if (!fromCache) {
                this._cacheValue(data, options);
            }
        },
        _supportsSessionStorage: function() {
            return 'sessionStorage' in window && window.sessionStorage;
        },
        _cachePrefix: 'splunk-appnav',
        _cacheKey: function(app) {
            return [this._cachePrefix, app.get('app'), app.get('owner'), app.get('locale')].join(':');
        },
        _cacheValue: function(data, options) {
            if (this._supportsSessionStorage()) {
                data = _(data).pick('nav', 'color', 'label', 'defaultView', 'searchView');
                console.debug('Caching app nav data: %o', data);
                try {
                    window.sessionStorage.setItem(this._cacheKey(options.model.application), JSON.stringify(data));
                } catch (e) {
                    console.warn('Update to store app nav data in sessionStorage: ', e);
                }
            }
        },
        _createFromCache: function(options) {
            if (this._supportsSessionStorage()) {
                try {
                    var cacheKey = this._cacheKey(options.model.application);
                    var cachedData = JSON.parse(window.sessionStorage.getItem(cacheKey));
                    if (cachedData) {
                        console.debug('Applying cached app nav data: %o', cachedData);
                        var appNav = new Backbone.Model();
                        this._applyAppNavData(cachedData, appNav, options, true);
                        options.model.appNav = appNav;
                        _.delay(_.bind(this._loadDefault, this, options), 1000);
                        return;
                    }
                } catch (e) {
                    console.warn('Unable load cached app nav data: ', e);
                }
            }
            this._createDefault(options);
        },
        _loadDefault: function(options) {
            if (options.appServerUrl) {
                this.createWithAppNavUrl(options);
            } else {
                this.createWithBackbone(options);
            }
        },
        _createDefault: function(options) {
            if (options.model.appNav) {
                this.createWithAppNavModel(options);
            } else {
                options.model.appNav = new Backbone.Model();
                this._loadDefault(options);
            }
        },
        create: function(options) {
            options = options || {};
            options.collection = options.collection || {};
            options.model = options.model || {};
            if (options.useSessionStorageCache === true) {
                this._createFromCache(options);
            } else {
                this._createDefault(options);
            }

            if (!options.model.userPref) {
                options.model.userPref = new UserPref();
                var userPrefDfd = options.model.userPref.fetch({data: {app:'user-prefs', owner: options.model.application.get('owner'), count:-1}});
                $.when(userPrefDfd).then(function() {
                    options.model.userPref.entry.content.trigger('ready');
                });
            }

            var applicationDfd = $.Deferred();
            if(!options.model.appLocal) {
                options.model.appLocal = new AppModel();
                applicationDfd.done(function() {
                    if (options.model.application.get("app") !== 'system') {
                        options.model.appLocal.fetch({
                            url: splunkDUtils.fullpath(options.model.appLocal.url + "/" + encodeURIComponent('search')),
                            data: {
                                app: 'search',
                                owner: options.model.application.get("owner")
                            }
                        });
                    }
                });
            }

            if (!options.collection.apps) {
                options.collection.apps = new AppsCollection();
                options.collection.apps.fetch({
                    data: {
                        sort_key: 'name',
                        sort_dir: 'desc',
                        app: '-' ,
                        owner: options.model.application.get('owner'),
                        search: 'visible=true AND disabled=0 AND name!=launcher',
                        count:-1
                    }
                });
            }
            
            return new View(options);
        }
    });
    return View;
});

define('contrib/text!views/shared/tourbar/TourBar.html',[],function () { return '<div class="tourbar"\n    <% if (fixedHeight) { %>\n        style="position: absolute; min-height: <%= fixedHeight %>px; max-height: <%= fixedHeight %>px; width: 100%; z-index: 15;"\n    <% } %>\n>\n    <div class="previous-container">\n        <% if (previousLink) { %>\n            <a class="previous btn" href="<%= previousLink %>"><i class="icon-chevron-left"></i></a>\n        <% } %>\n    </div>\n    <div class="close-container">\n        <button class="btn close-btn"><%= _("Exit").t() %></button>\n        \n    </div>\n    <div class="next-container">\n        <% if (nextLink) { %>\n            <a class="next btn" href="<%= nextLink %>"><i class="icon-chevron-right"></i></a>\n        <% } %>\n    </div>\n    <div class="info-container"\n        <% if (fixedHeight) { %>\n            style="min-height: <%= fixedHeight-20 %>px;"\n        <% } %>\n    >\n        <span class="info">\n            <%= _(info).t()  %>\n        </span>\n    </div>\n</div>\n';});

define('views/shared/tourbar/TourBar',
    [
        'jquery',
        'underscore',
        'module',
        'backbone',
        'splunk.util',
        'views/Base',
        'contrib/text!views/shared/tourbar/TourBar.html'
    ],
    function(
        $,
        _,
        module,
        Backbone,
        splunk_util,
        BaseView,
        template
    ) {
    
        return BaseView.extend({
            template: template,
            moduleId: module.id,
            initialize: function(options) {
                BaseView.prototype.initialize.call(this, options);
                this.fixedHeight = this.options.fixedHeight || 0;
                this.resetModel(this.options.model);
            },
            events: {
                "click .close-btn"  : "handleEndTour",
                "click .next"       : "handleNext",
                "click .previous"   : "handlePrevious"
            },
            setFixedHeight: function(height) {
                this.fixedHeight = height;
            },
            resetModel: function(model) {
                this.model = model;
                this.debouncedRender();
            },
            removeHighlight: function() {
                // if an element is currently highlighted, remove that highlight
                if (this._currentHighlightedSelector) {
                    var currentElement = $(this._currentHighlightedSelector);
                    currentElement.removeClass("highlightedElement");
                    this._currentHighlightedSelector = undefined;
                }
                this._highlightSelector = undefined;
            },
            highlightElement: function(selector) {
                if (selector) {
                    this._highlightSelector = selector;
                }
    
                if (this._highlightSelector) { 
                    var element = $(this._highlightSelector);
                    if (element) {
                        element.addClass("highlightedElement");
                        this._currentHighlightedSelector = this._highlightSelector;
                    } 

                    setTimeout(function() {
                        this.highlightElement(); 
                    }.bind(this), 250);
                }
            },
            render: function() {
                var html = undefined,
                    info = undefined,
                    nextLink = undefined,
                    previousLink = undefined;

                this.removeHighlight();

                if (this.model) {

                    info = this.model.entry.content.get("info");
                    var selector = this.model.entry.content.get("highlightSelector");
                    if (selector) {
                        this.highlightElement(selector);
                    }

                    nextLink = this.model.getNextLink();
                    previousLink = this.model.getPreviousLink();
                }
                html = this.compiledTemplate({
                    previousLink: previousLink,
                    nextLink: nextLink,
                    info: info,
                    fixedHeight: this.fixedHeight
                });
                this.$el.html(html);

                return this;
            },
            handleNext: function(event) {
                event.preventDefault(); 
                if (this.model) {
                    this.model.navigateToNext();
                }
            },
            handlePrevious: function(event) {
                event.preventDefault();
                if (this.model) {
                    this.model.navigateToPrevious();
                }
            },
            handleEndTour: function(event) {
                event.preventDefault();
                if (this.model) {
                    this.model.endTour();
                }
            }
        });
    }
);


define('splunkjs/mvc/headerview',['require','exports','module','./mvc','./basesplunkview','views/shared/splunkbar/Master','views/shared/appbar/Master','views/shared/litebar/Master','./sharedmodels','helpers/user_agent','views/shared/tourbar/TourBar','splunk.util','models/config','uri/route'],function (require, exports, module) {
    var mvc = require('./mvc'),
        BaseSplunkView = require("./basesplunkview"),
        GlobalNav = require('views/shared/splunkbar/Master'),
        AppNav = require('views/shared/appbar/Master'),
        SideNav = require('views/shared/litebar/Master'),
        sharedModels = require('./sharedmodels'),
        userAgent = require('helpers/user_agent'),
        TourBar = require('views/shared/tourbar/TourBar'),
        splunkUtils = require('splunk.util'),
        config = require('models/config'),
        route = require('uri/route');


    var HeaderView = BaseSplunkView.extend({
        moduleId: module.id,
        
        className: 'splunk-header',

        options: {
            appbar: true,
            splunkbar: true,
            acceleratedAppNav: false,
            useSessionStorageCache: false
        },

        initialize: function() {
            this.configure();
            this.model = this.model || {};
            this.model.application= sharedModels.get("app");
            this.model.user= sharedModels.get("user");
            this.model.appLocal= sharedModels.get("appLocal");
            this.model.serverInfo= sharedModels.get("serverInfo");
            
            var acceleratedAppNav = this.settings.get('acceleratedAppNav') && userAgent.isIE7();
            this.collection = this.collection || {};
            this.collection.appLocals = sharedModels.get("appLocals");
            this.deferreds = this.deferreds || {};
            this.initTour();
            this.useSideNav = this.settings.get('litebar');

            if (this.useSideNav) {
                this.sideNav = SideNav.create({
                    model: {
                        application: this.model.application,
                        appLocal: this.model.appLocal,
                        user: this.model.user,
                        serverInfo: this.model.serverInfo,
                        config: config
                    },
                    collection: {
                        apps: this.collection.appLocals
                    }
                });
            } else {
                if(this.settings.get('splunkbar')) {
                    this.globalNav = GlobalNav.create({
                        model: {
                            application: this.model.application,
                            appLocal: this.model.appLocal,
                            user: this.model.user,
                            serverInfo: this.model.serverInfo,
                            config: config
                        },
                        collection: {
                            apps: this.collection.appLocals
                        }
                    });
                }

                if(this.settings.get('appbar')){
                    this.appNav = AppNav.create({
                        model: {
                            application: this.model.application,
                            app: this.model.appLocal,
                            user: this.model.user,
                            serverInfo: this.model.serverInfo
                        },
                        appServerUrl: acceleratedAppNav,
                        useSessionStorageCache: this.settings.get('useSessionStorageCache'),
                        autoRender: false
                    });
                }
            }
        },
        initTour: function() {
            this.deferreds.tour = $.Deferred();

            // get the tour name from the query string
            this.tourName = undefined; 
            var queryProps = splunkUtils.queryStringToProp(window.location.search);
            if (queryProps.hasOwnProperty("tour")) {
                var tours = sharedModels.get("uiTours");
                this.tourName = queryProps["tour"];
                if (tours && this.tourName && this.tourName.length > 0) {

                    // when the collection has been fetched, grab the current tour stanza
                    tours.dfd.done(function() {
                        this.model.tour = tours.getTourModel(this.tourName);
                        if (this.model.tour) {
                            this.tourbar = new TourBar({
                                model: this.model.tour
                            });
                            this.model.tour.on("navigateRequest", function(destTourModel) {
                                var link = destTourModel.getUri(true);  
                                var path = "app/" + this.model.application.get("app") + "/" + link;
                                splunkUtils.redirect_to(path);
                            }, this);
                            this.model.tour.on("endTour", function() {
                                // route to home page
                                var path = route.home(this.model.application.get('root'),
                                                      this.model.application.get('locale'));
                                window.location.href = path;
                            }, this);
                            this.deferreds.tour.resolve();
                        }
                    }.bind(this));
                }
            }
        },
        render: function() {
            if (this.useSideNav) {
                this.$el.append(this.sideNav.render().el);
            } else {
                this.$el.empty();
                if (this.settings.get('splunkbar')) {
                    this.$el.append(this.globalNav.render().el);
                }
                if(this.settings.get('appbar')){
                    this.$el.append(this.appNav.render().el);
                }
            }
            if (this.tourName) {
                this.deferreds.tour.then(function(){
                    if (this.model.tour && this.tourbar) {
                        this.$el.append(this.tourbar.render().el);
                    }
                }.bind(this));
            }
            return this;
        }
    });

    return HeaderView;
});
